2013-01-22  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.12.1 Released.

	* Fix astcanary startup problem due to wrong pid value from before daemon
	  call

	  When Asterisk forks itself into the background via a call to daemon, it must
	  re-set the pid value of the new process. Otherwise, astcanary gets the pid
	  value of the process before the fork, which prevents it from running.
	  Asterisk eventually starts lowering its priority, as it can no longer
	  communicate with the proverbial canary in the coal mine.

	  This patch ensures that the correct process identifier is used by astcanary.

	  (closes issue ASTERISK-20947)
	  Reported by: Jakob Hirsch
	  Tested by: mjordan
	  patches:
	    asterisk-10.12.0.astcanary_ppid.diff uploaded by Jakob Hirsch (license 6113)

	* Update init.d scripts to handle stderr; readd splash screen for remote
	  consoles

	  When r376428 was commited to re-order start up sequences to be more tolerant
  	  of forking with thread primitives, a few items were changed that caused
	  changes in behavior on some distros. This includes:
	  
	  * Not displaying the splash screen on a remote console.
          * Displaying an error message on stderr when a remote console cannot
            connect to a running instance of Asterisk.

          In the first case, the splash screen was re-added (thanks to Michael L.
          Young).
          In the second case, the various init.d scripts were modified to pipe
          stderr to /dev/null, as the error message is useful - if you execute a
	  remote console or a remote console command execution and it fail, it
	  should tell you. Note that the error message was always present, it just
	  failed to be printed prior to r376428.

          Much thanks to the folks who quickly reported this problem, provided
          solutions, and promptly tested the various init.d scripts on a variety of
	  distros.

         (closes issue ASTERISK-20945)
         Reported by: Warren Selby
         Tested by: Michael L. Young, Jamuel Starkey, kaldemar, Danny Nicholas, mjordan
         patches:
           asterisk-20945-remote-intro-msg.diff uploaded by elguero (license 5026)
	   ASTERISK-20945-1.8-mjordan.diff uploaded by mjordan (license 6283)


	* Reset RTP timestamp; sequence number on SSRC change

	  In r370252 for ASTERISK-18404, Asterisk's handling of RTP was
	  modified to better account for out of order RTP packets. This was
	  accomplished by using the RTP timestamp and sequence number to check
	  for out of order packets. However, when a SSRC change occurs, the
	  timestamp and sequence number will no longer have any relation to the
	  previously received packets. The variables tracking the timestamp and
	  sequence number therefore have to be reset.

	  (closes issue ASTERISK-20906)
	  Reported by: Eelco Brolman
	  patches:
	    dtmf_on_hold.patch uploaded by Eelco Brolman (license #6442)

2013-01-14  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.12.0 Released.

	* Final non-security release of Asterisk 10. So long, and thanks for
	  all the T.38 gateway faxes!

2013-01-09  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.12.0-rc2 Released.

2013-01-08 23:55 +0000 [r378683-378689]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_queue.c: app_queue: Fix incorrect assertion. (issue
	  ASTERISK-16115)

	* /, configs/queues.conf.sample, UPGRADE.txt, CHANGES,
	  apps/app_queue.c: app_queue: Fix multiple calls to a queue member
	  that is in only one queue. When ringinuse=no queue members can
	  receive more than one call if these calls happen at nearly the
	  same time. * Fix so a queue member does not receive more than one
	  call from a queue. NOTE: This fix does not prevent multiple calls
	  to a member if the member is in more than one queue. * Did some
	  refactoring to eliminate some code redundancy. (issue
	  ASTERISK-16115) Reported by: nik600 Patches:
	  jira_asterisk_16115_single_q_v1.8.patch (license #5621) patch
	  uploaded by rmudgett Modified * Revert the -r341580 and -r341599
	  changes adding the queues.conf check_state_unknown option as it
	  was added in an attempt to fix this problem. The fix did not need
	  to be optional. The fix should not have tried to explicitly set
	  the device state. Setting the device state by something other
	  than the device introduces a race condition. I also could not see
	  how the change would be effective other than delaying the
	  app_queue code long enough for the device state to propagate to
	  app_queue. ........ Merged revisions 378663 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-02 17:40 +0000 [r378286-378320]  Matthew Jordan <mjordan@digium.com>

	* res/res_calendar.c, include/asterisk/devicestate.h,
	  channels/chan_local.c, /, main/ccss.c, channels/chan_sip.c,
	  apps/app_meetme.c, channels/chan_agent.c, main/devicestate.c,
	  include/asterisk/channel.h, res/res_jabber.c, apps/app_queue.c,
	  channels/chan_iax2.c, main/channel.c, channels/chan_dahdi.c,
	  channels/chan_skinny.c, include/asterisk/event_defs.h,
	  main/features.c, main/event.c, apps/app_confbridge.c,
	  apps/confbridge/conf_state_empty.c, funcs/func_devstate.c:
	  Prevent exhaustion of system resources through exploitation of
	  event cache Asterisk maintains an internal cache for devices in
	  the event subsystem. The device state cache holds the state of
	  each device known to Asterisk, such that consumers of device
	  state information can query for the last known state for a
	  particular device, even if it is not part of an active call. The
	  concept of a device in Asterisk can include entities that do not
	  have a physical representation. One way that this occurred was
	  when anonymous calls are allowed in Asterisk. A device was
	  automatically created and stored in the cache for each anonymous
	  call that occurred; this was possible in the SIP and IAX2 channel
	  drivers and through channel drivers that utilized the
	  res_jabber/res_xmpp resource modules (Gtalk, Jingle, and Motif).
	  These devices are never removed from the system, allowing
	  anonymous calls to potentially exhaust a system's resources. This
	  patch changes the event cache subsystem and device state
	  management to no longer cache devices that are not associated
	  with a physical entity. (issue ASTERISK-20175) Reported by:
	  Russell Bryant, Leif Madsen, Joshua Colp Tested by: kmoore
	  patches: event-cachability-3.diff uploaded by jcolp (license
	  5000) ........ Merged revisions 378303 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c, main/http.c, res/res_jabber.c,
	  channels/sip/include/sip.h: Resolve crashes due to large stack
	  allocations when using TCP Asterisk had several places where
	  messages received over various network transports may be copied
	  in a single stack allocation. In the case of TCP, since multiple
	  packets in a stream may be concatenated together, this can lead
	  to large allocations that overflow the stack. This patch modifies
	  those portions of Asterisk using TCP to either favor heap
	  allocations or use an upper bound to ensure that the stack will
	  not overflow: * For SIP, the allocation now has an upper limit *
	  For HTTP, the allocation is now a heap allocation instead of a
	  stack allocation * For XMPP (in res_jabber), the allocation has
	  been eliminated since it was unnecesary. Note that the HTTP
	  portion of this issue was independently found by Brandon Edwards
	  of Exodus Intelligence. (issue ASTERISK-20658) Reported by:
	  wdoekes, Brandon Edwards Tested by: mmichelson, wdoekes patches:
	  ASTERISK-20658_res_jabber.c.patch uploaded by mmichelson (license
	  5049) issueA20658_http_postvars_use_malloc2.patch uploaded by
	  wdoekes (license 5674) issueA20658_limit_sip_packet_size3.patch
	  uploaded by wdoekes (license 5674) ........ Merged revisions
	  378269 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-31 14:43 +0000 [r378218]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_sip.c: Ensure chan_sip rejects encrypted streams
	  without crypto info This ensures that Asterisk rejects encrypted
	  media streams (RTP/SAVP audio and video) that are missing
	  cryptographic keys and ensures that the incoming SDP is
	  consistent with RFC4568 as far as having a crypto attribute
	  present for any SAVP streams. Review:
	  https://reviewboard.asterisk.org/r/2204/ ........ Merged
	  revisions 378217 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-18 17:38 +0000 [r378120]  Kinsey Moore <kmoore@digium.com>

	* main/channel.c, /: Add test events for time limit-related hangups
	  This patch adds hangup-related test events in order to support
	  testing of time-limited bridges. This aids in testing the S() and
	  L() bridge options. (issue SWP-4713) ........ Merged revisions
	  378119 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-17 23:08 +0000 [r378089-378093]  Richard Mudgett <rmudgett@digium.com>

	* main/loader.c, /: Fix potential double free when unloading a
	  module. ........ Merged revisions 378092 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_local.c, /: Make chan_local module references tied
	  to local_pvt lifetime. The chan_local module references were
	  manually tied to the existence of the ;1 and ;2 channel links. *
	  Made chan_local module references tied to the existence of the
	  local_pvt structure as well as automatically take care of the
	  module references. * Tweaked the wording of the local_fixup()
	  failure warning message to make sense. Review:
	  https://reviewboard.asterisk.org/r/2181/ ........ Merged
	  revisions 378088 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-14 21:30 +0000 [r378037]  Richard Mudgett <rmudgett@digium.com>

	* /, apps/app_queue.c: app_queue: Revert bad ringinuse=no patch.
	  With the option ringinuse=no set, the patch committed for
	  ASTERISK-16115 causes non-SIP queue members to never be called
	  because the device state is checked after a channel is created to
	  determine if the member is busy. These queue members always get
	  the "Member %s is busy, cannot dial" message. Most channel
	  drivers other than chan_sip use the default device state
	  handling. The default device-state state is considered in use or
	  unknown if the channel exists or not respectively. (closes issue
	  ASTERISK-20801) Reported by: rmudgett Patches:
	  jira_asterisk_16115_revert_r370418_v1.8.patch (license #5621)
	  patch uploaded by rmudgett ........ Merged revisions 378036 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-13 20:52 +0000 [r377992]  Richard Mudgett <rmudgett@digium.com>

	* apps/confbridge/conf_state.c,
	  apps/confbridge/include/confbridge.h,
	  include/asterisk/bridging.h, apps/app_confbridge.c,
	  apps/confbridge/conf_state_multi_marked.c: confbridge: Fix MOH on
	  simultaneous user entry to a new conference. When two users
	  entered a new conference simultaneously, one of the callers hears
	  MOH. This happened if two unmarked users entered simultaneously
	  and also if a waitmarked and a marked user entered
	  simultaneously. * Created a confbridge internal MOH API to
	  eliminate the inlined MOH handling code. Note that the conference
	  mixing bridge needs to be locked when actually starting/stopping
	  MOH because there is a small window between the conference join
	  unsuspend MOH and actually joining the mixing bridge. * Created
	  the concept of suspended MOH so it can be interrupted while
	  conference join announcements to the user and DTMF features can
	  operate. * Suspend any MOH until the user is about to actually
	  join the mixing bridge of the conference. This way any pre-join
	  file playback does not need to worry about MOH. * Made post-join
	  actions only play deferred entry announcement files. Changing the
	  user/conference state during that time is not protected or
	  controlled by the state machine. (closes issue ASTERISK-20606)
	  Reported by: Eugenia Belova Tested by: rmudgett Review:
	  https://reviewboard.asterisk.org/r/2232/

2012-12-13 13:48 +0000 [r377947]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_sip.c: Ensure Min-SE is included in outbound
	  INVITEs Asterisk now includes Min-SE in outbound INVITEs when the
	  value is not 90 (the default) and session timers are not
	  disabled. This has the effect of Asterisk following RFC4028 more
	  closely with regard to 422 responses and preventing situations in
	  which Asterisk would be forced to temporarily accept a call to
	  tear it down based on a Session-Expires below the locally
	  configured Min-SE. (issue SWP-5051) Review:
	  https://reviewboard.asterisk.org/r/2222/ Reported-by: Kinsey
	  Moore Patch-by: Kinsey Moore ........ Merged revisions 377946
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-12 22:41 +0000 [r377923]  Rusty Newton <rnewton@digium.com>

	* /, sounds/Makefile: Incremented EXTRA_SOUNDS_VERSION in
	  sounds/Makefile to 1.4.12 for new Extra Sounds releases See
	  CHANGES-* files in English extra 1.4.12 tarballs for new sound
	  prompts added. (closes ASTERISK-20328) Reported by: Matt Jordan
	  (closes AST-755) Reported by: John Bigelow ........ Merged
	  revisions 377922 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-11 21:57 +0000 [r377848-377882]  Richard Mudgett <rmudgett@digium.com>

	* main/timing.c, main/channel.c, main/data.c, main/stun.c, /,
	  main/file.c, main/http.c, main/aoc.c, main/image.c, main/cel.c:
	  Cleanup CLI commands on exit for several files. (issue
	  ASTERISK-20649) Reported by: Corey Farrell Patches:
	  unregister-cli-multiple-all.patch (license #5909) patch uploaded
	  by Corey Farrell ........ Merged revisions 377881 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/udptl.c, /: Cleanup udptl on exit. * Cleanup CLI commands on
	  exit. (issue ASTERISK-20649) Reported by: Corey Farrell Patches:
	  udptl-shutdown-1_8-10.patch (license #5909) patch uploaded by
	  Corey Farrell udptl-shutdown-11-trunk.patch (license #5909) patch
	  uploaded by Corey Farrell Modified ........ Merged revisions
	  377847 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-11 20:48 +0000 [r377842]  Mark Michelson <mmichelson@digium.com>

	* res/res_clialiases.c, /: Fix crash that can occur if CLI
	  registration fails for an aliased command. A recent memory leak
	  fix in main/cli.c causes an ast_cli_entry's command field to be
	  freed and NULLed if ast_cli_register() fails. res_clialiases was
	  ignoring the return value of ast_cli_register() and was then
	  passing the NULL command off to a a hash function. This resulted
	  in a crash. The fix is not to ignore the erroneous return value.
	  If ast_cli_register() fails, then we do not continue trying to
	  process the current alias. ........ Merged revisions 377840 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-11 20:42 +0000 [r377705-377838]  Richard Mudgett <rmudgett@digium.com>

	* /, main/taskprocessor.c: Cleanup taskprocessor on exit. * Cleanup
	  CLI commands on exit. * v10 only: Merged v1.8 -r374177 change to
	  taskprocessor.c missed in v10 -r374178. (issue ASTERISK-20649)
	  Reported by: Corey Farrell Patches:
	  taskprocessor-cleanup-1_8-11-trunk.patch (license #5909) patch
	  uploaded by Corey Farrell taskprocessor-cleanup-10-only.patch
	  (license #5909) patch uploaded by Corey Farrell Modified ........
	  Merged revisions 377837 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/pbx.c, /: Cleanup pbx on exit. * Cleanup CLI commands on
	  exit. * Unreference hints and statecbs containers on exit. (issue
	  ASTERISK-20649) Reported by: Corey Farrell Patches:
	  pbx-cleanup-1_8.patch (license #5909) patch uploaded by Corey
	  Farrell pbx-cleanup-10.patch (license #5909) patch uploaded by
	  Corey Farrell pbx-cleanup-11-trunk.patch (license #5909) patch
	  uploaded by Corey Farrell Modified ........ Merged revisions
	  377806 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/logger.c: Cleanup logger on exit. * Cleanup CLI commands,
	  destroy verbosers and logchannels lists on exit. (issue
	  ASTERISK-20649) Reported by: Corey Farrell Patches:
	  logger-cleanup-all.patch (license #5909) patch uploaded by Corey
	  Farrell Modified ........ Merged revisions 377771 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/indications.c: Cleanup indications on exit. * Made
	  ast_unregister_indication_country() unlink the found tone zone
	  before selecting a new default_tone_zone to make it impossible to
	  select the tone zone being unregistered again. * Ringcadence is
	  no longer parsed twice in store_config_tone_zone(). * Cleanup CLI
	  commands and destroy default_tone_zone on exit. (issue
	  ASTERISK-20649) Reported by: Corey Farrell Patches:
	  indications-cleanup-all.patch (license #5909) patch uploaded by
	  Corey Farrell Modified ........ Merged revisions 377740 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/event.c: Cleanup event on exit. * Cleanup CLI commands on
	  exit. * v10 only: Merged v1.8 -r374177 change to event.c missed
	  in v10 -r374178. (issue ASTERISK-20649) Reported by: Corey
	  Farrell Patches: event_shutdown-10-only.patch (license #5909)
	  patch uploaded by Corey Farrell event_shutdown-1_8-11-trunk.patch
	  (license #5909) patch uploaded by Corey Farrell ........ Merged
	  revisions 377708 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/dnsmgr.c, /: Cleanup dnsmgr on exit. * Cleanup dnsmgr thread
	  and CLI commands on exit. (issue ASTERISK-20649) Reported by:
	  Corey Farrell Patches: dnsmgr-cleanup-1_8.patch (license #5909)
	  patch uploaded by Corey Farrell dnsmgr-cleanup-10-11-trunk.patch
	  (license #5909) patch uploaded by Corey Farrell Modified ........
	  Merged revisions 377704 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-10 16:53 +0000 [r377624-377656]  Kinsey Moore <kmoore@digium.com>

	* /, res/res_fax.c: Ensure ReceiveFax provides a CED tone via T.38
	  When using res_fax_digium, the T.38 CED tone was not being
	  provided properly which would cause some incoming faxes to fail.
	  This was not an issue with res_fax_spandsp since it does not
	  strictly honor the send_ced flag and sends the CED tone whenever
	  receiving a T.38 fax. (closes issue FAX-343) Reported-by:
	  Benjamin Tietz Patch-by: Kinsey Moore ........ Merged revisions
	  377655 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Handle Session-Expires less than local
	  Min-SE in 200 OK Ensure that a call is immediately torn down if a
	  Session-Expires value received in a 200 OK is less than the local
	  Min-SE. This also prevents Asterisk from allowing calls with
	  Session-Expires below the RFC4028-mandated minimum (90s). (closes
	  issue ASTERISK-20653) Review:
	  https://reviewboard.asterisk.org/r/2237/ Patch-by: Kinsey Moore
	  ........ Merged revisions 377623 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-10 06:41 +0000 [r377558-377592]  Igor Goncharovskiy <igor.goncharovsky@gmail.com>

	* channels/chan_unistim.c, /: Fix codec mismatch Fix code to send
	  in both rx and tx open stream messages correct codecs. Found that
	  on phase 0/1 phones wrong codecs cause to no audio in some
	  situations. (issue ASTERISK-20183) ........ Merged revisions
	  377591 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_unistim.c, /: Fix crash on transfer initiated from
	  insreeen menu on Unistim phones. Removed CDR-related code that
	  moved to do_masquarade before. (closes issue ASTERISK-20417)
	  Reported by: Rudolf Migalin ........ Merged revisions 377557 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-10  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.12.0-rc1 Released.

2012-12-10 01:39 +0000 [r377504-377510]  Tilghman Lesher <tilghman@meg.abyt.es>

	* main/xmldoc.c, /: Improve documentation by making all of the
	  colors used readable, no matter what the background color is.
	  Dark blue on a black background is unreadable, as is yellow on a
	  light background. This patch turns on the bright attribute for
	  colors when on a dark background and turns *off* the bright
	  attribute when the -W command line option is used (indicating a
	  _light_ background). This ensures that text is readable in both
	  cases. Patch by: tilghman Review:
	  https://reviewboard.asterisk.org/r/2224 ........ Merged revisions
	  377509 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, addons/cdr_mysql.c: Remove some dead code and additionally
	  handle a case that wasn't handled. ........ Merged revisions
	  377487 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-08 00:29 +0000 [r377399-377432]  Richard Mudgett <rmudgett@digium.com>

	* contrib/realtime/mysql/sippeers.sql, /: Fix order of SIP
	  allow/disallow in MySQL contrib script. Using the contrib
	  sippeers.sql script to create the sippeers MySQL table would
	  result in being unable to place calls if you set the disallow
	  value to all. (closes issue ASTERISK-20756) Reported by: Andre
	  Luis Patches: sippeers.patch patch uploaded by Andre Luis
	  ........ Merged revisions 377431 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/astmm.c: MALLOC_DEBUG: Only wait if we want atexit
	  allocation dumps. ........ Merged revisions 377398 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-07 21:58 +0000 [r377382]  Kinsey Moore <kmoore@digium.com>

	* codecs/codec_dahdi.c: codec_dahdi: Fix output of "transcoder
	  show" CLI command. In r306010 "Asterisk media architecture
	  conversion - no more format bitfields", the logic for
	  incrementing encoders and decoders when opening transcoder
	  channels was changed without making the corresponding change when
	  decrementing encoder / decoder channels. The result being that
	  when a channel was destroyed, codec_dahdi couldn't properly tell
	  if it was an encoder or decoder, and the default case is to
	  assume it was a decoder. This could result in negative numbers
	  for decoders in use like in: VOIP6*CLI> transcoder show 2/-2
	  encoders/decoders of 92 channels are in use. (closes issue
	  ASTERISK-19921) Patch-by: Shaun Ruffell

2012-12-06 23:56 +0000 [r377354]  Richard Mudgett <rmudgett@digium.com>

	* apps/confbridge/conf_config_parser.c, apps/app_confbridge.c:
	  confbridge: Fix some resource leaks on conference teardown. *
	  Made destroy_conference_bridge() destroy a missed ast_mutex_t and
	  ast_cond_t. * Made join_conference_bridge() init the
	  ast_mutex_t's and ast_cond_t so destroy_conference_bridge() can
	  destroy them unconditionally. * Made join_conference_bridge()
	  abort if the new conference could not be added to the conferences
	  container. * Made leave_conference() discard any post-join
	  actions if join_conference_bridge() had to abort early. * Made
	  the join_conference_bridge() diagnostic messages better describe
	  what happened. * Renamed leave_conference_bridge() to
	  leave_conference() and made it only take a conference user
	  pointer. The conference pointer was redundant. * Made
	  conf_bridge_profile_copy() use struct copy instead of memcpy(). *
	  No need to lock the conference in start_conf_record_thread()
	  since all of the callers already have it locked.

2012-12-05 16:57 +0000 [r377261]  Jonathan Rose <jrose@digium.com>

	* res/res_srtp.c, /: res_srtp: Fix a crash caused by srtp_dealloc
	  on an already dealloced session When srtp_create fails, the
	  session may be dealloced or just not alloced. At the same time
	  though, the session pointer might not be set to NULL in this
	  process and attempting to srtp_dealloc it again will cause a
	  segfault. This patch checks for failure of srtp_create and sets
	  the session pointer to NULL if it fails. (closes issue
	  ASTERISK-20499) Reported by: tootai Review:
	  https://reviewboard.asterisk.org/r/2228/ ........ Merged
	  revisions 377256 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-05 16:49 +0000 [r377258]  Joshua Colp <jcolp@digium.com>

	* /, channels/chan_sip.c: Fix a SIP request memory leak with TLS
	  connections. During the TLS re-work in chan_sip some TLS specific
	  code was moved into a separate function. This function operates
	  on a copy of the incoming SIP request. This copy was never
	  deinitialized causing a memory leak for each request processed.
	  This function is now given a SIP request structure which it can
	  use to copy the incoming request into. This reduces the amount of
	  memory allocations done since the internal allocated components
	  are reused between packets and also ensures the SIP request
	  structure is deinitialized when the TLS connection is torn down.
	  (closes issue ASTERISK-20763) Reported by: deti ........ Merged
	  revisions 377257 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-05 02:09 +0000 [r377038-377241]  Richard Mudgett <rmudgett@digium.com>

	* main/format.c: * Fix registering core show codecs/codec CLI
	  commands twice. * Fix registering atexit format_attr_shutdown()
	  more than once.

	* apps/confbridge/conf_config_parser.c: confbridge: Fix several
	  small issues. * Made func_confbridge_helper() allow an empty
	  value when setting options. You previously could not
	  Set(CONFBRIDGE(user,pin)=) and clear the configured pin from the
	  dialplan. * Made func_confbridge_helper() handle its datastore
	  better if multiple threads attempt to set the first CONFBRIDGE
	  option value on the channel. * Made the func_confbridge_helper()
	  only output one diagnostic message concerning the option. * Made
	  the bridge video_mode able to repeatedly change in the config
	  file and CONFBRIDGE dialplan function. The video_mode option
	  values are an enum and not independent of each other. * Made
	  handle_cli_confbridge_show_bridge_profile() better handle the
	  video_mode option. * Simplified datastore handling code in
	  conf_find_user_profile() and conf_find_bridge_profile(). * Made
	  parse_bridge(), parse_user(), and parse_menu() use var->file
	  instead of CONFBRIDGE_CONFIG because the var could have been from
	  an include file. (closes issue ASTERISK-20655) Reported by:
	  Birger "WIMPy" Harzenetter

	* apps/app_confbridge.c: confbridge: Update online XML
	  documentation.

	* /, main/asterisk.c: Cleanup ast_run_atexits() atexits list. *
	  Convert atexits list to a mutex instead of a rd/wr lock. The lock
	  is only write locked. * Move CLI verbose Asterisk ending message
	  to where AMI message is output in really_quit() to avoid further
	  surprises about using stuff already shutdown. (issue
	  ASTERISK-20649) Reported by: Corey Farrell ........ Merged
	  revisions 377165 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, include/asterisk/_private.h, main/stdtime/localtime.c,
	  main/asterisk.c: Cleanup core main on exit. * Cleanup time zones
	  on exit. * Make exit clean/unclean report consistent for AMI and
	  CLI in really_quit(). (issue ASTERISK-20649) Reported by: Corey
	  Farrell Patches: core-cleanup-1_8-10.patch (license #5909) patch
	  uploaded by Corey Farrell core-cleanup-11-trunk.patch (license
	  #5909) patch uploaded by Corey Farrell Modified ........ Merged
	  revisions 377135 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/config.c: Cleanup config cache on exit. (issue
	  ASTERISK-20649) Reported by: Corey Farrell Patches:
	  config-cleanup-all.patch (license #5909) patch uploaded by Corey
	  Farrell ........ Merged revisions 377104 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/cli.c, /: Cleanup CLI resources on exit and CLI command
	  registration errors. (issue ASTERISK-20649) Reported by: Corey
	  Farrell Patches: cli-leaks-1_8-10.patch (license #5909) patch
	  uploaded by Corey Farrell cli-leaks-11-trunk.patch (license
	  #5909) patch uploaded by Corey Farrell Modified ........ Merged
	  revisions 377073 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/cdr.c, /: Cleanup CDR resources on exit. * Simplify
	  do_reload() return handling since it never returned anything
	  other than 0. (issue ASTERISK-20649) Reported by: Corey Farrell
	  Patches: cdr-cleanup-1_8.patch (license #5909) patch uploaded by
	  Corey Farrell cdr-cleanup-10-11-trunk.patch (license #5909) patch
	  uploaded by Corey Farrell Modified ........ Merged revisions
	  377069 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/ccss.c: Fix CCSS CLI commands and logger level not
	  unregistered. (issue ASTERISK-20649) Reported by: Corey Farrell
	  Patches: ccss-cleanup-all.patch (license #5909) patch uploaded by
	  Corey Farrell ........ Merged revisions 377037 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-30 21:33 +0000 [r376951]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/misdn/isdn_lib.c: chan_misdn: Fix sending
	  RELEASE_COMPLETE in response to SETUP. Fix sending a
	  RELEASE_COMPLETE in response to a SETUP if chan_misdn does not
	  have a B channel available to assign to the call. (closes issue
	  ABE-2869) Reported by: Guenther Kelleter Patches:
	  setup-reject_2.diff (license #6372) patch uploaded by Guenther
	  Kelleter Modified ........ Merged revision 376949 from
	  https://origsvn.digium.com/svn/asterisk/be/branches/C.3-bier
	  ........ Merged revisions 376950 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-30 17:06 +0000 [r376920]  Sean Bright <sean@malleable.com>

	* /, funcs/func_volume.c: Minor spelling fix to the VOLUME
	  documentation. ........ Merged revisions 376919 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-30 16:23 +0000 [r376916]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Fix potential crashes during SIP attended
	  transfers. The principal behind this patch is simple. During a
	  transfer, we manipulate channels that are owned by a separate
	  thread than the one we currently are running in, so it makes
	  sense that we need to grab a reference to the channels so that
	  they cannot disappear out from under us. In the wild, crashes
	  were sometimes seen when the transferring party would hang up the
	  call before the transfer target answered the call. The most
	  common place to see the crash occur was when attempting to send a
	  connected line update to the transferer channel. (closes issue
	  ASTERISK-20226) Reported by Jared Smith Patches:
	  ASTERISK-20226.patch uploaded by Mark Michelson (License #5049)
	  Tested by: Jared Smith ........ Merged revisions 376901 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-29 22:58 +0000 [r376865-376869]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_local.c, /: chan_local: Fix local_pvt ref leak in
	  local_devicestate(). Regression introduced by ASTERISK-20390 fix.
	  (closes issue ASTERISK-20769) Reported by: rmudgett Tested by:
	  rmudgett ........ Merged revisions 376868 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Fix compile error. (issue ASTERISK-20724)
	  ........ Merged revisions 376864 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-29 21:51 +0000 [r376835]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_sip.c: Improve Code Readability And Fix Setting
	  natdetected Flag For 1.8, 10, 11 and trunk we are are improving
	  the code readability. For 11 and trunk, auto nat detection was
	  added. The natdetected flag was being set to 1 when the host
	  address in the VIA header did not specifiy a port. This patch
	  fixes this by setting the port on the temporary sock address used
	  to SIP_STANDARD_PORT in order for the sock address comparison to
	  work properly. (closes issue ASTERISK-20724) Reported by: Michael
	  L. Young Patches: asterisk-20724-set-port-v2.diff uploaded by
	  Michael L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2206/ ........ Merged
	  revisions 376834 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-29 00:45 +0000 [r376759-376789]  Richard Mudgett <rmudgett@digium.com>

	* /, main/astmm.c, main/asterisk.c: Add MALLOC_DEBUG atexit
	  unreleased malloc memory summary. * Adds the following CLI
	  commands to control MALLOC_DEBUG reporting of unreleased malloc
	  memory when Asterisk is shut down. memory atexit list on memory
	  atexit list off memory atexit summary byline memory atexit
	  summary byfunc memory atexit summary byfile memory atexit summary
	  off * Made check all remaining allocated region blocks atexit for
	  fence violations. * Increased the allocated region hash table
	  size by about three times. It still isn't large enough
	  considering the number of malloced blocks Asterisk uses. * Made
	  CLI "memory show allocations anomalies" use
	  regions_check_all_fences(). Review:
	  https://reviewboard.asterisk.org/r/2196/ ........ Merged
	  revisions 376788 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/astmm.c: Enhance MALLOC_DEBUG CLI commands. * Fixed CLI
	  "memory show allocations" misspelling of anomalies option. The
	  command will still accept the original misspelling. *
	  Miscellaneous tweaks to CLI "memory show allocations" command
	  output format. * Made CLI "memory show summary" summarize by line
	  number instead of by function if a filename is given. * Made CLI
	  "memory show summary" sort its output by filename or
	  function-name/line-number depending upon request. * Miscellaneous
	  tweaks to CLI "memory show summary" command output format.
	  ........ Merged revisions 376758 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-28 16:30 +0000 [r376726]  Jonathan Rose <jrose@digium.com>

	* main/manager.c, /: manager: Make challenge work with
	  allowmultiplelogin=no Prior to this patch, challenge would yield
	  a multiple logins error if used without providing the username
	  (which isn't really supposed to be an argument to challenge) if
	  allowmultiplelogin was set to no because allowmultiplelogin finds
	  a user with a zero length login name. This check is simply
	  disabled for the challenge action when the username is empty by
	  this patch. (closes issue ASTERISK-20677) Reported by: Vladimir
	  Patches: challenge_action_nomultiplelogin.diff uploaded by
	  Jonathan Rose (license 6182) ........ Merged revisions 376725
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-27 23:58 +0000 [r376628-376689]  Richard Mudgett <rmudgett@digium.com>

	* main/pbx.c, /, UPGRADE.txt: Fix extension matching with the '-'
	  char. The '-' char is supposed to be ignored by the dialplan
	  extension matching. Unfortunately, it's treatment is not handled
	  consistently throughout the extension matching code. * Made the
	  old exten matching code consistently ignore '-' chars. * Made the
	  old exten matching code consistently handle case in the matching.
	  * Made ignore empty character sets. * Fixed ast_extension_cmp()
	  to return -1, 0, or 1 as documented. The only user of it in
	  pbx_lua.c was testing for -1. It was originally returning the
	  strcmp() value for less than which is not usually going to be -1.
	  * Fix character set sorting if the sets have the same number of
	  characters and start with the same character. Character set [0-9]
	  now sorts before [02-9a] as originally intended. * Updated some
	  extension label and priority already in use warnings to also
	  indicate if the extension is aliased. (closes issue
	  ASTERISK-19205) Reported by: Philippe Lindheimer, Birger "WIMPy"
	  Harzenetter Tested by: rmudgett Review:
	  https://reviewboard.asterisk.org/r/2201/ ........ Merged
	  revisions 376688 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* addons/res_config_mysql.c, /, apps/app_celgenuserevent.c,
	  pbx/pbx_dundi.c: Remove unnecessary channel module references. *
	  Removed call to ast_module_user_hangup_all() in
	  res_config_mysql.c since it is effectively a noop. No channels
	  can attach a reference to that module. * Removed call to
	  ast_module_user_hangup_all() in app_celgenuserevent.c. The caller
	  of unload_module() has already called it. * Removed redundant
	  channel module references in pbx_dundi.c. The registered dialplan
	  function callback dispatchers for the read/read2/write callbacks
	  already reference the module before calling. * pbx_dundi: Moved
	  unregistering CLI commands, DUNDi switch, and dialplan functions
	  to the first thing the unload_module() does. This will reduce the
	  chance of new channels using DUNDi services while the module is
	  being torn down. ........ Merged revisions 376657 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, include/asterisk/linkedlists.h: Made AST_LIST_REMOVE() simpler
	  and use better names. * Update doxygen of AST_LIST_REMOVE().
	  ........ Merged revisions 376627 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-22 23:56 +0000 [r376587]  Matthew Jordan <mjordan@digium.com>

	* main/lock.c, /, main/logger.c, include/asterisk/lock.h:
	  Re-initialize logmsgs mutex upon logger initialization to prevent
	  lock errors Similar to the patch that moved the fork earlier in
	  the startup sequence to prevent mutex errors in the recursive
	  mutex surrounding the read/write thread registration lock, this
	  patch re-initializes the logmsgs mutex. Part of the start up
	  sequence before forking the process into the background includes
	  reading asterisk.conf; this has to occur prior to the call to
	  daemon in order to read startup parameters. When reading in a
	  conf file, log statements can be generated. Since this can't be
	  avoided, the mutex instead is re-initialized to ensure a reset of
	  any thread tracking information. This patch also includes some
	  additional debugging to catch errors when locking or unlocking
	  the recursive mutex that surrounds locks when the DEBUG_THREADS
	  build option is enabled. DO_CRASH or THREAD_CRASH will cause an
	  abort() if a mutex error is detected. (issue ASTERISK-19463)
	  Reported by: mjordan Tesetd by: mjordan ........ Merged revisions
	  376586 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-20 17:01 +0000 [r376522]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c, channels/sip/include/sip.h: Add "Require:
	  timer" to 200 OK responses when appropriate. The method by which
	  the Require header is added to 200 responses is inspired by the
	  method that Olle Johansson uses in his darjeeling-prack branch.
	  (closes issue ASTERISK-20570) Reported by Matt Jordan, at the
	  behest of Olle Johansson Review:
	  https://reviewboard.asterisk.org/r/2172 ........ Merged revisions
	  376521 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-19 19:44 +0000 [r376470]  Walter Doekes <walter+asterisk@wjd.nu>

	* /, channels/chan_sip.c, main/security_events.c,
	  main/indications.c: Fix most leftover non-opaque ast_str uses.
	  Instead of calling str->str, one should use ast_str_buffer(str).
	  Same goes for str->used as ast_str_strlen(str) and str->len as
	  ast_str_size(str). Review:
	  https://reviewboard.asterisk.org/r/2198 ........ Merged revisions
	  376469 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-18 20:18 +0000 [r376414-376431]  Matthew Jordan <mjordan@digium.com>

	* /, main/utils.c, main/stdtime/localtime.c, main/asterisk.c:
	  Reorder startup sequence to prevent lockups when process is sent
	  to background Although it is very rare and timing dependent, the
	  potential exists for the call to 'daemon' to cause what appears
	  to be a deadlock in Asterisk during startup. This can occur when
	  a recursive mutex is obtained prior to the daemon call executing.
	  Since daemon uses fork to send the process into the background,
	  any threading primitives are unsafe to re-use after the call.
	  Implementations of pthread recursive mutexes are highly likely to
	  store the thread identifier of the thread that previously
	  obtained the mutex. If the mutex was locked prior to the fork, a
	  subsequent unlock operation will potentially fail as the thread
	  identifier is no longer valid. Since the mutex is still locked,
	  all subsequent attempts to grab the mutex by other threads will
	  block. This behavior exhibited itself most often when
	  DEBUG_THREADS was enabled, as this compile time option surrounds
	  the mutexes in Asterisk with another recursive mutex that
	  protects the storage of thread related information. This made it
	  much more likely that a recursive mutex would be obtained prior
	  to daemon and unlocked after the call. This patch does the
	  following: a) It backports a patch from Asterisk 11 that prevents
	  the spawning of the localtime monitoring thread. This thread is
	  now spawned after Asterisk has fully booted. b) It re-orders the
	  startup sequence to call daemon earlier during Asterisk startup.
	  This limits the potential of threading primitives being accessed
	  by initialization calls before daemon is called. c) It removes
	  calls to ast_verbose/ast_log/etc. prior to daemon being called.
	  Developers should send error messages directly to stderr prior to
	  daemon, as calls to ast_log may access recursive mutexes that
	  store thread related information. d) It reorganizes when thread
	  local storage is created for storing lock information during the
	  creation of threads. Prior to this patch, the read/write lock
	  protecting the list of threads in ast_register_thread would
	  utilize the lock in the thread local storage prior to it being
	  initialized; this patch prevents that. On a very related note,
	  this patch will *greatly* improve the stability of the Asterisk
	  Test Suite. Review: https://reviewboard.asterisk.org/r/2197
	  (closes issue ASTERISK-19463) Reported by: mjordan Tested by:
	  mjordan ........ Merged revisions 376428 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/confbridge/conf_state.c: Add a test event that reports
	  changes in ConfBridge state This patch adds a test event to
	  ConfBridge that reports transitions between states in ConfBridge.
	  This is used by tests in the Asterisk Test Suite that verify
	  state changes based on the entering/leaving of conference
	  participants.

2012-11-16 19:41 +0000 [r376390]  Jonathan Rose <jrose@digium.com>

	* /, res/res_monitor.c: monitor: prevent attempts to move/remove
	  recordings skipped with 'i' and 'o'. The i and o options for
	  monitor skip the input and output sides of a recording
	  respectively. This patch addresses a problem in those options
	  when monitor is called without specifying a specific filename
	  where monitor will try to move the recording that was skipped.
	  Since this usually doesn't exist when these options are used, it
	  would produce a warning when it does this in most cases, but it
	  is conceivable that there are use cases where this could result
	  in moving/removing a file unintentionally. (closes issue
	  ASTERISK-20641) Reported by: Jonathan Rose Review:
	  https://reviewboard.asterisk.org/r/2190/ ........ Merged
	  revisions 376389 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-16 00:08 +0000 [r376315-376342]  David M. Lee <dlee@digium.com>

	* /, utils/extconf.c: Fixed extconf.c breakage introduced in
	  r376306. To quote wdoekes: > Note that I'm not confirming
	  legitimacy of having that file in tree at > all. Is anyone using
	  aelparse/conf2ael? ........ Merged revisions 376340 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* utils/Makefile, tests/test_astobj2_thrash.c (added),
	  utils/utils.xml, /, utils/hashtest.c (removed),
	  tests/test_hashtab_thrash.c (added), utils/hashtest2.c (removed),
	  include/asterisk/hashtab.h: Migrate hashtest/hashtest2 to be unit
	  tests. Both hashtest and hashtest2 are manual testing apps that
	  thrash hash tables (hashtab and ao2 containers, respectively), by
	  spinning up several threads that randomly insert, delete, lookup
	  and iterate over the hash table. If the app doesn't crash, the
	  hash table probably passes the test. Those utils are not a part
	  of the typical Asterisk build, so they do not usually get
	  compiled. This all makes them less that useful. This patch
	  removes those manual test programs and replaces them with
	  Asterisk unit test modules (test_{hashtab,astobj2}_thrash.so). It
	  also attempts to make the tests more deterministic. * Rather than
	  spinning up some number of threads that operate on the hash table
	  randomly, spin up four threads that concurrenly add, remove,
	  lookup and iterate over the hash table. * Each thread checks the
	  state of the hash table both during and after execution, and
	  indicates a test failure if things are not as expected. * Each
	  thread times out after 60 seconds to prevent deadlocking the unit
	  test run. (closes issue ASTERISK-20505) Reported by: Matt Jordan
	  Review: https://reviewboard.asterisk.org/r/2189/ ........ Merged
	  revisions 376306 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-15 22:55 +0000 [r376308]  Jonathan Rose <jrose@digium.com>

	* /, apps/app_meetme.c: app_meetme: Fix channels lingering when
	  hung up under certain conditions Channels would get stuck and
	  MeetMe would repeatedly display an Unable to write frame to
	  channel error in the conf_run function if hung up during certain
	  sound prompts such as during user count announcements. This patch
	  fixes that by reintroducing a hangup check in the meetme's main
	  loop (also in conf_run). (closes issue ASTERISK-20486) Reported
	  by: Michael Cargile Review:
	  https://reviewboard.asterisk.org/r/2187/ Patches:
	  meetme_hangup_patch_ASTERISK-20486_v3.diff uploaded by Jonathan
	  Rose (license 6182) ........ Merged revisions 376307 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-15 01:50 +0000 [r376263]  Rusty Newton <rnewton@digium.com>

	* apps/app_voicemail.c, /: Patch to play correct sound file when a
	  voicemail's urgent status is removed We were attempting to play
	  "vm-urgent-removed", which didn't exist. Now we play
	  "vm-marked-nonurgent" which exists and is the correct sound file.
	  Previous behavior was silence and a warning on the CLI. (issue
	  ASTERISK-20280) (closes issue ASTERISK-20280) Reported by: Tomo
	  Takebe Tested by: Rusty Newton Patches: asterisk20280.patch
	  uploaded by Rusty Newton (license 5829) ........ Merged revisions
	  376262 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-14 19:50 +0000 [r376233]  Richard Mudgett <rmudgett@digium.com>

	* pbx/pbx_spool.c, /: Fix call files when astspooldir is relative.
	  Future dated call files are ignored when astspooldir is relative
	  to the current directory. The queue_file() assumed that the qdir
	  needed to be prepended if the given filename did not start with a
	  '/'. If astspooldir is relative it is not going to start from the
	  root directory obviously so it will not start with a '/'. The
	  filename used in queue_file() ultimately results in qdir
	  prepended multiple times. * Made queue_file() not prepend qdir if
	  the filename contains a '/'. (closes issue ASTERISK-20593)
	  Reported by: James Le Cuirot Patches:
	  0004-Fix-future-call-files-from-relative-directories.patch
	  (license #6439) patch uploaded by James Le Cuirot ........ Merged
	  revisions 376232 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-13 18:20 +0000 [r376208]  Brent Eagles <beagles@digium.com>

	* main/channel.c, /: Patch to prevent stopping the active generator
	  when it is not the silence generator. This patch introduces an
	  internal helper function to safely check whether the current
	  generator is the one that is expected before deactivating it. The
	  current externally accessible ast_channel_stop_generator()
	  function has been modified to be implemented in terms of the new
	  function. (closes issue ASTERISK-19918) Reported by: Eduardo Abad
	  ........ Merged revisions 376199 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-12 20:44 +0000 [r376167]  Joshua Colp <jcolp@digium.com>

	* main/pbx.c, /: Properly check if the "Context" and "Extension"
	  headers are empty in a ShowDialPlan action. The code which
	  handles the ShowDialPlan action wrongly assumed that a non-NULL
	  return value from the function which retrieves headers from an
	  action indicates that the header has a value. This is incorrect
	  and the contents must be checked to see if they are blank.
	  (closes issue ASTERISK-20628) Reported by: jkroon Patches:
	  asterisk-showdialplan-incorrect-error.patch uploaded by jkroon
	  ........ Merged revisions 376166 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-12 20:15 +0000 [r376143]  Michael L. Young <elgueromexicano@gmail.com>

	* main/pbx.c, /: Fix Dynamic Hints Variable Substition - Underscore
	  Problem When adding a dynamic hint, if an extension contains an
	  underscore no variable subsitution is being performed. This patch
	  changes from checking if the extension contains an underscore to
	  checking if the extension begins with an underscore. (closes
	  issue ASTERISK-20639) Reported by: Steven T. Wheeler Tested by:
	  Steven T. Wheeler, Michael L. Young Patches:
	  asterisk-20639-dynamic-hint-underscore.diff uploaded by Michael
	  L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2188/ ........ Merged
	  revisions 376142 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-08 21:59 +0000 [r376088]  Mark Michelson <mmichelson@digium.com>

	* /, res/res_fax.c: Fix a "set but not used" warning on newer gccs.
	  Turns out the "helpful" setting of ms and res in this macro is
	  completely useless after the timeout antipattern fix. If you're a
	  new guy looking to write code, don't write a macro like this one.
	  ........ Merged revisions 376087 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-08 21:07 +0000 [r376030-376059]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/sig_ss7.c: chan_dahdi/SS7: Made reject incoming call
	  for an in-alarm or blocked channel. If a SS7 call comes in
	  requesting a CIC that is in-alarm, the call is accepted and
	  connects if the extension exists in the dialplan. The call does
	  not have any audio. * Made release the call immediately with
	  circuit congestion cause. (closes issue ASTERISK-20204) Reported
	  by: Tuan Le Patches: jira_asterisk_20204_v1.8.patch (license
	  #5621) patch uploaded by rmudgett ........ Merged revisions
	  376058 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* include/asterisk/utils.h, include/asterisk/astmm.h, /,
	  main/utils.c, main/astmm.c, main/asterisk.c: Add MALLOC_DEBUG
	  enhancements. * Makes malloc() behave like calloc(). It will
	  return a memory block filled with 0x55. A nonzero value. * Makes
	  free() fill the released memory block and boundary fence's with
	  0xdeaddead. Any pointer use after free is going to have a pointer
	  pointing to 0xdeaddead. The 0xdeaddead pointer is usually an
	  invalid memory address so a crash is expected. * Puts the freed
	  memory block into a circular array so it is not reused
	  immediately. * When the circular array rotates out a memory block
	  to the heap it checks that the memory has not been altered from
	  0xdeaddead. * Made the astmm_log message wording better. * Made
	  crash if the DO_CRASH menuselect option is enabled and something
	  is found. * Fixed a potential alignment issue on 64 bit systems.
	  struct ast_region.data[] should now be aligned correctly for all
	  platforms. * Extracted region_check_fences() from
	  __ast_free_region() and handle_memory_show(). * Updated
	  handle_memory_show() CLI usage help. Review:
	  https://reviewboard.asterisk.org/r/2182/ ........ Merged
	  revisions 376029 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-07 17:16 +0000 [r375995]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/time.h, apps/app_jack.c, apps/app_dial.c,
	  main/pbx.c, main/rtp_engine.c, /, apps/app_meetme.c,
	  res/res_fax.c, apps/app_record.c, channels/chan_agent.c,
	  main/utils.c, include/asterisk/channel.h, apps/app_queue.c,
	  channels/sig_pri.c, channels/chan_iax2.c, main/channel.c,
	  channels/chan_dahdi.c, apps/app_waitforring.c,
	  channels/sig_analog.c: Multiple revisions 375993-375994 ........
	  r375993 | mmichelson | 2012-11-07 11:01:13 -0600 (Wed, 07 Nov
	  2012) | 30 lines Fix misuses of timeouts throughout the code.
	  Prior to this change, a common method for determining if a
	  timeout was reached was to call a function such as
	  ast_waitfor_n() and inspect the out parameter that told how many
	  milliseconds were left, then use that as the input to
	  ast_waitfor_n() on the next go-around. The problem with this is
	  that in some cases, submillisecond timeouts can occur, resulting
	  in the out parameter not decreasing any. When this happens
	  thousands of times, the result is that the timeout takes much
	  longer than intended to be reached. As an example, I had a
	  situation where a 3 second timeout took multiple days to finally
	  end since most wakeups from ast_waitfor_n() were under a
	  millisecond. This patch seeks to fix this pattern throughout the
	  code. Now we log the time when an operation began and find the
	  difference in wall clock time between now and when the event
	  started. This means that sub-millisecond timeouts now cannot play
	  havoc when trying to determine if something has timed out. Part
	  of this fix also includes changing the function ast_waitfor() so
	  that it is possible for it to return less than zero when a
	  negative timeout is given to it. This makes it actually possible
	  to detect errors in ast_waitfor() when there is no timeout.
	  (closes issue ASTERISK-20414) reported by David M. Lee Review:
	  https://reviewboard.asterisk.org/r/2135/ ........ r375994 |
	  mmichelson | 2012-11-07 11:08:44 -0600 (Wed, 07 Nov 2012) | 3
	  lines Remove some debugging that accidentally made it in the last
	  commit. ........ Merged revisions 375993-375994 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-06 18:27 +0000 [r375965]  Richard Mudgett <rmudgett@digium.com>

	* include/asterisk/features.h, main/channel.c, /, main/features.c,
	  include/asterisk/channel.h, .cleancount: Fix stuck DTMF when
	  bridge is broken. When a bridge is broken by an AMI Redirect
	  action or the ChannelRedirect application, an in progress DTMF
	  digit could be stuck sending forever. * Made simulate a DTMF end
	  event when a bridge is broken and a DTMF digit was in progress.
	  (closes issue ASTERISK-20492) Reported by: Jeremiah Gowdy
	  Patches: bridge_end_dtmf-v3.patch.txt (license #6358) patch
	  uploaded by Jeremiah Gowdy Modified to
	  jira_asterisk_20492_v1.8.patch jira_asterisk_20492_v1.8.patch
	  (license #5621) patch uploaded by rmudgett Tested by: rmudgett
	  Review: https://reviewboard.asterisk.org/r/2169/ ........ Merged
	  revisions 375964 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-12-10  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.11.0 Released.

2012-12-06  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.11.0-rc3 Released.

	* chan_local: Fix local_pvt ref leak in local_devicestate().

	Regression introduced by ASTERISK-20390 fix.

	(closes issue ASTERISK-20769)
	Reported by: rmudgett

2012-12-05  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.11.0-rc2 Released.

	* Fix a SIP request memory leak with TLS connections.

	During the TLS re-work in chan_sip some TLS specific code was moved
	into a separate function. This function operates on a copy of the
	incoming SIP request. This copy was never deinitialized causing a
	memory leak for each request processed.

	This function is now given a SIP request structure which it can use
	to copy the incoming request into. This reduces the amount of memory
	allocations done since the internal allocated components are reused
	between packets and also ensures the SIP request structure is
	deinitialized when the TLS connection is torn down.

	(closes issue ASTERISK-20763)
	Reported by: deti

2012-11-06  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.11.0-rc1 Released.

2012-11-05 23:00 +0000 [r375894]  Matthew Jordan <mjordan@digium.com>

	* main/timing.c, main/channel.c, /, res/res_timing_pthread.c,
	  res/res_timing_dahdi.c, res/res_timing_timerfd.c,
	  bridges/bridge_softmix.c, funcs/func_jitterbuffer.c,
	  include/asterisk/timing.h, res/res_musiconhold.c,
	  channels/chan_iax2.c, res/res_fax_spandsp.c,
	  res/res_timing_kqueue.c: Refactor ast_timer_ack to return an
	  error and handle the error in timer users Currently, if an
	  acknowledgement of a timer fails Asterisk will not realize that a
	  serious error occurred and will continue attempting to use the
	  timer's file descriptor. This can lead to situations where errors
	  stream to the CLI/log file. This consumes significant resources,
	  masks the actual problem that occurred (whatever caused the timer
	  to fail in the first place), and can leave channels in odd
	  states. This patch propagates the errors in the timing resource
	  modules up through the timer core, and makes users of these
	  timers handle acknowledgement failures. It also adds some
	  defensive coding around the use of timers to prevent using bad
	  file descriptors in off nominal code paths. Note that the patch
	  created by the issue reporter was modified slightly for this
	  commit and backported to 1.8, as it was originally written for
	  Asterisk 10. Review: https://reviewboard.asterisk.org/r/2178/
	  (issue ASTERISK-20032) Reported by: Jeremiah Gowdy patches:
	  jgowdy-timerfd-6-22-2012.diff uploaded by Jeremiah Gowdy (license
	  6358) ........ Merged revisions 375893 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-05 21:39 +0000 [r375863]  Richard Mudgett <rmudgett@digium.com>

	* main/loader.c, /: Add safety NULL pointer check in module user
	  references. Made __ast_module_user_remove() check for NULL
	  pointers. ........ Merged revision 375860 from C.3 ........
	  Merged revisions 375862 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-05 17:55 +0000 [r375846]  Jonathan Rose <jrose@digium.com>

	* UPGRADE.txt: chan_sip: Document a change to user-field encoding
	  introduced with r303509 The change in question was added to
	  improve compliance with RFC3261, but at the time of commit, it
	  wasn't adequately documented in the UPGRADE notes. (closes issue
	  ASTERISK-20561) Reported by: Deniz Review:
	  https://reviewboard.asterisk.org/r/2177/

2012-11-04 03:08 +0000 [r375728-375801]  Matthew Jordan <mjordan@digium.com>

	* main/manager.c, /: Don't attempt to purge sessions when no
	  sessions exist Manager's tcp/tls objects have a periodic function
	  that purge old manager sessions periodically. During shutdown,
	  the underlying container holding those sessions can be disposed
	  of and set to NULL before the tcp/tls periodic function is
	  stopped. If the periodic function fires, it will attempt to
	  iterate over a NULL container. This patch checks for whether or
	  not the sessions container exists before attempting to purge
	  sessions out of it. If the sessions container is NULL, we simply
	  return. Note that this error was also caught by the Asterisk Test
	  Suite. ........ Merged revisions 375800 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* res/res_fax.c: Only deref a reserved gateway session if we
	  actually reserved one Its perfectly acceptable to have a gateway
	  session unreserved when we go to first allocate one. Unreffing
	  the reserved gateway session - when its NULL - will result in an
	  assertion error. This problem was caught by the Asterisk Test
	  Suite (once we had enough of the debugging flags enabled)

	* main/manager.c, /: Properly clean up manager resources on exit
	  This patch does two things: 1) It properly unregisters the
	  manager CLI commands 2) It cleans up AMI users on exit. Prior to
	  this patch, the AMI users were not being disposed of properly,
	  resulting in a memory leak. (closes issue ASTERISK-20646)
	  Reported by: Corey Farrell patches: manager_shutdown.patch
	  uploaded by Corey Farrell (license 5909) ........ Merged
	  revisions 375793 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/db.c: Properly finalize prepared SQLite3 statements to
	  prevent memory leak The AstDB uses prepared SQLite3 statements to
	  retrieve data from the SQLite3 database. These statements should
	  be finalized during Asterisk shutdown so that the SQLite3
	  database can be properly closed. Failure to finalize the
	  statements results in a memory leak and a failure when closing
	  the database. This patch fixes those issues by ensuring that all
	  prepared statements are properly finalized at shutdown. (closes
	  issue ASTERISK-20647) Reported by: Corey Farrell patches:
	  astdb-sqlite3_close.patch uploaded by Corey Farrell (license
	  5909)

	* main/xmldoc.c, /: Fix memory leak when unloading XML
	  documentation This patch is a modified version of a patch
	  originally committed for the Asterisk 11 branch in r375756. A
	  portion of that patch, that fixed the memory leak during
	  unloading XML documentation, applies to branches 1.8 and 10 as
	  well. The patch for this issue was modified for these two
	  branches. (issue ASTERISK-20648) Reported by: Corey Farrell
	  Tested by: mjordan patches: xmldoc-memory_leak.patch uploaded by
	  Corey Farrell (license 5909) ........ Merged revisions 375758
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/cdr.c, /: Prevent multiple CDR batches from conflicting when
	  scheduling the CDR write The Asterisk Test Suite caught an error
	  condition where a scheduled CDR batch write can be deleted twice
	  if two channels attempt to post their CDRs at the same time. The
	  batch CDR mutex is locked while the CDRs are appended to the
	  current batch list; however, it is unlocked prior to actually
	  scheduling the CDR write. As such, two threads can attempt to
	  remove the currently scheduled batch write at the same time,
	  resulting in an assertion error. This patch extends the time that
	  the mutex is locked to encompass actually scheduling the write.
	  This prevents two threads from unscheduling the currently
	  scheduled write at the same time. ........ Merged revisions
	  375727 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-03 03:15 +0000 [r375699]  Andrew Latham <lathama@gmail.com>

	* README, include/asterisk/doxyref.h, /: Doxygen Updates Replace
	  links to missing text files removed in the 1.6.x series with
	  links to the wiki. Doxygen can handle URLs fine, don't atempt to
	  quote them. Also update the wiki link in the Readme to get
	  everyone on the same page. (issue ASTERISK-20259) ........ Merged
	  revisions 375698 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-02 20:53 +0000 [r375626-375659]  Richard Mudgett <rmudgett@digium.com>

	* main/channel.c, channels/chan_misdn.c, /, main/ccss.c,
	  main/format_pref.c: Things don't need to be that const. ........
	  Merged revisions 375658 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/misdn/isdn_lib.h, /, channels/misdn/isdn_lib.c: Multiple
	  revisions 375519-375524 ........ r375519 | rmudgett | 2012-10-30
	  16:06:15 -0500 (Tue, 30 Oct 2012) | 11 lines chan_misdn: Timer
	  primitives must be handled first. The frm->addr is a different
	  "address space" than the stack/instance address of other Lx
	  primitives. The test for B channel instance address could fail.
	  Patches: patch01_timers.diff (license #6372) patch uploaded by
	  Guenther Kelleter JIRA ABE-2888 ........ r375520 | rmudgett |
	  2012-10-30 16:14:58 -0500 (Tue, 30 Oct 2012) | 10 lines
	  chan_misdn: Free memory in error paths and other memory leaks.
	  The one line commented with BUG is not easily fixable because
	  there is no de-init function one can call. Patches:
	  patch02_memory.diff (license #6372) patch uploaded by Guenther
	  Kelleter JIRA ABE-2888 ........ r375521 | rmudgett | 2012-10-30
	  16:38:41 -0500 (Tue, 30 Oct 2012) | 14 lines chan_misdn: ISDN NT
	  L2 de-establish/establish * An NT-PTMP cannot de/establish L2
	  since it doesn't know the TEIs. * On NT-PTP L2 is started when L1
	  is finally active in handle_l1. * L2 deactivation logging
	  cleanup. * L2 aggregate link status is unknown for NT-PTMP, show
	  as "UNKN". * Removed unused functions and code for L2 handling.
	  Patches: patch03_L2estab.diff (license #6372) patch uploaded by
	  Guenther Kelleter Modified JIRA ABE-2888 ........ r375522 |
	  rmudgett | 2012-10-30 16:56:14 -0500 (Tue, 30 Oct 2012) | 22
	  lines chan_misdn: Fix broken upper_id/lower_id usage. Sending PH
	  prim via lower_id layer (3 or 1) simply does not work. For TE (3)
	  it returns an error (len=-6) which is not evaluated by
	  handle_l1(), so the L1 layer status ends up wrong. Instead PH
	  must be sent via L4, only then does it reach L1 without an error
	  message. And NT PH prims only reach L1 when they are sent to
	  layer 2 id. --> use upper_id to send PH primitives. * Check for
	  errors in PH_(DE)ACTIVATE | CONFIRM. * Debug messages are
	  improved. * The lower_id is now not used for anything, except:
	  Why is lower_id layer deleted when it wasn't created? I removed
	  this code since it looks very wrong. Patches:
	  patch04_l1activation.diff (license #6372) patch uploaded by
	  Guenther Kelleter JIRA ABE-2888 ........ r375523 | rmudgett |
	  2012-10-30 17:29:15 -0500 (Tue, 30 Oct 2012) | 31 lines
	  chan_misdn: Fix loss of B channels if L1 is down. If you make 2
	  calls out an NT PTMP port which is not connected to any phone,
	  the B channel associated with that call becomes unusable until
	  Asterisk is restarted. The problem is the EVENT_SETUP is queued
	  when L1 is not up in misdn_lib_send_event(). If L1 cannot be
	  activated the event won't be dequeued. It gets even worse when
	  the call is hung up. The queued EVENT_SETUP will be overwritten
	  by an EVENT_DISCONNECT. The reserved B channel then will never be
	  freed. If later someone connects a phone to the port, L1 will
	  eventually activate and the queued EVENT_DISCONNECT is sent down
	  the stack. However, it is ignored because it is the wrong call
	  state. The real fix would be that activation and queueing for a
	  new SETUP is done by the NT stack. But since it doesn't, the
	  workaround must be removed because it doesn't always work. Fix:
	  The event is no longer queued but immediately sent to the stack.
	  If L1 cannot be activated, the L3 state machine that was started
	  by the EVENT_SETUP will do its work, i.e. a timeout will release
	  the B channel properly. The SETUP possibly cannot be sent the
	  first time but is resent by T303 in case L1 could be activated.
	  Patches: patch05_bchan-loss.diff (license #6372) patch uploaded
	  by Guenther Kelleter Modified JIRA ABE-2888 ........ r375524 |
	  rmudgett | 2012-10-30 18:26:05 -0500 (Tue, 30 Oct 2012) | 13
	  lines chan_misdn: Remove some calls to exit(). Try proper cleanup
	  when something goes wrong in misdn_lib_init(). Especially do not
	  call exit()! * Fix memory leak because stack_destroy() does not
	  free the stack struct. Patches: patch06_cleanup-init.diff
	  (license #6372) patch uploaded by Guenther Kelleter Modified JIRA
	  ABE-2888 ........ Merged revisions 375519-375524 from
	  https://origsvn.digium.com/svn/asterisk/be/branches/C.3-bier
	  ........ Merged revisions 375625 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-11-02 17:19 +0000 [r375601]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_sip.c: Fix Wrong Result In Debug Message For SDP
	  Origin Processing While looking at some debug logs, I noticed
	  that it was being reported that the SDP origin line was
	  unsupported or failed. Upon looking into this on my local
	  machine, I found that I too was getting this debug message yet
	  everything seemed to be getting processed properly. What was
	  discovered is, that, the variable to determine what is displayed
	  in the debug message for the SDP line that was processed, was not
	  being set for the origin line when the result was successful.
	  This patch fixes this and was tested on local machine. ........
	  Merged revisions 375594 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-31 14:34 +0000 [r375531]  Matthew Jordan <mjordan@digium.com>

	* /, res/res_calendar_ews.c: Properly extract the Body information
	  of an EWS calendar item Unlike all other calendar modules,
	  res_calendar_ews fails to extract the Body information for a
	  calendar item. This is due, in part, to a quirk in the schema in
	  the XML - not only does a CalendarItem contain a Body element,
	  but the CalendarItem exists as a descendant of a different Body
	  element. The neon parser was erroneously skipping all Body
	  elements. This patch fixes that by bypassing Body elements that
	  are not a child of CalendarItem, and parsing the Body element out
	  if it is a child. Note that the original patch by Terry Wilson
	  only needed slight modifications to make it properly pull the
	  Body information out; as such, while I've linked to the patch
	  that I uploaded for Dmitry, I've attributed the patch to Terry.
	  (closes issue ASTERISK-19738) Reported by: Dmitry Burilov Tested
	  by: Dmitry Burilov patches: calendar_ews_body_2012_10_29.diff
	  uploaded by Terry Wilson (license 6283) ........ Merged revisions
	  375528 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-30 19:20 +0000 [r375496]  Richard Mudgett <rmudgett@digium.com>

	* bridges/bridge_softmix.c: Fix ConfBridge crash if no timing
	  module loaded. (closes issue ASTERISK-19448) Reported by: feyfre
	  Patches: smfix.patch (license #6099) patch uploaded by feyfre
	  Modified for coding guidelines.

2012-10-30 18:55 +0000 [r375470-375485]  Jonathan Rose <jrose@digium.com>

	* /, apps/app_mixmonitor.c: mixmonitor: Add a test event This test
	  event is being used to fix the mixmonitor_audiohook_inherit test.
	  ........ Merged revisions 375484 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/app_confbridge.c: confbridge: Fix a bug which made
	  conferences not record with AMI/CLI commands When confbridge was
	  changed to handle conference status with a state machine in
	  r374658. The function responsible for starting recording for a
	  conference was refactored with the function actually responsible
	  for launching the recording thread being split into a function
	  with another name. The old function name was still used for
	  manually started recordings through AMI or CLI. This patch fixes
	  that by switching which function is used to start recording the
	  conference. (closes issue ASTERISK-20601) Reported by: Vilius
	  Patches: confbridge_mixmonitor.diff uploaded by Jonathan Rose
	  (license 6182)

2012-10-30 02:14 +0000 [r375451]  Matthew Jordan <mjordan@digium.com>

	* /, apps/app_queue.c: Ensure that the Queue application tracks
	  busy members in off nominal situations There are a few code paths
	  where the Queue application fails to count a paused or in use
	  queue member as being 'busy'. This can cause callers to get stuck
	  in the Queue until a paused agent unpauses themselves. (closes
	  issue ASTERISK-20623) Reported by: Bryan Walters patches:
	  app_queue.patch uploaded by Bryan Walters (license 5851) ........
	  Merged revisions 375450 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-29 21:09 +0000 [r375417]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Prevent resetting of NATted realtime peer
	  address on reload. If a "sip reload" is issued for a SIP peer,
	  then his IP address will be cleared, thus resulting in forgetting
	  the public IP address. Asterisk will then attempt to route SIP
	  traffic to the private IP address. The fix here is to make "sip
	  reload" ignore realtime peers when "host = dynamic" is spotted.
	  Realtime peers can now only have their IP address reset if they
	  have gone from being not dynamic to being dynamic. (closes issue
	  ASTERISK-18203) reported by daren ferreira (closes issue
	  ASTERISK-20572) reported by JoshE Patches: fix_nat_realtime.diff
	  uploaded by JoshE (license #6075) ........ Merged revisions
	  375415 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-29 19:28 +0000 [r375362-375389]  Richard Mudgett <rmudgett@digium.com>

	* /, main/features.c: Fix the Park 'r' option when a channel parks
	  itself. When a channel uses the Park appliation to park itself
	  with the 'r' option, the channel hears music-on-hold instead of
	  the requested ringing. * Added a missing check for the 'r' option
	  when a channel parks itself. (closes issue ASTERISK-19382)
	  Reported by: James Stocks Patches by: dsessions Review:
	  https://reviewboard.asterisk.org/r/2148/ ........ Merged
	  revisions 375388 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_dahdi.c, /: chan_dahdi: Fix segfault dereferencing
	  a NULL tech_pvt. The tech support customer was using the AMI
	  Redirect action shortly after a call was placed. While the
	  channel tried to do an ast_read(), the masquerade resulting from
	  the channel redirect took place. The masquerade in the middle of
	  the ast_read() resulted in the segfault. (closes issue AST-1025)
	  Reported by: Trey Blancher Patches: jira_ast_1025_v1.8_v2.patch
	  (license #5621) patch uploaded by rmudgett ........ Merged
	  revisions 375361 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-23 16:21 +0000 [r375273-375326]  Jonathan Rose <jrose@digium.com>

	* contrib/scripts/ast_tls_cert, /: ast_tls_cert script: Better
	  response for various exit conditions to openssl (closes issue
	  ASTERISK-20260) Reported by: Daniel O'Connor Patches:
	  ast_tls_cert-update.diff uploaded by Daniel O'Connor (license
	  6419) ........ Merged revisions 375325 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/app.c: core: Fix a memory leak in app.c from an early
	  return ast_app_group_match_get_count allocates memory with the
	  regcomp function and we previously forgot to free it when bailing
	  out due to a regex compilation failure against category. (closes
	  issue AST-1018) Reported by: Guenther Kelleter Patches:
	  regcomp_memleak.diff uploaded by Guenther Kelleter (license 6372)
	  ........ Merged revisions 375299 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, codecs/gsm/src/code.c: GSM: Fix encoding problems with GSM
	  (closes issue ASTERISK-20457) Reported by: Richard Miller
	  Patches: code.patch uploaded by Richard Miller (license 5685)
	  ........ Merged revisions 375272 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-18 21:39 +0000 [r375217-375245]  Jonathan Rose <jrose@digium.com>

	* UPGRADE.txt: app_queue: add upgrade notes for 375216 Adds notes
	  describing behavioral changes to rrmemory strategy caused by
	  375216 (issue AST-989) Reported by: Thomas Arimont

	* /, apps/app_queue.c: app_queue: Make ordering of
	  rrmemory/rrordered persist over add/remove members Prior to this
	  patch, adding, removing or reloading members to rrmemory would
	  cause the order to become completely jumbled. Now it behaves more
	  or less like rrordered other than the fact that it stores the
	  members on a hash table rather than a linked list. This patch
	  also prevents removal of members and member reloads from jumbling
	  rrordered queues. (issue AST-989) Reported by: Thomas Arimont
	  Review: https://reviewboard.asterisk.org/r/2164/ ........ Merged
	  revisions 375216 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-18 19:53 +0000 [r375190]  Richard Mudgett <rmudgett@digium.com>

	* Makefile, /, build_tools/make_version, configure, configure.ac,
	  makeopts.in: build_tools: Allow Asterisk to report git SHAs in
	  version string. Make git more attractive for managing
	  work-in-progress. Especially convenient when a potential patch
	  set needs to be tested on multiple platforms since one can use
	  git to keep all the test environments in sync independent of a
	  subversion server. Now the Asterisk version will show the exact
	  git SHA5 that was used when building (still appended by "M" if
	  there are local modifications) from a git clone of the Asterisk
	  repository so the developer can more easily know what is actually
	  under test. You will now get this: $ asterisk -V Asterisk
	  GIT-1698298 Instead of this: $ asterisk -V Asterisk
	  UNKNOWN__and_probably_unsupported This has zero impact for those
	  not using git with the exception of an extra test in the
	  configure script to gather git's path. This is necessary to
	  prevent "sudo make install" from failing since git may not be in
	  the path in make's shell environment. (closes issue
	  ASTERISK-20483) Reported by: Shaun Ruffell Patches:
	  0001-build_tools-Allow-Asterisk-to-report-git-SHAs-in-ver.patch
	  (license #5417) patch uploaded by Shaun Ruffell Modified ........
	  Merged revisions 375189 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-17 18:58 +0000 [r375147]  Kinsey Moore <kmoore@digium.com>

	* main/tcptls.c, /: Ensure Asterisk fails TCP/TLS SIP calls when
	  certificate checking fails When placing a call to a TCP/TLS SIP
	  endpoint whose certificate is not signed by a configured CA
	  certificate, Asterisk would issue a warning and continue to
	  process the call as if there was not an issue with the
	  certificate. Asterisk now properly fails the call if the
	  certificate fails verification or if the certificate does not
	  exist when certificate checking is enabled (the default
	  behavior). (closes issue ASTERISK-20559) Reported by: kmoore
	  Review: https://reviewboard.asterisk.org/r/2163/ ........ Merged
	  revisions 375146 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-16 21:43 +0000 [r375078-375112]  Walter Doekes <walter+asterisk@wjd.nu>

	* /, channels/chan_sip.c: Fixes to the fd-oriented SIP TCP reads.
	  Don't crash on large user input. Allow SIP headers without space.
	  Optimize code a bit. Review:
	  https://reviewboard.asterisk.org/r/2162 ........ Merged revisions
	  375111 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Update sip_request_call SIP dial string
	  documentation. This was missed when merging review r1859.
	  ........ Merged revisions 375074 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-16 19:16 +0000 [r375060]  Tzafrir Cohen <tzafrir.cohen@xorcom.com>

	* contrib/scripts/autosupport, /: autosupport: fix bashism '==' is
	  bashism (bashspecific, fails when dash is /bin/sh). Anyway, a
	  'case' works better there. (closes issue ASTERISK-20567) Reported
	  by: Tzafrir Cohen ........ Merged revisions 375059 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-15 21:06 +0000 [r375026]  Mark Michelson <mmichelson@digium.com>

	* apps/app_dial.c, /, main/ccss.c, include/asterisk/strings.h,
	  channels/chan_iax2.c: Fix some potential misuses of ast_str in
	  the code. Passing an ast_str pointer by value that then calls
	  ast_str_set(), ast_str_set_va(), ast_str_append(), or
	  ast_str_append_va() can result in the pointer originally passed
	  by value being invalidated if the ast_str had to be reallocated.
	  This fixes places in the code that do this. Only the example in
	  ccss.c could result in pointer invalidation though since the
	  other cases use a stack-allocated ast_str and cannot be
	  reallocated. I've also updated the doxygen in strings.h to
	  include notes about potential misuse of the functions mentioned
	  previously. Review: https://reviewboard.asterisk.org/r/2161
	  ........ Merged revisions 375025 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-14 09:40 +0000 [r374991]  Tzafrir Cohen <tzafrir.cohen@xorcom.com>

	* config.sub, /, config.guess: Update config.guess and config.sub:
	  2012-10-10 Update config.guess and config.sub to revision
	  fb456b34ef4aa02b95dc6be69aaa66fa94a844fb from the
	  savannah.gnu.org git repo. Adds support for e.g. aarch64 (ARM
	  64bit). config.guess:timestamp='2012-09-25'
	  config.sub:timestamp='2012-10-10' ........ Merged revisions
	  374977 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-12 16:11 +0000 [r374906]  Mark Michelson <mmichelson@digium.com>

	* main/tcptls.c, /, channels/chan_sip.c, include/asterisk/tcptls.h:
	  Do not use a FILE handle when doing SIP TCP reads. This is used
	  to solve an issue where a poll on a file descriptor does not
	  necessarily correspond to the readiness of a FILE handle to be
	  read. This change makes it so that for TCP connections, we do a
	  recv() on the file descriptor instead. Because TCP does not
	  guarantee that an entire message or even just one single message
	  will arrive during a read, a loop has been introduced to ensure
	  that we only attempt to handle a single message at a time. The
	  tcptls_session_instance structure has also had an overflow buffer
	  added to it so that if more than one TCP message arrives in one
	  go, there is a place to throw the excess. Huge thanks goes out to
	  Walter Doekes for doing extensive review on this change and
	  finding edge cases where code could fail. (closes issue
	  ASTERISK-20212) reported by Phil Ciccone Review:
	  https://reviewboard.asterisk.org/r/2123 ........ Merged revisions
	  374905 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-11 15:43 +0000 [r374844]  Matthew Jordan <mjordan@digium.com>

	* main/cdr.c, /: Fix incorrect billing duration reported when batch
	  mode is enabled Similar to r369351, the billing duration can be
	  skewed when batch mode is enabled. This happened much more rarely
	  than the duration, as it only occured when the call was answered
	  (thereby indicating an actual answer time) and immediately hung
	  up on (indicating a billsec of 0). Since a billing time of '0'
	  can either mean that the call immediately ended or that the CDR
	  was improperly answered, we have to use additional information to
	  know whether or not we can trust the CDR billsec value. Prior to
	  this patch, we looked to see if we had a valid answer time. If we
	  did, and billsec was zero, we used the current time to calculate
	  what billsec value we could from the CDR being written. If batch
	  mode is enabled, this will incorrectly report a billsec value
	  being much greater than the actual duration of the call. Instead
	  of relying on the presence of an answer time to know whether or
	  not we can re-calculate the billsec for the CDR, we now also use
	  the presence of the CDR's end time to know if we need to
	  re-calculate or whether we can trust the billsec value that we
	  have. This prevents erroneous jumps in the billsec value, while
	  still making sure that in the worst case, some billing time will
	  be calculated. (closes issue AST-1016) Reported by: Thomas
	  Arimont Tested by: Thomas Arimont ........ Merged revisions
	  374843 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-10 20:55 +0000 [r374695-374803]  Richard Mudgett <rmudgett@digium.com>

	* /, apps/app_queue.c: app_queue: Made pass connected line updates
	  from the caller to ringing queue members. Party A calls Party B
	  Party B puts Party A on hold. Party B calls a queue. Ringing
	  queue member D sees Party B identification. Party B transfers
	  Party A to the queue. Queue member D does not get a connected
	  line update for Party A. Queue member D answers the call and
	  still sees Party B information. However, if Party A later
	  transfers the call to Party C then queue member D gets a
	  connected line update for Party C. * Made pass connected line
	  updates from the caller to queue members while the queue members
	  are ringing. (closes issue AST-1017) Reported by: Thomas Arimont
	  (closes issue ABE-2886) Reported by: Thomas Arimont Tested by:
	  rmudgett ........ Merged revisions 374801 from
	  https://origsvn.digium.com/svn/asterisk/be/branches/C.3-bier
	  ........ Merged revisions 374802 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/pbx.c, /: Fix execution of 'i' extension due to
	  uninitialized variable. The fix for ASTERISK-18243 added code
	  that could potentially use dst_exten[] uninitialized. As a result
	  the 'i' exten may not be executed when it should. (closes issue
	  ASTERISK-20455) Reported by: Richard Miller Patches:
	  pbx-1.8.16.0.diff (license #5685) patch uploaded by Richard
	  Miller Made some cosmetic modifications. ........ Merged
	  revisions 374758 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* configs/chan_dahdi.conf.sample, /: dahdi.conf.sample: Add
	  description for "buffers" setting. This contains an edited
	  version of the patch originally created by John Bigelow. (closes
	  issue ASTERISK-14435) Reported by: John Bigelow Patches:
	  buffers.patch (license #5091) patch uploaded by John Bigelow
	  0001-dahdi.conf.sample-Add-description-for-buffers-settin.patch
	  (license #5417) patch uploaded by Shaun Ruffell Modified ........
	  Merged revisions 374727 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* pbx/pbx_spool.c, /: Fix deletion of unopenable spool files. If
	  scan_service() cannot open the spool file, it logs a message
	  saying that it will delete the file and calls remove_from_queue()
	  to do it. However, remove_from_queue() fails to delete the spool
	  file because struct outgoing has not yet been fully initialized.
	  * Merged allocating a new struct outgoing and init_outgoing()
	  into new_outgoing(). Allocation is initialization. * Made
	  apply_outgoing() not initialize the spool filename in struct
	  outgoing. * Made apply_outgoing() call ast_trim_blanks() and
	  ast_skip_blanks() rather than manually inlining them. * Reduced
	  indentation levels in apply_outgoing(). * Fixed a garbled comment
	  in remove_from_queue(). * Reworked scan_service() to simplify it.
	  (closes issue ASTERISK-17231) Reported by: David Chappell
	  Patches: spool_open_failure.diff (license #4997) patch uploaded
	  by David Chappell Started with this patch. ........ Merged
	  revisions 374686 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 * Fixed some
	  memory leaks on off nominal paths in init_outgoing() when merging
	  into the new_outgoing() function dealing with o->capabilities.

2012-11-05  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.10.0 Released.

2012-11-05  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.10.0-rc2 Released.

	* Fix a bug which made ConfBridge not record the conference when
	  the recording was initiated from an AMI/CLI command

	  (closes issue ASTERISK-20601)
	  Reported by: Vilius

2012-10-08  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.10.0-rc1 Released.

2012-10-08 13:46 +0000 [r374652]  Matthew Jordan <mjordan@digium.com>

	* apps/confbridge/conf_state.c (added),
	  apps/confbridge/conf_state_single.c (added),
	  apps/confbridge/conf_state_inactive.c (added),
	  apps/confbridge/conf_state_single_marked.c (added),
	  apps/confbridge/include/confbridge.h,
	  apps/confbridge/include/conf_state.h (added),
	  apps/confbridge/conf_state_multi.c (added),
	  apps/app_confbridge.c, apps/confbridge/conf_state_multi_marked.c
	  (added), apps/confbridge/conf_state_empty.c (added): Resolve
	  issues in ConfBridge regarding marked, waitmarked, and unmarked
	  users Thank's to Neil Tallim (flan)'s tireless testing, issue
	  reporting, and patches it became clear that app_confbridge had
	  some complex logic in how it handled interactions between marked,
	  waitmarked, and unmarked users. In particular, there were some
	  areas in which the interactions between the users resulted in
	  inconsistent behavior, and app_confbridge was missing logic in
	  how to handle some corner cases. Some areas included: * Poor
	  handling of mixing unmarked and waitmarked users *
	  Inconsistencies in how MOH and muting was applied to various
	  users * Handling of various announcements for different user
	  profile options flan's patches seem to fix the various issues,
	  but highlighted how hard the code could be to maintain. In an
	  attempt to make things easier to maintain and to more fully
	  enumerate the various cases that exist, this patch breaks up the
	  logic into a state machine-like setup. Please note that the
	  various state transitioned are documented on the Asterisk wiki:
	  https://wiki.asterisk.org/wiki/display/AST/Confbridge+state+changes
	  Review: //https://reviewboard.asterisk.org/r/2072/ Note that for
	  the following issues, mjordan uploaded the patch, although it was
	  written by twilson. Any contributor license discrepency is due to
	  that. (closes issue ASTERISK-19562) Reported by: flan Tested by:
	  flan, mjordan, jrose patches:
	  bugASTERISK-19562_ASTERISK-19726_ASTERISK-20181.patch uploaded by
	  twilson (license 6283) (closes issue ASTERISK-19726) Reported by:
	  flan Tested by: flan patches:
	  bugASTERISK-19562_ASTERISK-19726_ASTERISK-20181.patch uploaded by
	  twilson (license 6283) (closes issue ASTERISK-20181) Reported by:
	  Jonathan White Tested by: Jonathan White patches:
	  bugASTERISK-19562_ASTERISK-19726_ASTERISK-20181.patch uploaded by
	  twilson (license 6283)

2012-10-05 20:23 +0000 [r374586]  dlee <dlee@localhost>:

	* main/manager.c, /: Multiple revisions 374570,374581 ........
	  r374570 | dlee | 2012-10-05 15:14:41 -0500 (Fri, 05 Oct 2012) |
	  22 lines Improve AMI long line error handling In AMI's parser,
	  when it receives a long line (> 1024 characters), it discards
	  that line, but continues to process the message normally.
	  Typically, this is not a problem because a) who has lines that
	  long and b) usually a discarded line results in an invalid
	  message. But if that line is specifying an optional field, then
	  the message will be processed, you get a 'Response: Success', but
	  things don't work the way you expected them to. This patch
	  changes the behavior when a line-too-long parse error occurs. *
	  Changes the log message to avoid way-too-long (and truncated
	  anyways) log messages * Adds a 'parsing' status flag to Response:
	  Success * Sets parsing = MESSAGE_LINE_TOO_LONG if, well, a line
	  is too long * Responds with an appropriate error if parsing !=
	  MESSAGE_OKAY (closes issue AST-961) Reported by: John Bigelow
	  Review: https://reviewboard.asterisk.org/r/2142/ ........ r374581
	  | dlee | 2012-10-05 15:20:28 -0500 (Fri, 05 Oct 2012) | 1 line
	  I've committed too much. Reverting part of r374570. ........
	  Merged revisions 374570,374581 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-05 18:25 +0000 [r374537]  Richard Mudgett <rmudgett@digium.com>

	* channels/misdn/isdn_lib.h, channels/chan_misdn.c, /,
	  channels/misdn/isdn_msg_parser.c, channels/misdn/isdn_lib.c:
	  Merged revisions 374515-374535 from
	  https://origsvn.digium.com/svn/asterisk/be/branches/C.3-bier
	  ................ r374515 | rmudgett | 2012-10-04 17:52:36 -0500
	  (Thu, 04 Oct 2012) | 10 lines chan_misdn: Remove some deadcode *
	  Made setup_bc() static. Patches: patch1_unused-code.diff (license
	  #6372) patch uploaded by Guenther Kelleter Modified JIRA ABE-2882
	  ................ r374516 | rmudgett | 2012-10-04 18:01:01 -0500
	  (Thu, 04 Oct 2012) | 7 lines chan_misdn: Remove unused bchan
	  states Patches: patch2_unused-states.diff (license #6372) patch
	  uploaded by Guenther Kelleter JIRA ABE-2882 ................
	  r374517 | rmudgett | 2012-10-04 18:17:51 -0500 (Thu, 04 Oct 2012)
	  | 16 lines chan_misdn: Remove unnecessary null pointer checks and
	  checks for stack->nt * cleanup_bc() is always called with valid
	  bc (or it would've crashed before). * Value of stack->nt is known
	  in advance at some places. * Rename handle_event() to
	  handle_event_te(), handle_frm() to handle_frm_te(). Patches:
	  patch3_checks.diff (license #6372) patch uploaded by Guenther
	  Kelleter Modified JIRA ABE-2882 ................ r374518 |
	  rmudgett | 2012-10-04 18:21:59 -0500 (Thu, 04 Oct 2012) | 7 lines
	  chan_misdn: Fix spelling in log messages Patches:
	  patch4_spelling.diff (license #6372) patch uploaded by Guenther
	  Kelleter JIRA ABE-2882 ................ r374519 | rmudgett |
	  2012-10-04 18:31:59 -0500 (Thu, 04 Oct 2012) | 15 lines
	  chan_misdn: Don't cleanup a bc twice. In handle_frm_te() after
	  calling misdn_lib_send_event(bc, EVENT_RELEASE_COMPLETE) bc is
	  emptied, cleaned and set not in use, although
	  misdn_lib_send_event() already did the same. This is bad. When
	  it's not in use we are not allowed to touch it. * Moved log
	  message in front of the resulting actions and fixed it to match
	  the case. Patches: patch5_bccleanup.diff (license #6372) patch
	  uploaded by Guenther Kelleter JIRA ABE-2882 ................
	  r374520 | rmudgett | 2012-10-04 18:43:56 -0500 (Thu, 04 Oct 2012)
	  | 12 lines chan_misdn: Fix memory leaks, bc, chan not cleaned up
	  etc., really bad stuff. * Fix return codes of cb_events() for
	  EVENT_SETUP to use caller's cleanup mechanisms. * Move
	  cl_queue_chan() call after bearer check. Patches:
	  patch6_leaks.diff (license #6372) patch uploaded by Guenther
	  Kelleter JIRA ABE-2882 ................ r374521 | rmudgett |
	  2012-10-04 18:48:38 -0500 (Thu, 04 Oct 2012) | 11 lines
	  chan_misdn: We must initialize cause on sending a DISCONNECT. We
	  must initialize cause on sending a DISCONNECT, so it is later
	  correctly indicated to ast_channel in case the answer
	  (RELEASE/RELEASE_COMPLETE) does not include one. Patches:
	  patch7_hangupcause.diff (license #6372) patch uploaded by
	  Guenther Kelleter JIRA ABE-2882 ................ r374522 |
	  rmudgett | 2012-10-04 19:03:56 -0500 (Thu, 04 Oct 2012) | 7 lines
	  chan_misdn: Remove unused code for upqueue Patches:
	  patch8_unused-upqueue.diff (license #6372) patch uploaded by
	  Guenther Kelleter JIRA ABE-2882 ................ r374523 |
	  rmudgett | 2012-10-04 19:11:50 -0500 (Thu, 04 Oct 2012) | 7 lines
	  chan_misdn: Improve debugging (port number, messages fixed, dups
	  removed) Patches: patch9_debug.diff (license #6372) patch
	  uploaded by Guenther Kelleter JIRA ABE-2882 ................
	  r374533 | rmudgett | 2012-10-05 12:17:18 -0500 (Fri, 05 Oct 2012)
	  | 8 lines chan_misdn: Better debug: we can print_bc_info even if
	  there's no ast leg. Patches: patch10_debug-bc-2.diff (license
	  #6372) patch uploaded by Guenther Kelleter Modified. JIRA
	  ABE-2882 ................ r374534 | rmudgett | 2012-10-05
	  12:34:10 -0500 (Fri, 05 Oct 2012) | 16 lines chan_misdn:
	  setup_bc() is called too early for an incoming SETUP on TE. This
	  prevents the B channel from being setup for HDLC mode when
	  requested by the bearer capability and config option hdlc=yes. It
	  violates ETS300102 Ch.5.2.3.2: "The user, in any case, must not
	  connect to the channel until a CONNECT ACKNOWLEDGE message has
	  been received." * Call setup_bc() on receipt of
	  CONNECT_ACKNOWLEGDE for PTMP, and on first response to SETUP for
	  PTP. Patches: abe-2881-2.diff (license #6372) patch uploaded by
	  Guenther Kelleter Modified. JIRA ABE-2881 ................
	  r374535 | rmudgett | 2012-10-05 12:41:05 -0500 (Fri, 05 Oct 2012)
	  | 2 lines chan_misdn: Remove some more deadcode. ................
	  ........ Merged revisions 374536 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-04 20:17 +0000 [r374476-374481]  Alec L Davis <sivad.a@paradise.net.nz>

	* main/dsp.c, /, configs/dsp.conf.sample, CHANGES: dsp.c User
	  Configurable DTMF_HITS_TO_BEGIN and DTMF_MISSES_TO_END Instead of
	  a recompile, allow values to be adjusted in dsp.conf For binary
	  distributions allows easy adjustment for wobbly GSM calls, and
	  other reasons. Defaults to DTMF_HITS_TO_BEGIN=2 and
	  DTMF_MISSES_TO_END=3 (closes issue ASTERISK-17493) Tested by:
	  alecdavis alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2144/ ........ Merged
	  revisions 374479 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/dsp.c, /: dsp.c fix incorrect DTMF Digit_Duration. it's
	  always short by 'hits_to_begin*DTMF_GSIZE', or 25.5ms if
	  hitstobegin=2 (issue ASTERISK-16003) Tested by: alecdavis
	  alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2145/ ........ Merged
	  revisions 374475 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-04 17:44 +0000 [r374457]  Joshua Colp <jcolp@digium.com>

	* /, channels/chan_sip.c: Fix a regression from direct media ACLs
	  where the directrtpsetup option no longer works. A check was
	  added for direct media ACLs that immediately forbid remote
	  bridging if there was no bridged channel. This caused
	  directrtpsetup to no longer function as it needs this information
	  before bridging actually occurs. Logic has now been adjusted so
	  if there is no bridged channel a remote bridge will still be
	  attempted. (closes issue ASTERISK-20511) Reported by: kristoff
	  Review: https://reviewboard.asterisk.org/r/2146/ ........ Merged
	  revisions 374456 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-04 15:37 +0000 [r374427]  dlee <dlee@localhost>:

	* /, res/res_agi.c, main/db.c: Fix DBDelTree error codes for AMI,
	  CLI and AGI The AMI DBDelTree command will return Success/Key
	  tree deleted successfully even if the given key does not exist.
	  The CLI command 'database deltree' had a similar problem, but was
	  saved because it actually responded with '0 database entries
	  removed'. AGI had a slightly different error, where it would
	  return success if the database was unavailable. This came from
	  confusion about the ast_db_deltree retval, which is -1 in the
	  event of a database error, or number of entries deleted
	  (including 0 for deleting nothing). * Changed some poorly named
	  res variables to num_deleted * Specified specific errors when
	  calling ast_db_deltree (database unavailable vs. entry not found
	  vs. success) * Fixed similar bug in AGI database deltree, where
	  'Database unavailable' results in successful result (closes issue
	  AST-967) Reported by: John Bigelow Review:
	  https://reviewboard.asterisk.org/r/2138/ ........ Merged
	  revisions 374426 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-04 04:41 +0000 [r374370-374385]  Alec L Davis <sivad.a@paradise.net.nz>

	* main/dsp.c, /, configs/dsp.conf.sample, CHANGES: dsp.c User
	  configuration of DTMF_NORMAL_TWIST and DTMF_REVERSE_TWIST values
	  Asterisk's DTMF Specifications are based on AT&T specs, which may
	  not be compatible in other countries. Various countries have
	  different specifications for the maximum power level differences
	  between the DTMF low group and high group of frequencies. Power
	  level difference between frequencies for different
	  Administrations/RPOAs NTT = Max. 5 dB AT&T = 4dB(reverse) to
	  8dB(normal) Danish = Max. 6 dB Australian = Max. 10 dB Brazilian
	  = Max. 9 dB ETSI = Max. 6 dB from ETSI ES 201 235-3 V1.3.1
	  (2006-03) Now allow 4 variables to be individually configured in
	  dsp.conf, with reasonable min/max of 2dB to 20dB. Default is AT&T
	  specifications Add's the following variables to dsp.conf
	  ;dtmf_normal_twist=6.31 ;dtmf_reverse_twist=2.51
	  ;relax_dtmf_normal_twist=6.31 ;relax_dtmf_reverse_twist=3.98
	  (closes issue ASTERISK-20442) Reported by: tbsky Tested by:
	  tbsky,alecdavis alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2141/ ........ Merged
	  revisions 374384 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/dsp.c, /: _dsp_init: bring inline with trunk preparation for
	  clean merge of DTMF TWIST patch No functional changes, just
	  style. alecdavis (license 585) Reported by: Alec Davis Tested by:
	  alecdavis related https://reviewboard.asterisk.org/r/2141
	  ........ Merged revisions 374365 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-04 02:11 +0000 [r374178-374336]  Matthew Jordan <mjordan@digium.com>

	* /, res/res_jabber.c: Check for presence of buddy in info/dinfo
	  handlers The res_jabber resource module uses the ASTOBJ library
	  for managing its ref counted objects. After calling
	  ASTOBJ_CONTAINER_FIND to locate a buddy object, the pointer to
	  the object has to be checked to see if the buddy existed. Prior
	  to this patch, the buddy object was not checked for NULL; with
	  this patch in both aji_client_info_handler and aji_dinfo_handler
	  the pointer is checked before used and, if no buddy object was
	  found, the handlers return an error code. This patch does not
	  take the approach that our JID can be used to log in from another
	  resource. If that approach is desired, an improvement could be
	  made to this patch to create the buddy on the fly. This patch
	  seeks only to prevent Asterisk from crashing. Note that multiple
	  people have proposed patches for this issue; the patch being
	  committed here is based on those. (closes issue ASTERISK-19532)
	  Reported by: Karsten Wemheuer Tested by: Byron Clark patches:
	  fix-jabber uploaded by Karsten Wemheuer (license #5930)
	  xmpp_no_crash_with_ejabberd.patch uploaded by Byron Clark
	  (license #6157) (closes issue ASTERISK-19557) Reported by:
	  ulugutz ........ Merged revisions 374335 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/ccss.c: Destroy the generic_monitors container after the
	  core_instances in ccss For each item in core_instances disposed
	  of in the shutdown of ccss, any generic monitor instances
	  referenced by the objects will be removed from generic_monitors
	  during their destruction. Hilarity ensues if generic_monitors no
	  longer exists. Thanks to the Asterisk Test Suite's generic_ccss
	  test for complaining loudly when it ran into this.

	* /, main/asterisk.c: Ensure Shutdown AMI event is still fired
	  during Asterisk shutdown Richard pointed out that having the
	  manager dispose of itself gracefully during shutdown meant that
	  the Shutdown event will no longer get fired. This patch moves the
	  AMI event just prior to running the atexit callbacks. ........
	  Merged revisions 374230 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/message.c: Fix findings from check-in on r374177 Richard
	  pointed out two problems with the check-in from r374177: * The
	  ast_msg_shutdown function declaration doesn't match the prototype
	  in main/message.c. * The ref/alloc function usage in astobj2 (in
	  11+) can use the ao2_t_* variants of the functions to allow the
	  REF_DEBUG flag to enable/disable their debug counterparts.

	* main/channel.c, main/format.c, main/data.c, main/pbx.c,
	  main/manager.c, /, main/ccss.c, channels/chan_agent.c,
	  main/features.c, main/cel.c, main/format_pref.c,
	  main/indications.c, main/message.c, main/asterisk.c, main/db.c:
	  Fix a variety of ref counting issues This patch resolves a number
	  of ref leaks that occur primarily on Asterisk shutdown. It adds a
	  variety of shutdown routines to core portions of Asterisk such
	  that they can reclaim resources allocate duringd initialization.
	  Review: https://reviewboard.asterisk.org/r/2137 ........ Merged
	  revisions 374177 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-10-01 17:52 +0000 [r374132-374135]  Sean Bright <sean@malleable.com>

	* include/asterisk/astdb.h, tests/test_db.c, apps/app_queue.c,
	  main/db.c: app_queue: Support persisting and loading of long
	  member lists. Greenlight in #asterisk brought up that he was
	  receiving an error message "Could not create persistent member
	  string, out of space" when running app_queue in Asterisk 10.
	  dump_queue_members() made an assumption that 8K would be enough
	  to store the generated string, but with queues that have large
	  member lists this is not always the case. This patch removes the
	  limitation and uses ast_str instead of a fixed sized buffer. The
	  complicating factor comes from the fact that ast_db_get requires
	  a buffer and buffer size argument, which doesn't let us pull back
	  more than what we pass in, so I introduced a new
	  ast_db_get_allocated() which returns an ast_strdup()'d copy of
	  the value from astdb. As an aside, I did some testing on the
	  maximum size of data that we can store in the BDB library we
	  distribute and was able to store a 10MB string and retrieve it
	  with no problems, so I feel this is a safe patch. Review:
	  https://reviewboard.asterisk.org/r/2136/ ........ Merged
	  revisions 374108 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/db.c: Use ast_copy_string instead of strncpy to guarantee a
	  NUL terminated string.

2012-09-28 19:21 +0000 [r374045]  Jonathan Rose <jrose@digium.com>

	* /, res/res_jabber.c: res_jabber: Remove CLI command 'jabber test'
	  The opinion of development was that it is both improper to have
	  Matt's personal email address used in the source and that the
	  command wouldn't be useful without it. (closes issue AST-467)
	  Reported by: Malcolm Davenport ........ Merged revisions 374032
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-28 12:15 +0000 [r373990]  Joshua Colp <jcolp@digium.com>

	* /, res/res_agi.c: Update documentation to make it explicit that
	  "stream file" will not restart musiconhold. (issue
	  ASTERISK-17367) Reported by: oej ........ Merged revisions 373989
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-27 22:12 +0000 [r373946]  Richard Mudgett <rmudgett@digium.com>

	* /, apps/app_senddtmf.c: Fix SendDTMF crash and channel reference
	  leak using channel name parameter. The SendDTMF channel name
	  parameter has two issues. 1) Crashes if the channel name does not
	  exist. 2) Leaks a channel reference if the channel is the current
	  channel. Problem introduced by ASTERISK-15956. * Updated SendDTMF
	  documentation. * Renamed app to senddtmf_name and tweaked the
	  type. ........ Merged revisions 373945 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-27 16:50 +0000 [r373879-373910]  Joshua Colp <jcolp@digium.com>

	* main/loader.c, /: loader: Ensure dependent modules are properly
	  initialized. If an Asterisk module specifies a dependency in
	  ast_module_info.nonoptreq, it is possible for Asterisk to skip
	  calling the modules's .load function. Asterisk was loading and
	  linking the module via load_dynamic_module() but was not adding
	  the module to the resource_heap. Therefore the module was not
	  initialized based on it's priority along with the other modules
	  in the heap. Now use load_resource() instead of
	  load_dynamic_module() for non-optional requirement. This will add
	  the module to the resource_heap so the module can be properly
	  initialized in the correct order. This is required if there are
	  any module global data structures initialized in the .load()
	  callback for the module on platforms which do not support weak
	  references. (issue ASTERISK-20439) Reported by: sruffell Patches:
	  0001-loader-Ensure-dependent-modules-are-properly-initial.patch
	  uploaded by sruffell (license 5417) ........ Merged revisions
	  373909 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_local.c, /: Fix an issue where Local channels
	  dialed by app_queue are considered in use immediately. The
	  chan_local channel driver returns a device state of in use even
	  if a created Local channel has not yet been dialed. This fix
	  changes the logic to return a state of not in use until the
	  channel itself has been dialed. (closes issue ASTERISK-20390)
	  Reported by: tim_ringenbach Review:
	  https://reviewboard.asterisk.org/r/2116/ ........ Merged
	  revisions 373878 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-26 21:11 +0000 [r373849]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Move handling of 408 response so there is
	  no misleading warning message. (closes issue ASTERISK-20060)
	  Reported by: Walter Doekes ........ Merged revisions 373848 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-26 18:15 +0000 [r373816]  Richard Mudgett <rmudgett@digium.com>

	* /, apps/app_meetme.c: Fixed meetme tab completion and command
	  documentation. * Removed unnecessary case sensitivity in meetme
	  list, lock, unlock, mute, unmute, and kick commands. * Separated
	  meetme lock/unlock, mute/unmute, and kick commands into their own
	  registered commands to simplify tab completion and parameter
	  checking. meetme_lock_cmd(), meetme_mute_cmd(), and
	  meetme_kick_cmd() * Simplified meetme_show_cmd() (closes issue
	  AST-1006) Reported by: John Bigelow Tested by: rmudgett ........
	  Merged revisions 373815 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-25 23:08 +0000 [r373737-373774]  Mark Michelson <mmichelson@digium.com>

	* /, main/say.c: Fix saying of date in Dutch. The Dutch say the
	  date before the month. (closes issue ASTERISK-20353) Reported by:
	  Teun Ouwehand ........ Merged revisions 373773 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* configs/agents.conf.sample, /, channels/chan_agent.c: Remove dead
	  code and documentation for nonexistent feature. multiplelogin was
	  removed from chan_agent back in 1.6.0 when AgentCallbackLogin()
	  was removed. (closes issue AST-948) reported by Steve Pitts
	  ........ Merged revisions 373768 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/app_voicemail.c, /: Fix error where improper IMAP greetings
	  would be deleted. (closes issue ASTERISK-20435) Reported by:
	  fhackenberger Patches: asterisk-20435-imap-del-greeting.diff
	  uploaded by Michael L. Young (License #5026) (with suggested
	  modification made by me) ........ Merged revisions 373735 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-25 20:12 +0000 [r373706]  Joshua Colp <jcolp@digium.com>

	* channels/chan_local.c, /: Fix T.38 support when used with
	  chan_local in between. Users of the T.38 API can indicate
	  AST_T38_REQUEST_PARMS on a channel to request that the channel
	  indicate a T.38 negotiation with the parameters present on the
	  channel. The return value of this indication is expected to be
	  AST_T38_REQUEST_PARMS upon success but with chan_local involved
	  this could never occur. This fix changes chan_local to always
	  return AST_T38_REQUEST_PARMS for this situation. If the
	  underlying channel technology on the other side does not support
	  T.38 this would have been determined ahead of time using
	  ast_channel_get_t38_state and an indication would not occur.
	  (closes issue ASTERISK-20229) Reported by: wdoekes Patches:
	  ASTERISK-20229.patch uploaded by wdoekes (license 5674) Review:
	  https://reviewboard.asterisk.org/r/2070/ ........ Merged
	  revisions 373705 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-25 19:34 +0000 [r373675-373703]  Kinsey Moore <kmoore@digium.com>

	* res/res_rtp_asterisk.c, /: Fix an issue where media would not
	  flow for situations where the legacy STUN code is in use. The
	  STUN packets should *not* be blocked by strict RTP. (closes issue
	  ASTERISK-20415) Reported-by: Michele Cicciotti Patch-by: Josh
	  Colp (trunk r369817) ........ Merged revisions 373702 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_queue.c: "show" completion option for "queue"
	  shouldn't appear twice When tab-completing CLI commands starting
	  with "queue", "show" appeared twice in the list due to the way
	  that Asterisk's tab completion functions and the order in which
	  the commands were registered. The registration order has been
	  altered to resolve this issue. (closes issue AST-940)
	  Reported-by: Steve Pitts ........ Merged revisions 373666 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-25 17:35 +0000 [r373665]  Terry Wilson <twilson@digium.com>

	* /, channels/chan_sip.c, configs/sip.conf.sample,
	  channels/sip/include/sip.h: Properly handle UAC/UAS roles for SIP
	  session timers The SIP session timer mechanism contains a
	  mandatory 'refresher' parameter (included in the Session-Expires
	  header) which is used in the session timer offer/answer signaling
	  within a SIP Invite dialog. It looks like asterisk is
	  interpreting the uac resp. uas role only as the initial role of
	  client and server (caller is uac, callee is uas). The standard
	  rfc 4028 however assigns the client role to the ((RE)-Invite)
	  requester, the server role to the ((RE)-Invite) responder. This
	  patch has Asterisk track the actual refresher as "us" or "them"
	  as opposed to relying on just the configured "uas" or "uac"
	  properties. (closes issue AST-922) Reported by: Thomas Airmont
	  Review: https://reviewboard.asterisk.org/r/2118/ ........ Merged
	  revisions 373652 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-25 17:19 +0000 [r373633-373645]  Richard Mudgett <rmudgett@digium.com>

	* /, codecs/ilbc/iLBC_encode.c, codecs/ilbc/iLBC_decode.c: Fix
	  valgrind found memcpy issues in codec_ilbc. Valgrind found
	  codec_ilbc using memcpy instead of memmove for overlapping memory
	  blocks. (issue ASTERISK-19890) (closes issue ASTERISK-20231)
	  Reported by: Walter Doekes Patches: ASTERISK-20231.patch (license
	  #5674) patch uploaded by Walter Doekes ........ Merged revisions
	  373640 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* codecs/Makefile, /: Make rebuild GSM, ilbc, or lpc10 codecs if
	  the respective sources change. ........ Merged revisions 373618
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-25 16:24 +0000 [r373631]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c: chan_sip: Set Quality of Service for
	  video rtp instance (closes issue ASTERISK-20201) Reported by:
	  ddkprog Patches: chan_sip.c.diff uploaded by ddkprog (license
	  6008) ........ Merged revisions 373617 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-25 13:28 +0000 [r373579]  Kinsey Moore <kmoore@digium.com>

	* configs/res_odbc.conf.sample, /: Fix documentation for default
	  username in res_odbc This was previously stated to be "root", but
	  is actually the name of the context if unspecified. (closes issue
	  ASTERISK-20258) Reported by: Stefan x ........ Merged revisions
	  373578 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-25 12:00 +0000 [r373533-373551]  Joshua Colp <jcolp@digium.com>

	* res/res_rtp_multicast.c, /: Fix an issue where a caller to
	  ast_write on a MulticastRTP channel would determine it failed
	  when in reality it did not. When sending RTP packets via
	  multicast the amount of data sent is stored in a variable and
	  returned from the write function. This is incorrect as any
	  non-zero value returned is considered a failure while a return
	  value of 0 is success. For callers (such as ast_streamfile) that
	  checked the return value they would have considered it a failure
	  when in reality nothing went wrong and it was actually a success.
	  The write function for the multicast RTP engine now returns -1 on
	  failure and 0 on success, as it should. (closes issue
	  ASTERISK-17254) Reported by: wybecom ........ Merged revisions
	  373550 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Add missing checks that I neglected. The
	  SIP technology and SIP info technology should be considered
	  equal. (closes issue ASTERISK-20409) Reported by: michele
	  cicciotti privatewave ........ Merged revisions 373532 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-24 22:17 +0000 [r373505]  Matthew Jordan <mjordan@digium.com>

	* res/res_rtp_asterisk.c, /: Revert change to res_rtp_asterisk
	  committed in r373236 (1.8) The change committed in r373236
	  attempted to account for endpoints that increased their RTP
	  timestamp in DTMF end of event re-transmissions. This change
	  attempted to make Asterisk continue to work with endpoints that
	  failed to follow the RFC while maintaining the fix that allowed
	  for out of order DTMF to be handled. Unfortunately, there is no
	  free lunch, and this patch broke any system that sent DTMF
	  immediately after an RTP session was established or when an SSRC
	  is updated. As such, that patch is being reverted for the
	  previous behavior. Endpoints that erroneously increase the RTP
	  timestamp in DTMF end of event packets will not work properly
	  with Asterisk. (issue ASTERISK-20424) ........ Merged revisions
	  373504 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-24 22:11 +0000 [r373501]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/chan_sip.c: Be consistent, send From: "Anonymous"
	  <sip:anonymous@anonymous.invalid> When setting
	  CALLERID(pres)=unavailable in the dialplan, the From header in
	  the SIP message contains "Anonymous"
	  <sip:Anonymous@anonymous.invalid>. For consistency, Asterisk
	  should use a lowercase a in the userpart of the URI. * Make the
	  From header use a lowercase A in the userpart of the anonymous
	  URI. (closes issue ASTERISK-19838) Reported by: Antti Yrjola
	  Patches: chan_sip_patch_ASTERISK-19838.patch (license #6383)
	  patch uploaded by Antti Yrjola ........ Merged revisions 373500
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-24 21:05 +0000 [r373468]  Jonathan Rose <jrose@digium.com>

	* funcs/func_audiohookinherit.c, /, apps/app_mixmonitor.c:
	  func_audiohookinherit: Document some missed sources. This patch
	  also mentions that AUDIOHOOK_INHERIT can be used to transfer
	  MixMonitor audiohooks. There is also wiki that addresses
	  audiohooks and the use of AUDIOHOOK_INHERIT at the following
	  link: https://wiki.asterisk.org/wiki/display/AST/Audiohooks
	  (closes issue ASTERISK-18220) Reported by: Ishfaq Malik ........
	  Merged revisions 373467 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-24 20:44 +0000 [r373466]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/chan_sip.c: Fix potential reentrancy problems in
	  chan_sip. Asterisk v1.8 and later was not as vulnerable to this
	  issue. * Made find_call() lock each private as it processes the
	  found dialogs. (Primary cause of ABE-2876) * Made the other
	  functions that traverse the dialogs container lock each private
	  as it examines them. * Fix race condition in sip_call() if the
	  thread that sent the INVITE is held up long enough for a response
	  to be processed. The p->initid for the INVITE retransmission
	  could be added after it was canceled by the response processing.
	  * Made __sip_destroy() clean up resource pointers after freeing.
	  This is primarily defensive in case someone has a stale private
	  pointer. * Removed redundant memset() in reqprep(). The call to
	  init_req() already does the memset() and is the first reference
	  to req in reqprep(). * Removed useless set of req.method in
	  transmit_invite(). The calls to initreqprep() and reqprep() have
	  to do this because they memset() the req. JIRA ABE-2876
	  .......... Merged -r373423 from
	  https://origsvn.digium.com/svn/asterisk/be/branches/C.3-bier
	  ........ Merged revisions 373424 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-24 19:17 +0000 [r373440]  Joshua Colp <jcolp@digium.com>

	* /, channels/chan_sip.c: Fix a deadlock caused by a race condition
	  between removing a hint and reloading the dialplan and
	  subscribing to the removed hint. If conditions were right it was
	  possible for both the PBX core and chan_sip to deadlock by both
	  having a lock that the other wants. In the case of the PBX core
	  it had the contexts lock and wanted a SIP dialog lock, while in
	  the case of chan_sip it had the SIP dialog lock and wanted the
	  contexts lock. This fix unlocks the SIP dialog before getting the
	  extension state so that the other thread will not block on trying
	  to lock it. Once the extension state is retrieved the SIP dialog
	  is locked again and life carries on. As the SIP dialog is
	  reference counted it is not possible for it to go away after
	  unlocking. (closes issue ASTERISK-20437) Reported by: jhutchins
	  ........ Merged revisions 373438 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-21 19:08 +0000 [r373300-373343]  Jonathan Rose <jrose@digium.com>

	* /, channels/iax2-provision.c: iax2-provision: Fix improper return
	  on failed cache retrieval (closes issue ASTERISK-20337) reported
	  by: John Covert Patches: iax2-provision.c.patch uploaded by John
	  Covert (license 5512) ........ Merged revisions 373342 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_queue.c: app_queue: Make queue reload members and
	  variants of that work Prior to this patch, 'queue reload members'
	  cli command did not work at all. This also affects the manager
	  function 'QueueReload' when supplied with the 'members: yes'
	  field. (closes issue AST-956) Reported by: John Bigelow ........
	  Merged revisions 373298 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-20 19:14 +0000 [r373245]  Joshua Colp <jcolp@digium.com>

	* /, apps/app_meetme.c: Fix incorrect MeetME conference bridge
	  reference count decrementing and sometimes premature destruction.
	  When using the 'e' or 'E' option to MeetMe the configured
	  conference bridges are loaded and examined to see if any are
	  empty. If no conference bridges are empty the caller is prompted
	  to enter the number of one. This operation left around a pointer
	  to the last created conference bridge still containing
	  participants. When the caller that was not able to find any empty
	  conference bridge hung up this pointer was disposed of and the
	  reference count of the conference bridge decremented. If there
	  was only a single participant in the conference bridge it was
	  ultimately destroyed prematurely. (closes issue AST-994) Reported
	  by: John Bigelow ........ Merged revisions 373242 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-20 18:42 +0000 [r373196-373237]  Matthew Jordan <mjordan@digium.com>

	* res/res_rtp_asterisk.c, /: When processing RFC 2833 DTMF,
	  accomodate increasing timestamps in End events While endpoints
	  should not be changing the source timestamp between DTMF event
	  packets, the fact is there exists those endpoints that do exactly
	  that. To work around this, we absorb timestamps within the
	  expected re-transmit period. Note that this period only affects
	  End of Event packets, so it should not prevent the detection of
	  new DTMF digits that happen to arrive right on top of each other.
	  (closes issue ASTERISK-20424) Reported by: Vladimir Mikhelson
	  Tested by: mjordan, Vladimir Mikhelson Review:
	  https://reviewboard.asterisk.org/r/2124 ........ Merged revisions
	  373236 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/confbridge/conf_config_parser.c: Ensure that all ConfBridge
	  sounds can be set using CONFBRIDGE function The CONFBRIDGE
	  function can be used to set the sounds in a ConfBridge bridge
	  profile. Unfortunately, three sounds were missed in the portion
	  of the code that applies the settings passed in from the
	  function: sound_only_one, join, and leave. This patch makes sure
	  that the sounds passed from the function are applied to the
	  bridge profile. (closes issue ASTERISK-20404) Reported by: univ
	  Tested by: mjordan

2012-09-19 17:05 +0000 [r373179]  Joshua Colp <jcolp@digium.com>

	* /, channels/chan_sip.c: Fix a regression where direct media was
	  not permitted for calls using SIP INFO DTMF. A change was
	  committed to fix direct media ACL support. This change wrongly
	  assumed that only a single channel technology structure exists
	  for chan_sip. This is in fact false as a second exists for calls
	  using SIP INFO DTMF. The code which performs direct media ACL
	  checking now checks for both the non-INFO DTMF and INFO DTMF
	  channel technology structures. (closes issue ASTERISK-20409)
	  Reported by: michele cicciotti privatewave ........ Merged
	  revisions 373165 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-18 20:13 +0000 [r373132]  Sean Bright <sean@malleable.com>

	* main/manager.c, /: Don't crash when passing a NULL message to
	  __astman_get_header. Before this commit, __astman_get_header
	  would blindly dereference the passed in 'struct message *' to
	  traverse the header list. There are cases, however, such as
	  '*CLI> sip qualify peer foo' where the message pointer is NULL,
	  so we need to check for that. ........ Merged revisions 373131
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-15 00:20 +0000 [r373101]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/sig_ss7.c: Made companding law for SS7 calls only
	  determined by SS7 signaling type. For SS7, the companding law for
	  a call was chosen inconsistently depending upon ss7type (ITU vs
	  ANSI) and the DAHDI companding default (T1 vs E1). For incoming
	  calls, the companding law was determined by ss7type. For outgoing
	  calls, the companding law was determined by the DAHDI default.
	  With the wrong combination you would get A-law/u-law conflicts.
	  An A-law/u-law conflict sounds like bad static on the line. SS7
	  ITU signaling with E1 line: ok SS7 ITU signaling with T1 line:
	  noise SS7 ANSI signaling with E1 line: noise SS7 ANSI signaling
	  with T1 line: ok * Fix the companding law used to be determined
	  by the SS7 signaling type only. ........ Merged revisions 373090
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-14 19:12 +0000 [r373059-373062]  Matthew Jordan <mjordan@digium.com>

	* main/tcptls.c, /, channels/chan_sip.c, main/ssl.c: Resolve memory
	  leaks in TLS initialization and TLS client connections This patch
	  resolves two sources of memory leaks when using TLS in Asterisk:
	  1) It removes improper initialization (and multiple
	  re-initializations) of portions of the SSL library. Asterisk
	  calls SSL_library_init and SSL_load_error_strings during SSL
	  initialization; collectively this obviates the need for calling
	  any of the following during initialization or client connection
	  handling: * ERR_load_crypto_strings (handled by
	  SSL_load_error_strings) * OpenSSL_add_all_algorithms (synonym for
	  SSL_library_init) * SSLeay_add_ssl_algorithms (synonym for
	  SSL_library_init) 2) Failure to completely clean up all memory
	  allocated by Asterisk and by the SSL library for TLS clients.
	  This included not freeing the SSL_CTX object in the SIP channel
	  driver, as well as not clearing the error stack when the TLS
	  client exited. Note that these memory leaks were found by Thomas
	  Arimont, and this patch was essentially written by him with some
	  minor tweaks. (closes issue AST-889) Reported by: Thomas Arimont
	  Tested by: Thomas Arimont patches: (bugAST-889.patch) by Thomas
	  Arimont (license 5525) Review:
	  https://reviewboard.asterisk.org/r/2105 ........ Merged revisions
	  373061 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, include/asterisk/astobj2.h, main/astobj2.c: Constify
	  __ao2_ref_debug in astobj2 When REF_DEBUG is enabled in certain
	  files - most notably ccss.c - the 'tag' parameter passed to
	  __ao2_ref_debug will be a const char *. The function currently
	  expects that parameter to not be const. This causes a warning
	  when compiling, as the const qualifier is being discarded. With
	  dev-mode enabled, this prevents compiling Asterisk. This patch
	  makes __ao2_ref_debug's tag and file parameters const. (closes
	  issue ASTERISK-20408) Reported by: mjordan ........ Merged
	  revisions 372959 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-13 18:44 +0000 [r373025]  dlee <dlee@localhost>:

	* main/channel.c, /, include/asterisk/channel.h: Fix timeouts for
	  ast_waitfordigit[_full]. ast_waitfordigit_full would simply pass
	  its timeout to ast_waitfor_nandfds, expecting it to decrement the
	  timeout by however many milliseconds were waited. This is a
	  problem if it consistently waits less than 1ms. The timeout will
	  never be decremented, and we wait... FOREVER! This patch makes
	  ast_waitfordigit_full manage the timeout itself. It maintains the
	  previously undocumented behavior that negative timeouts wait
	  forever. (closes issue ASTERISK-20375) Reported by: Mark
	  Michelson Tested by: Mark Michelson Review:
	  https://reviewboard.asterisk.org/r/2109/ ........ Merged
	  revisions 373024 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-13  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.9.0-rc1 Released.

2012-09-12 14:53 +0000 [r372933]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Add channel name to a warning to make
	  debugging easier. The "autodestruct with owner in place" message
	  is typically indicative of a channel reference leak. Printing out
	  the name of the channel in the message may be helpful when trying
	  to debug the issue. ........ Merged revisions 372932 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-11 22:23 +0000 [r372916]  Jonathan Rose <jrose@digium.com>

	* channels/chan_local.c, /: chan_local: Switch from using a random
	  4 digit hex identifier to unique id Changes chan_local channels
	  to use an 8 digit hex identifier generated atomically and
	  sequentially in order to eliminate the chance of having multiple
	  channels with the same name during high call volume situations.
	  (issue ASTERISK-20318) Reported by: Dan Cropp Review:
	  https://reviewboard.asterisk.org/r/2104/ ........ Merged
	  revisions 372902 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-11 21:04 +0000 [r372885]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/_private.h, main/message.c, main/asterisk.c: Fix
	  inability to shutdown gracefully due to an unending channel
	  reference. message.c makes use of a special message queue channel
	  that exists in thread storage. This channel never goes away due
	  to the fact that the taskprocessor used by message.c does not get
	  shut down, meaning that it never ends the thread that stores the
	  channel. This patch fixes the problem by shutting down the
	  taskprocessor when Asterisk is shut down. In addition, the thread
	  storage has a destructor that will release the channel reference
	  when the taskprocessor is destroyed. (closes issue AST-937)
	  Reported by Jason Parker Patches: AST-937.patch uploaded by Mark
	  Michelson (License #5049) Tested by Jason Parker

2012-09-11 17:14 +0000 [r372863]  dlee <dlee@localhost>:

	* Makefile: Corrects the astsbindir setting when installing the
	  sample asterisk.conf. (closes issue ASTERISK-20406)

2012-09-11 15:30 +0000 [r372841]  Mark Michelson <mmichelson@digium.com>

	* /, main/features.c: Fix bad channel application data reference.
	  When channels get bridged due to an AMI bridge action or a DTMF
	  attended transfer, the two channels that get bridged have their
	  application data pointing to the other channel's name. This means
	  that if one channel is hung up but the other moves on, it means
	  that the channel that moves on will have its application data
	  pointing at freed memory. (issue ASTERISK-20335) Reported by:
	  aragon ........ Merged revisions 372840 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-10 20:56 +0000 [r372805]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_iax2.c: Ensure iax2 debug output is displayed
	  when expected When IAX2 debug was changed from iax_showframe to
	  iax_outputframe, some instances were missed (or added afterward).
	  This was causing debug output to not be displayed when expected.
	  (closes issue ASTERISK-20338) Reported-by: John Covert Patch-by:
	  John Covert ........ Merged revisions 372804 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-10 18:41 +0000 [r372767]  Jonathan Rose <jrose@digium.com>

	* /, apps/app_meetme.c: app_meetme: Document that 'p' option will
	  continue in dialplan. (closes issue AST-991) Reported by John
	  Bigelow ........ Merged revisions 372765 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-10 18:32 +0000 [r372764]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_sip.c: Warn on CLI when UDPTL init fails This
	  adds a CLI warning when a SDP offer is rejected due to UDPTL
	  initialization failure. Previously, there was no indication of
	  the reason for offer rejection in this case. (closes issue
	  ASTERISK-20357) Reported-by: Francesco Usseglio Gaudi ........
	  Merged revisions 372763 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-10 17:14 +0000 [r372737]  Jonathan Rose <jrose@digium.com>

	* main/channel.c, /: Masquerade: Retain parkinglot settings made by
	  CHANNEL function. Prior to this patch, the user would have a
	  parkinglot set on a channel that was parked and when the channel
	  was retrieved, any attempt by that channel to park would simply
	  use the default. This patch makes parkinglot values set in this
	  way be retained through the masquerade. (closes issue AST-990)
	  Reported by: Nick Huskinson Patches:
	  masquerade_parkinglot_patch.diff Uploaded by Jonathan Rose
	  (license 6182) ........ Merged revisions 372736 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-09 01:24 +0000 [r372710]  Matthew Jordan <mjordan@digium.com>

	* channels/sip/sdp_crypto.c, /: Only re-create an SRTP session when
	  needed In r356604, SRTP handling was fixed to accomodate multiple
	  crypto keys in an SDP offer and the ability to re-create an SRTP
	  session when the crypto keys changed. In certain circumstances -
	  most notably when a phone is put on hold after having been
	  bridged for a significant amount of time - the act of re-creating
	  the SRTP session causes problems for certain models of phones.
	  The patch committed in r356604 always re-created the SRTP session
	  regardless of whether or not the cryptographic keys changed.
	  Since this is technically not necessary, this patch modifies the
	  behavior to only re-create the SRTP session if Asterisk detects
	  that the remote key has changed. This allows models of phones
	  that do not handle the SRTP session changing to continue to work,
	  while also providing the behavior needed for those phones that do
	  re-negotiate cryptographic keys. (issue ASTERISK-20194) Reported
	  by: Nicolo Mazzon Tested by: Nicolo Mazzon Review:
	  https://reviewboard.asterisk.org/r/2099 ........ Merged revisions
	  372709 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-08 05:21 +0000 [r372695]  dlee <dlee@localhost>:

	* /, main/Makefile: Add OPENSSL_INCLUDE to the CFLAGS for ssl.c and
	  tcptls.c. Without this flag, those files will compile with the
	  system installed OpenSSL headers (if they exist). This is a real
	  bummer if a different path was specified using --with-ssl=
	  (closes issue ASTERISK-20392) ........ Merged revisions 372682
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-07 23:06 +0000 [r372621-372656]  Richard Mudgett <rmudgett@digium.com>

	* /, main/astmm.c: Fix MALLOC_DEBUG version of ast_strndup().
	  (closes issue ASTERISK-20349) Reported by: Brent Eagles ........
	  Merged revisions 372655 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, funcs/func_math.c: Remove annoying unconditional debug message
	  from INC/DEC functions. (closes issue AST-1001) Reported by:
	  Guenther Kelleter ........ Merged revisions 372628 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_queue.c: Fix exception path typo in app_queue.c
	  try_calling(). (closes issue ASTERISK-20380) Reported by: Jeremy
	  Pepper Patches: fix-local-channel-locking.patch (license #6350)
	  patch uploaded by Jeremy Pepper ........ Merged revisions 372624
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/app_voicemail.c, /: Fix VoicemailUserEntry event headers
	  ServerEmail and MailCommand reported values. The AMI action
	  VoicemailUsersList VoicemailUserEntry event headers ServerEmail
	  and MailCommand did not report the global values if they were not
	  overridden. The VoicemailUserEntry event header ServerEmail was
	  not populated with the global value if the voicemail user did not
	  override it. The VoicemailUserEntry event header MailCommand was
	  never populated with a value. * Removed unused struct ast_vm_user
	  member mailcmd[]. (closes issue AST-973) Reported by: John
	  Bigelow Tested by: rmudgett ........ Merged revisions 372620 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-07 02:25 +0000 [r372555-372582]  Matthew Jordan <mjordan@digium.com>

	* /, apps/app_minivm.c: Free ast_str objects when temp file fails
	  to be created in MiniVM The previous commit (r372554) was from a
	  patch that was written before r366880, which ensured that ast_str
	  objects allocated in the sendmail routine were free'd in off
	  nominal paths. This commit frees the string objects in the off
	  nominal path introduced in r372554. (issue ASTERISK-17133)
	  Reported by: Tzafrir Cohen ........ Merged revisions 372581 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_minivm.c: Fix file descriptor leak and pointer scope
	  issue in MiniVM when sending mail When MiniVM sends an e-mail and
	  it has the volgain option set, it will spawn sox in a separate
	  process to handle the manipulation of the sound file. In doing
	  so, it creates a temporary file. There are two problems here: 1)
	  The file descriptor returned from mkstemp is leaked 2) The
	  finalfilename character pointer points to a buffer that loses
	  scope once volgain processing is finished. Note that in r316265,
	  Russell fixed some gcc warnings by using the return value of the
	  mkstemp call. A warning was placed in minivm that the file
	  descriptor was going to be leaked. This patch reverts that
	  change, as it handles the leak and 'uses' the file descriptor
	  returned from mkstemp. (closes issue ASTERISK-17133) Reported by:
	  Tzafrir Cohen patches: minivm_18501_demo.diff uploaded by Tzafrir
	  Cohen (license #5035) ........ Merged revisions 372554 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-06 22:10 +0000 [r372522]  Richard Mudgett <rmudgett@digium.com>

	* channels/sig_pri.c: Fix loss of MOH on an ISDN channel when
	  parking a call for the second time. Using the AMI redirect action
	  to take an ISDN call out of a parking lot causes the MOH state to
	  get confused. The redirect action does not take the call off of
	  hold. When the call is subsequently parked again, the call no
	  longer hears MOH. * Make chan_dahdi/sig_pri restart MOH on
	  repeated AST_CONTROL_HOLD frames if it is already in a state
	  where it is supposed to be sending MOH. The MOH may have been
	  stopped by other means. (Such as killing the generator.) This
	  simple fix is done rather than making the AMI redirect action
	  post an AST_CONTROL_UNHOLD unconditionally when it redirects a
	  channel and thus potentially breaking something with an
	  unexpected AST_CONTROL_UNHOLD. (closes issue ABE-2873) Patches:
	  jira_abe_2873_c.3_bier.patch (license #5621) patch uploaded by
	  rmudgett ........ Merged revisions 372521 from
	  https://origsvn.digium.com/svn/asterisk/be/branches/C.3-bier

2012-09-06 21:40 +0000 [r372518]  Kinsey Moore <kmoore@digium.com>

	* /, apps/app_queue.c: Ensure listed queues are not offered for
	  completion When using tab-completion for the list of queues on
	  "queue reset stats" or "queue reload
	  {all|members|parameters|rules}", the tab-completion listing for
	  further queues erroneously listed queues that had already been
	  added to the list. The tab-completion listing now only displays
	  queues that are not already in the list. (closes issue AST-963)
	  Reported-by: John Bigelow ........ Merged revisions 372517 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-06 18:54 +0000 [r372499]  dsessions <dsessions@localhost>:

	* channels/chan_sip.c, configs/res_ldap.conf.sample: LDAP Realtime
	  Peers Cannot Register Prior to 1.8, it was not necessary for an
	  explicit "type" to be set for an asterisk LDAP realtime peer. Now
	  the routine find_peer actually checks the type field during
	  registration and fails to find the peer if it is not set. The
	  attached patches make the realtime type equal whatever type is
	  being searched for if the type is 0 upon return from routine
	  build_peer. (closes issue ASTERISK-17222) Reported by: John
	  Covert Patch by: David Vossel Tested by: Darren Sessions Review:
	  https://reviewboard.asterisk.org/r/2095/

2012-09-06 15:54 +0000 [r372472]  Jonathan Rose <jrose@digium.com>

	* /, UPGRADE-1.8.txt: chan_sip: Note change in behavior to how
	  directmediapermit/deny ACL works r366547 introduced a change to
	  the directmedia ACL for chan_sip which modified the behavior
	  significantly. Prior to the patch, this option would bridge peers
	  with directmedia if a peer's IP address matched its own
	  directmedia ACL. After that patch, the peer would check the
	  bridged peer's ACL instead. This change has been present since
	  1.8.14.0. That patched failed to document the change in
	  Upgrade.txt, so this patch adds mention of that change to
	  UPGRADE.txt (UPGRADE-1.8.txt in newer branches) (issue AST-876)
	  ........ Merged revisions 372471 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-06 14:29 +0000 [r372445]  Kinsey Moore <kmoore@digium.com>

	* /, apps/app_queue.c: Ensure "rules" is tab-completable for "queue
	  show" Previously, tabbing at the end of "queue show" produced a
	  list of available queues about which information could be shown,
	  but did not include an alternative command, "rules", to access
	  information about queue rules. The "rules" item should now be
	  shown in the list of tab-completable items. (closes issue
	  AST-958) Reported-by: John Bigelow ........ Merged revisions
	  372444 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-06 02:49 +0000 [r372391-372418]  Matthew Jordan <mjordan@digium.com>

	* /, pbx/pbx_dundi.c: Fix DUNDi message routing bug when
	  neighboring peer is unreachable Consider a scenario where DUNDi
	  peer PBX1 has two peers that are its neighbors, PBX2 and PBX3,
	  and where PBX2 and PBX3 are also neighbors. If the connection is
	  temporarily broken between PBX1 and PBX3, PBX1 should not include
	  PBX3 in the list of peers it sends to PBX2 in a DPDISCOVER
	  message, as it cannot send messages to PBX3. If it does, PBX2
	  will assume that PBX3 already received the message and fail to
	  forward the message on to PBX3 itself. This patch fixes this by
	  only including peers in a DPDISCOVER message that are reachable
	  by the sending node. This includes all peers with an empty
	  address (00:00:00:00:00:00) and that are have been reached by a
	  qualify message. This patch also prevents attempting to qualify a
	  dynamic peer with an empty address until that peer registers.
	  (closes issue ASTERISK-19309) Reported by: Peter Racz patches:
	  dundi_routing.patch uploaded by Peter Racz (license 6290) The
	  patch uploaded by Peter was modified slightly for this commit.
	  ........ Merged revisions 372417 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_followme.c: Allow configured numbers for FollowMe to
	  be greater than 90 characters When parsing a 'number' defined in
	  followme.conf, FollowMe previously parsed the number in the
	  configuration file into a buffer with a length of 90 characters.
	  This can artificially limit some parallel dial scenarios. This
	  patch allows for numbers of any length to be defined in the
	  configuration file. Note that Clod Patry originally wrote a patch
	  to fix this problem and received a Ship It! on the JIRA issue.
	  The patch originally expanded the buffer to 256 characters.
	  Instead, the patch being committed duplicates the string in the
	  config file on the stack before parsing it for consumption by the
	  application. (closes issue ASTERISK-16879) Reported by: Clod
	  Patry Tested by: mjordan patches: followme_no_limit.diff uploaded
	  by Clod Patry (license #5138) Slightly modified for this commit.
	  ........ Merged revisions 372390 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-05 19:42 +0000 [r372372]  Richard Mudgett <rmudgett@digium.com>

	* main/dsp.c: Fix compile error.

2012-09-05 19:22 +0000 [r372358]  Kinsey Moore <kmoore@digium.com>

	* main/manager.c, /: Correct documentation for ModuleLoad AMI
	  action The documentation incorrectly listed 'rtp' as a reloadable
	  subsystem and left out many other reloadable subsystems. It is
	  now also documented that subsystems may only be reloaded, not
	  loaded or unloaded. (closes issue AST-977) Reported-by: John
	  Bigelow ........ Merged revisions 372354 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-05 18:43 +0000 [r372341]  Alec L Davis <sivad.a@paradise.net.nz>

	* main/dsp.c, /: dsp.c: in ast_mf_detect_init incorrectly sets
	  goertzel samples to 160, should be MF_GSIZE Related
	  https://reviewboard.asterisk.org/r/2097/ ........ Merged
	  revisions 372339 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-05 18:30 +0000 [r372338]  Kinsey Moore <kmoore@digium.com>

	* main/pbx.c, /: Ensure counts generated in
	  manager_show_dialplan_helper are correct When
	  manager_show_dialplan_helper was written, the counter increment
	  for the total number of contexts was placed with the extensions
	  increment instead of in the enclosing loop. This function should
	  now generate correct context counts. (closes issue AST-970)
	  Reported-by: John Bigelow ........ Merged revisions 372337 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-05 13:42 +0000 [r372288]  Matthew Jordan <mjordan@digium.com>

	* apps/app_voicemail.c, /: Fix memory leaks in app_voicemail when
	  using IMAP storage or realtime config This patch fixes two memory
	  leaks: 1. When find_user is called with NULL as its first
	  parameter, the voicemail user returned is allocated on the heap.
	  The inboxcount2 function uses find_user in such a fashion when
	  counting new messages, and fails to free the resulting voicemail
	  user object. 2. When populate_defaults is called on a voicemail
	  user, it wipes whatever flags have been set on the object by
	  copying over the global flags object. If the VM_ALLOCED flag was
	  ste on the voicemail user prior to doing so, that flag is
	  removed. This leaks the voicemail user when free_user is later
	  called. (closes issue ASTERISK-19155) Reported by: Filip Jenicek
	  patches: asterisk.patch2 uploaded by Filip Jenicek (license 6277)
	  Patch slightly modified for this commit. Review:
	  https://reviewboard.asterisk.org/r/2096 ........ Merged revisions
	  372268 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-05 07:37 +0000 [r372213-372240]  Alec L Davis <sivad.a@paradise.net.nz>

	* main/dsp.c, /: dsp.c: Fix multiple issues when no-interdigit
	  delay is present, and fast DTMF 50ms/50ms Revert DTMF hit/miss
	  detector to original -r349249 method with some changes, remove
	  unnecessary; 1. reseting of hits=0, when no signal, only need to
	  set it once. 2. incrementing of hits, when the hit is the same as
	  the current hit. 3. setting of lasthit, when it's the same as
	  before. Change HITS_TO_BEGIN to 2, MISSES_TO_END to 3 & 3
	  spelling mistakes (closes issue ASTERISK-19610) alecdavis
	  (license 585) Reported by: Jean-Philippe Lord Tested by:
	  alecdavis Review: https://reviewboard.asterisk.org/r/2085/
	  ........ Merged revisions 372239 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/dsp.c, /: dsp.c: optimize goerztzel sample loops, in
	  dtmf_detect, mf_detect and tone_detect use a temporary short int
	  when repeatedly used to call goertzel_sample. alecdavis (license
	  585) Reported by: alecdavis Tested by: alecdavis Review:
	  https://reviewboard.asterisk.org/r/2093/ ........ Merged
	  revisions 372212 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-05 04:47 +0000 [r372198]  Michael L. Young <elgueromexicano@gmail.com>

	* res/res_rtp_asterisk.c, /: Fix Incrementing Sequence Number For
	  Retransmitted DTMF End Packets In Asterisk 1.4+, a fix was put in
	  place to increment the sequence number for retransmitted DTMF end
	  packets. With the introduction of the RTP engine API in 1.8, the
	  sequence number was no longer being incremented. This patch fixes
	  this regression as well as cleans up a few lines that were not
	  doing anything. (closes issue ASTERISK-20295) Reported by: Nitesh
	  Bansal Tested by: Michael L. Young Patches:
	  01_rtp_event_seq_num.patch uploaded by Nitesh Bansal (license
	  6418) asterisk-20295-dtmf-fix-cleanup.diff uploaded by Michael L.
	  Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2083/ ........ Merged
	  revisions 372185 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-05 02:19 +0000 [r372165]  Matthew Jordan <mjordan@digium.com>

	* cel/cel_pgsql.c, /: Fix memory leak when CEL is successfully
	  written to PostgreSQL database PQClear is not called when the
	  result object of a call to PQExec has a status of
	  PGRES_COMMAND_OK. Interestingly enough, the off nominal case was
	  handled properly, so this memory leak only occurred when CEL
	  records were successfully written. This patch properly clears the
	  result in the nominal code path. (closes issue ASTERISK-19991)
	  Reported by: Etienne Lessard Tested by: Etienne Lessard patches:
	  mem_leak_cel_pgsql.patch uploaded by Etienne Lessard (license
	  #6394) ........ Merged revisions 372158 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-30 20:53 +0000 [r372049-372090]  Mark Michelson <mmichelson@digium.com>

	* /, apps/app_queue.c: Prevent crash on shutdown due to refcount
	  error on queues container. When app_queue is unloaded, the queues
	  container has its refcount decremented, potentially to 0. Then
	  the taskprocessor responsible for handling device state changes
	  is unreferenced. If the taskprocessor happens to be just about to
	  run its task, then it will create and destroy an iterator on the
	  queues container. This can cause the refcount on the queues
	  container to increase to 1 and then back to 0. Going back to 0 a
	  second time results in double frees. This failure was seen
	  periodically in the testsuite when Asterisk would shut down.
	  ........ Merged revisions 372089 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_queue.c: Help prevent ringing queue members from
	  being rung when ringinuse set to no. Queue member status would
	  not always get updated properly when the member was called, thus
	  resulting in the member getting multiple calls. With this change,
	  we update the member's status at the time of calling, and we also
	  check to make sure the member is still available to take the call
	  before placing an outbound call. (closes issue ASTERISK-16115)
	  reported by nik600 Patches: app_queue.c-svn-r370418.patch
	  uploaded by Italo Rossi (license #6409) ........ Merged revisions
	  372048 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-30 16:22 +0000 [r371962-372020]  Matthew Jordan <mjordan@digium.com>

	* /, channels/chan_iax2.c: AST-2012-013: Resolve ACL rules being
	  ignored during calls by some IAX2 peers When an IAX2 call is made
	  using the credentials of a peer defined in a dynamic Asterisk
	  Realtime Architecture (ARA) backend, the ACL rules for that peer
	  are not applied to the call attempt. This allows for a remote
	  attacker who is aware of a peer's credentials to bypass the ACL
	  rules set for that peer. This patch ensures that the ACLs are
	  applied for all peers, regardless of their storage mechanism.
	  (closes issue ASTERISK-20186) Reported by: Alan Frisch Tested by:
	  mjordan, Alan Frisch ........ Merged revisions 372015 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/manager.c, /, README-SERIOUSLY.bestpractices.txt:
	  AST-2012-012: Resolve AMI User Unauthorized Shell Access through
	  ExternalIVR The AMI Originate action can allow a remote user to
	  specify information that can be used to execute shell commands on
	  the system hosting Asterisk. This can result in an unwanted
	  escalation of permissions, as the Originate action, which
	  requires the "originate" class authorization, can be used to
	  perform actions that would typically require the "system" class
	  authorization. Previous attempts to prevent this permission
	  escalation (AST-2011-006, AST-2012-004) have sought to do so by
	  inspecting the names of applications and functions passed in with
	  the Originate action and, if those applications/functions matched
	  a predefined set of values, rejecting the command if the user
	  lacked the "system" class authorization. As noted by IBM X-Force
	  Research, the "ExternalIVR" application is not listed in the
	  predefined set of values. The solution for this particular
	  vulnerability is to include the "ExternalIVR" application in the
	  set of defined applications/functions that require "system" class
	  authorization. Unfortunately, the approach of inspecting fields
	  in the Originate action against known applications/functions has
	  a significant flaw. The predefined set of values can be bypassed
	  by creative use of the Originate action or by certain dialplan
	  configurations, which is beyond the ability of Asterisk to
	  analyze at run-time. Attempting to work around these scenarios
	  would result in severely restricting the applications or
	  functions and prevent their usage for legitimate means. As such,
	  any additional security vulnerabilities, where an
	  application/function that would normally require the "system"
	  class authorization can be executed by users with the "originate"
	  class authorization, will not be addressed. Instead, the
	  README-SERIOUSLY.bestpractices.txt file has been updated to
	  reflect that the AMI Originate action can result in commands
	  requiring the "system" class authorization to be executed. Proper
	  system configuration can limit the impact of such scenarios.
	  (closes issue ASTERISK-20132) Reported by: Zubair Ashraf of IBM
	  X-Force Research ........ Merged revisions 371998 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* doc/CODING-GUIDELINES (added), /: Restore CODING-GUIDELINES to
	  doc folder In r294740, the CODING-GUIDELINES was removed from the
	  doc folder in favor of the content on the Asterisk wiki. Some
	  folks still look in the doc folder initially for coding guideline
	  suggestions; as such, this patch adds a CODING-GUIDELINES file
	  back into the doc folder. The content of the file merely points
	  to the correct page on the Asterisk wiki where the coding
	  guidelines currently live. (closes issue ASTERISK-20279) Reported
	  by: Andrew Latham Patches: CODING-GUIDELINES.diff uploaded by
	  Andrew Latham (license 5985) ........ Merged revisions 371961
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-29 20:58 +0000 [r371920]  Jonathan Rose <jrose@digium.com>

	* /, apps/app_meetme.c: app_meetme: Adding test events for
	  following activity in MeetMe. ........ Merged revisions 371919
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-29 19:40 +0000 [r371861-371890]  Richard Mudgett <rmudgett@digium.com>

	* main/channel.c, /: Initialize file descriptors for dummy channels
	  to -1. Dummy channels usually aren't read from, but functions
	  like SHELL and CURL use autoservice on the channel. (closes issue
	  ASTERISK-20283) Reported by: Gareth Palmer Patches:
	  svn-371580.patch (license #5169) patch uploaded by Gareth Palmer
	  (modified) ........ Merged revisions 371888 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/app_dial.c, /: Fix hangup cause passthrough regression. The
	  v1.8 -r369258 change to fix the F and F(x) action logic
	  introduced a regression in passing the hangup cause from the
	  called channel to the caller channel. (closes issue
	  ASTERISK-20287) Reported by: Konstantin Suvorov Patches:
	  app_dial_hangupcause.patch (license #6421) patch uploaded by
	  Konstantin Suvorov (modified) Tested by: rmudgett ........ Merged
	  revisions 371860 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-29 17:07 +0000 [r371825]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c: chan_sip: Send 408 on retransmit timeout
	  instead of 603 (closes issue ASTERISK-20124) Reported by: Walter
	  Doekes ........ Merged revisions 371824 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-27 21:49 +0000 [r371748-371789]  Mark Michelson <mmichelson@digium.com>

	* configs/agents.conf.sample, /: Fix misleading documentation in
	  agents.conf.sample regarding ackcall usage. The documentation
	  made it sound as if the DTMF acknowledgment was needed at the
	  time the agent logs in, rather than when the agent is called.
	  This is likely a relic from the days when there were multiple
	  ways of logging in agents. (closes issue AST-962) reported by
	  Steve Pitts ........ Merged revisions 371787 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/manager.c, /: Fix incorrect documentation of the
	  MailboxStatus manager command. The "Waiting" field was
	  misdocumented as reporting the number of messages waiting. In
	  reality, it simply indicated the presence or absence of waiting
	  messages. ........ Merged revisions 371782 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, configs/queues.conf.sample: Fix incorrectly documented option
	  in queues.conf sharedlastcall defaults to "no" not "yes" (closes
	  issue AST-979) reported by Steve Pitts ........ Merged revisions
	  371747 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-27 16:43 +0000 [r371719]  dlee <dlee@localhost>:

	* main/lock.c, /: Fixes ast_rwlock_timed[rd|wr]lock for BSD and
	  variants. The original implementations simply wrap pthread
	  functions, which take absolute time as an argument. The spinlock
	  version for systems without those functions treated the argument
	  as a delta. This patch fixes the spinlock version to be
	  consistent with the pthread version. (closes issue
	  ASTERISK-20240) Reported by: Egor Gorlin Patches: lock.c.patch
	  uploaded by Egor Gorlin (license 6416) ........ Merged revisions
	  371718 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-27 13:57 +0000 [r371691]  Kinsey Moore <kmoore@digium.com>

	* /, main/utils.c: Implement workaround for BETTER_BACKTRACES crash
	  When compiling with BETTER_BACKTRACES enabled, Asterisk will
	  sometimes crash when "core show locks" is run. This happens
	  regularly in the testsuite since several tests run "core show
	  locks" to help with debugging. This seems to be a fault with
	  libraries on certain operating systems (notably CentOS 6.2/6.3)
	  running on virtual machines and utilizing gcc 4.4.6. (closes
	  issue ASTERISK-20090) ........ Merged revisions 371690 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-26 23:06 +0000 [r371663]  Alec L Davis <sivad.a@paradise.net.nz>

	* main/dsp.c, /: mf_detect: incorrectly used DTMF_GSIZE instead of
	  MF_GSIZE ........ Merged revisions 371662 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-21 20:40 +0000 [r371591]  Mark Michelson <mmichelson@digium.com>

	* cdr/cdr_tds.c, main/xmldoc.c, apps/app_dial.c,
	  channels/chan_dahdi.c, /, channels/chan_sip.c, funcs/func_odbc.c,
	  main/file.c, main/utils.c, apps/app_queue.c, pbx/pbx_config.c,
	  res/res_jabber.c, apps/app_stack.c, channels/chan_oss.c,
	  res/res_config_sqlite.c: Fix misuses of asprintf throughout the
	  code. This fixes three main issues * Change asprintf() uses to
	  ast_asprintf() so that it pairs properly with ast_free() and no
	  longer causes MALLOC_DEBUG to freak out. * When ast_asprintf()
	  fails, set the pointer NULL if it will be referenced later. * Fix
	  some memory leaks that were spotted while taking care of the
	  first two points. (Closes issue ASTERISK-20135) reported by
	  Richard Mudgett Review: https://reviewboard.asterisk.org/r/2071
	  ........ Merged revisions 371590 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-20 15:27 +0000 [r371545]  Kinsey Moore <kmoore@digium.com>

	* main/udptl.c, /: Ignore recovered zero-length secondary UDPTL
	  packets In some cases, recovering lost packets using the
	  secondary packet recovery mechanism with UDPTL/T.38 can result in
	  the recovery of zero-length packets. These must be ignored or the
	  frame generated from them can cause segfaults and allocation
	  failures. (closes issue ASTERISK-19762) (closes issue
	  ASTERISK-19373) Reported-by: Benjamin (bulkorok) Reported-by: Rob
	  Gagnon (rgagnon) ........ Merged revisions 371544 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-18 02:34 +0000 [r371491-371529]  Matthew Jordan <mjordan@digium.com>

	* main/http.c: Remove old debug code from http configuration
	  loading (closes issue ASTERISK-20254) Reported by: Andrew Latham
	  Patches: http.diff uploaded by Andrew Latham (license #5985)

	* main/xmldoc.c, /: Fix memory leak in XML documentation When
	  formatting documentation fields, the XML documentation parser
	  calls xmldoc_get_formatted. This function allocates a string
	  buffer at the beginning of its routine. Unfortunately, on certain
	  code paths, it also calls xmldoc_string_cleanup, which assumes
	  that it will create the string buffer. The previously allocated
	  string buffer is then leaked by the xmldoc_string_cleanup
	  routine. Now: we don't do that. (closes issue AST-932) Reported
	  by: Alexander Homig ........ Merged revisions 371469 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-17 15:51 +0000 [r371437]  Kinsey Moore <kmoore@digium.com>

	* main/loader.c, /: Add instrumentation to subsystem reloads When
	  Asterisk is built with TEST_FRAMEWORK defined, Asterisk will now
	  generate TestEvent AMI events on subsystem reloads such as cdr,
	  dnsmgr, extconfig, etc. (issue PQ-1126) ........ Merged revisions
	  371436 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-16 22:50 +0000 [r371398]  Terry Wilson <twilson@digium.com>

	* /, main/config.c: Handle integer over/under-flow in
	  ast_parse_args The strtol family of functions will return
	  *_MIN/*_MAX on overflow. To detect when an overflow has happened,
	  errno must be set to 0 before calling the function, then checked
	  afterward. (closes issue ASTERISK-20120) Reported by: Matt Jordan
	  Review: https://reviewboard.asterisk.org/r/2073/ ........ Merged
	  revisions 371392 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-16 22:42 +0000 [r371394]  Kinsey Moore <kmoore@digium.com>

	* main/loader.c, /: Add module reload instrumentation for
	  TEST_FRAMEWORK This adds AMI events for module reloads when
	  Asterisk is built with TEST_FRAMEWORK enabled and corrects
	  generation of the module load AMI event. (issue PQ-1126) ........
	  Merged revisions 371393 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-16 19:05 +0000 [r371338-371358]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c: chan_sip: Use pvt outgoing_call variable
	  to set Remote-Party-ID Header Previously the pvt SIP_OUTGOING
	  flag was used instead, which will frequently flip during
	  reinvites. (closes issue AST-897) Reported by: Thomas Arimont
	  ........ Merged revisions 371357 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: chan_sip: Trigger reinvite if the SDP
	  answer is included in the SIP ACK Under certain conditions, a SIP
	  transaction involving directmedia wouldn't trigger a re-invite
	  because the SDP answer was included in an ACK instead of in a
	  message that we would have triggered the invite with. This patch
	  just queues a source change control frame if the dialog is using
	  directmedia when we find sdp for an ACK. (closes issue AST-913)
	  Reported by: Thomas Arimont ........ Merged revisions 371337 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-15 23:19 +0000 [r371313]  Mark Michelson <mmichelson@digium.com>

	* /, apps/app_queue.c: Fix bug where final queue member would not
	  be removed from memory. If a static queue had realtime members,
	  then there could be a potential for those realtime members not to
	  be properly deleted from memory. If the queue's members were
	  loaded from realtime and then all the members were deleted from
	  the backend, then the queue would still think these members
	  existed. The reason was that there was a short- circuit in code
	  such that if there were no members found in the backend, then the
	  queue would not be updated to reflect this. Note that this only
	  affected static queues with realtime members. Realtime queues
	  with realtime members were unaffected by this issue. (closes
	  issue ASTERISK-19793) reported by Marcus Haas ........ Merged
	  revisions 371306 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-15 20:15 +0000 [r371271]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_sip.c: Avoid unconditional NULLing of mwipvt on
	  relatedpeer on SIP dialog destruction The other instance of this
	  bug was fixed by jcolp/file in r121496. If we are destroying a
	  dialog only set the MWI dialog pointer on the related peer to
	  NULL if it is the dialog currently being destroyed. (closes issue
	  ASTERISK-20119) Patch-by: Misha Vodsedalek ........ Merged
	  revisions 371270 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-15 01:43 +0000 [r371250-371251]  Michael L. Young <elgueromexicano@gmail.com>

	* channels/chan_sip.c: Reverting this change that was meant for
	  branch 11. (issue ASTERISK-20221)

	* channels/chan_sip.c: Fix Segfault When Registering SIP Over
	  WebSockets The helper function, get_address_family_filter, in
	  chan_sip for dns resolution by address family was not recognizing
	  the websockets transport and resulting in a null pointer being
	  sent to functions in netsock2, in an attempt to determine if we
	  are bound to ANY address ([::]) or not. This patch fixes this
	  issue by handling the transport types SIP_TRANSPORT_WS and
	  SIP_TRANSPORT_WSS which results in a sock address being set
	  properly for use in determining the address family. (closes issue
	  ASTERISK-20221) Reported by: Sven Beisiegel Tested by: Sven
	  Beisiegel, James Mortensen Patches:
	  asterisk-20221-ws-family-filter.diff uploaded by Michael L. Young
	  (license 5026)

2012-08-13 20:04 +0000 [r371203]  Kinsey Moore <kmoore@digium.com>

	* main/loader.c, /, apps/app_meetme.c: Add test instrumentation
	  This adds test instrumentation for loading and unloading of
	  modules and for certain actions in MeetMe to be used in the
	  testsuite or any other consumer of AMI events. These will only be
	  generated when Asterisk is built with TEST_FRAMEWORK enabled.
	  (issue PQ-1131) (issue PQ-1133) ........ Merged revisions 371201
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-13 19:51 +0000 [r371199]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Fix problem where incorrect pointer was
	  checked for nullity. ........ Merged revisions 371198 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-10 21:23 +0000 [r371142]  Mark Michelson <mmichelson@digium.com>

	* /, apps/app_queue.c: Fix a couple of documentation problems in
	  app_queue.c * The RemoveQueueMember app made mention of options
	  that could be passed in, but no options are supported. I have
	  removed the listing of options from the documentation. * The
	  RQMSTATUS variable did not list "NOTDYNAMIC" as a possible value
	  that could be set. (closes issue AST-949) reported by Steve Pitts
	  (closes issue AST-954) reported by Steve Pitts ........ Merged
	  revisions 371141 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-10 16:46 +0000 [r371022-371090]  Alexandr Anikin <may@telecom-service.ru>

	* addons/chan_ooh323.c, /: remove ALREADYGONE flag on ooh323 call
	  data by ooh323_indicate (CONGESTION/BUSY) due to call hasn't gone
	  there really. This indication arrive from asterisk core not h.323
	  stack (closes issue ASTERISK-19308) Reported by: Dmitry Melekhov
	  Patches: ASTERISK-19308.patch ........ Merged revisions 371089
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* addons/ooh323c/src/ooGkClient.c, /: Send re-register packets by
	  GRQ (gatekeeper request) interval (close issue ASTERISK-20094)
	  Patches: ASTERISK-20094-2.patch ........ Merged revisions 371060
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* addons/ooh323c/src/ooGkClient.c, /: Fix to resend GRQ/RRQ if RRJ
	  (registration reject) is received (close issue ASTERISK-20094)
	  Patches: ASTERISK-20094.patch ........ Merged revisions 371011
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-09 19:11 +0000 [r371013]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c, /, configure,
	  include/asterisk/autoconfig.h.in, configure.ac,
	  channels/sig_pri.c, channels/sig_ss7.c: Use better libss7
	  detection test and move libpri compile test. ........ Merged
	  revisions 371012 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-09 18:05 +0000 [r370989]  Alexandr Anikin <may@telecom-service.ru>

	* /, addons/ooh323c/src/ooh323ep.c: change opening h323 logfile
	  with append mode instead of overwrite ........ Merged revisions
	  370988 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-09 17:39 +0000 [r370986]  Kinsey Moore <kmoore@digium.com>

	* /, apps/app_meetme.c: Correct documentation for the MeetMe x flag
	  The documentation for the x flag for MeetMe incorrectly described
	  its function as closing down the conference when the last marked
	  user left. It actually causes the users with that flag to leave
	  the conference when the last marked user exits. The functionality
	  of this flag is not changing. ........ Merged revisions 370985
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-08 22:42 +0000 [r370954]  Michael L. Young <elgueromexicano@gmail.com>

	* /, apps/app_chanspy.c: Fix Not Unreferencing A Spied Channel When
	  a channel hangs up while being spied upon and the option to exit
	  the ChanSpy application when the spied on channel hangs up is
	  set, ast_autochan_destroy is not being called and therefore a
	  reference to the spied upon channel is not removed. The symptom
	  being reported was that when using func_group in the dialplan and
	  calling "group show channels" at the cli, the spied upon channel
	  was still being shown while "core show channels" showed that the
	  channel was not up. This patch calls ast_autochan_destroy when a
	  spied upon channel hangs up and the option to exit the ChanSpy
	  application is set, removing the reference to the channel
	  allowing the count for the group that the spied channel was part
	  of to be decremented. (closes issue ASTERISK-17515) Reported by:
	  Arkadiusz Malka Tested by: Alexandr Gordeev, Michael L. Young
	  Patches: asterisk-17515-destroy-autochan.diff uploaded by Michael
	  L. Young (license 5026) ........ Merged revisions 370952 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-08 20:29 +0000 [r370924]  Kinsey Moore <kmoore@digium.com>

	* main/channel.c, /: Do not define a cause that doesn't actually
	  exist AST_CAUSE_NOTDEFINED is a placeholder for usage when there
	  is no cause information. As such, it should not be defined and
	  translatable as a cause. ........ Merged revisions 370923 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-08 20:04 +0000 [r370901]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c, channels/sig_analog.c, /,
	  channels/sig_analog.h: Fix the analog dial *0 flash-hook of
	  bridged peer feature. The flash-hook the bridged peer feature now
	  correctly determines if the bridged peer is another chan_dahdi
	  channel, that it is an analog channel, and that it has the
	  correct signaling for an FXO port. It now also flash-hooks the
	  correct channel. ........ Merged revisions 370900 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-07 19:21 +0000 [r370858]  Kinsey Moore <kmoore@digium.com>

	* main/channel.c, /: Add missing AST_CAUSE_* -> text translations
	  ........ Merged revisions 370856 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-06 15:02 +0000 [r370798]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Improve debug message for temporary
	  outbound proxies. Thanks to Paul Belanger for pointing this out.
	  ........ Merged revisions 370797 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-03 21:50 +0000 [r370772]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c, channels/sip/config_parser.c,
	  channels/sip/include/sip.h: Multiple revisions 370769-370771
	  ........ r370769 | mmichelson | 2012-08-03 16:35:00 -0500 (Fri,
	  03 Aug 2012) | 24 lines Fix error in the "IPorHost" section of a
	  SIP dialstring. This is based on the review request posted by
	  Walter Doekes (referenced lower in the commit message) The main
	  fix here is to treat the IPorHost portion of the dial string as a
	  temporary outbound proxy. This ensures requests get sent to the
	  proper location. Due to the age of the request, some parts were
	  no longer relevant. For instance, the request moved outbound
	  proxy parsing code into a single method. This is done in a
	  previous commit, so it was not necessary to do again. Also, the
	  review request fixed some errors with regards to request routing
	  for CANCEL and ACK requests. This has also been fixed in more
	  recent commits. (closes issue ASTERISK-19677) reported by Walter
	  Doekes Review https://reviewboard.asterisk.org/r/1859 ........
	  r370770 | mmichelson | 2012-08-03 16:39:35 -0500 (Fri, 03 Aug
	  2012) | 3 lines Remove unused variable. ........ r370771 |
	  mmichelson | 2012-08-03 16:43:52 -0500 (Fri, 03 Aug 2012) | 5
	  lines Seriously? Another compilation error fixed. Somebody beat
	  me. ........ Merged revisions 370769-370771 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-08-01 02:26 +0000 [r370698]  Kinsey Moore <kmoore@digium.com>

	* /, utils/extconf.c: Revert alloca changes for utils These changes
	  were a tad overzealous in the utils directory. Unfortunately,
	  these don't compile with a "make". ........ Merged revisions
	  370697 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-31 21:19 +0000 [r370672]  Matthew Jordan <mjordan@digium.com>

	* /, channels/chan_sip.c: Schedule pokes of registered SIP peers
	  within a given timespan after SIP reload With a large number of
	  SIP peers registered, performing a SIP reload causes a flood of
	  SIP OPTIONS request packets. These are immediately sent out, and,
	  as responses come back, can cause peers to be flagged as 'lagged'
	  due to handling of the many response messages. This fix prevents
	  this "packet storm" and schedules the pokes for a random time.
	  That time varies between 1 ms and the peer's qualify time, or, if
	  the qualify time is unknown, the global qualifyfreq setting. The
	  committed patch has some very small modifications to the patch
	  schmidts wrote for the review. (closes issue ASTERISK-19154)
	  Reported by: Nicolo Mazzon patches: issue19154.patch license
	  #6034 uploaded by schmidts Review:
	  https://reviewboard.asterisk.org/r/1652 ........ Merged revisions
	  370666 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-31 19:57 +0000 [r370643]  Kinsey Moore <kmoore@digium.com>

	* apps/app_while.c, include/asterisk/utils.h, main/pbx.c,
	  res/res_config_pgsql.c, channels/chan_sip.c, apps/app_festival.c,
	  pbx/pbx_lua.c, funcs/func_cut.c, tests/test_linkedlists.c,
	  apps/app_getcpeid.c, funcs/func_global.c, channels/chan_jingle.c,
	  main/tcptls.c, funcs/func_channel.c, apps/app_directed_pickup.c,
	  main/callerid.c, main/file.c, apps/app_macro.c, main/astmm.c,
	  apps/app_sms.c, main/event.c, pbx/pbx_dundi.c,
	  include/asterisk/strings.h, utils/extconf.c,
	  apps/app_mixmonitor.c, main/asterisk.c, main/dsp.c,
	  addons/res_config_mysql.c, apps/app_voicemail.c,
	  addons/app_mysql.c, /, apps/app_meetme.c, apps/app_dictate.c,
	  main/say.c, main/threadstorage.c, funcs/func_strings.c,
	  main/utils.c, funcs/func_logic.c, channels/chan_gtalk.c,
	  cdr/cdr_pgsql.c, channels/chan_iax2.c, res/res_jabber.c,
	  main/config.c, main/channel.c, res/ael/pval.c,
	  apps/app_osplookup.c, main/manager.c, pbx/pbx_spool.c,
	  main/strcompat.c, apps/app_minivm.c, main/features.c,
	  res/res_agi.c, main/http.c, main/logger.c, pbx/pbx_ael.c,
	  main/app.c, channels/chan_alsa.c, pbx/pbx_realtime.c,
	  addons/chan_mobile.c, main/db.c: Clean up and ensure proper usage
	  of alloca() This replaces all calls to alloca() with ast_alloca()
	  which calls gcc's __builtin_alloca() to avoid BSD semantics and
	  removes all NULL checks on memory allocated via ast_alloca() and
	  ast_strdupa(). (closes issue ASTERISK-20125) Review:
	  https://reviewboard.asterisk.org/r/2032/ Patch-by: Walter Doekes
	  (wdoekes) ........ Merged revisions 370642 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-31 15:31 +0000 [r370619]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c, configs/sip.conf.sample,
	  channels/sip/include/sip.h: Help mitigate potential reinvite
	  glare scenarios. When Asterisk servers are set up back-to-back,
	  and direct media is to be used betweeen endpoints, it is fairly
	  common for the two Asterisk servers to send direct media
	  reinvites to each other simultaneously. This results in 491s and
	  ACKs being exchanged between the servers. While the media
	  eventually gets set up properly, the problem is that there can be
	  a noticeable delay for the streams to stabilize. This patch adds
	  a new directmedia option called "outgoing". With this set, an
	  immediate direct media reinvite will only be sent if the call
	  direction is outgoing. For incoming dialogs, an immediate direct
	  media reinvite will not be sent, but further "reactionary" direct
	  media reinvites may be sent. For those who are having some deja
	  vu, that's because this patch was originally committed to trunk
	  since there is a new configuration option added. After seeing a
	  bug report about audio being slow to set up on SIP calls, it
	  became apparent that this patch would be the best solution for
	  resolving the issue. The patch is unintrusive and will have no
	  effect unless the option is explicitly enabled. (closes issue
	  AST-896) reported by Thomas Arimont (closes issue ASTERISK-19857)
	  reported by Matt Jordan ........ Merged revisions 370618 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-09-13  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.8.0 Released.

2012-09-11  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.8.0-rc2 Released.

	* AST-2012-013: Resolve ACL rules being ignored during calls by some
	  IAX2 peers

	* AST-2012-012: Resolve AMI User Unauthorized Shell Access through
	  ExternalIVR

	* r371861: Fix hangup cause passthrough regression.

	  The v1.8 -r369258 change to fix the F and F(x) action logic
	  introduced a regression in passing the hangup cause from the called
	  channel to the caller channel.

	  (closes issue ASTERISK-20287)
	  Reported by: Konstantin Suvorov
	  Patches:
	      app_dial_hangupcause.patch (license #6421) patch uploaded by
	      Konstantin Suvorov (modified)
	      Tested by: rmudgett

	* r372710: Only re-create an SRTP session when needed; respond with
	  correct crypto policy

	  In r356604, SRTP handling was fixed to accomodate multiple crypto
	  keys in an SDP offer and the ability to re-create an SRTP session
	  when the crypto keys changed. In certain circumstances - most
	  notably when a phone is put on hold after having been bridged for a
	  significant amount of time - the act of re-creating the SRTP session
	  causes problems for certain models of	phones.	The patch committed in
	  r356604 always re-created the SRTP session regardless	of whether or
	  not the cryptographic keys changed. Since this is technically
	  not necessary, this patch modifies the behavior to only re-create the
	  SRTP session if Asterisk detects that the remote key has changed.
	  This allows models of phones that do not handle the SRTP session
	  changing to continue to work, while also providing the behavior
	  needed for those phones that do re-negotiate cryptographic keys.

	  (issue ASTERISK-20194)
	  Reported by: Nicolo Mazzon
	  Tested by: Nicolo Mazzon

	  Review: https://reviewboard.asterisk.org/r/2099

	* r372841: Fix bad channel application data reference.

	  When channels get bridged due to an AMI bridge action
	  or a DTMF attended transfer, the two channels that
	  get bridged have their application data pointing to
	  the other channel's name. This means that if one channel
	  is hung up but the other moves on, it means that the
	  channel that moves on will have its application data
	  pointing at freed memory.

	  (issue ASTERISK-20335)

2012-07-31  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.8.0-rc1 Released.

2012-07-30 16:49 +0000 [r370564]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_misdn.c, /: Release B channel allocation on error
	  path in chan_misdn. ........ Merged revisions 370563 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-30 14:50 +0000 [r370547]  Jonathan Rose <jrose@digium.com>

	* apps/app_meetme.c: app_meetme: Change app_meetme support level to
	  extended from deprecated (closes issue ASTERISK-20134) Reported
	  by: Leif Madsen

2012-07-25 21:12 +0000 [r370495]  Jonathan Rose <jrose@digium.com>

	* /, res/res_agi.c: res_agi: Add message indicating need for \n
	  character in verbose message The while loop responsible for
	  reading AGI messages from a fastAGI service can end up looping
	  indefinitely when an AGI script fails to indicate the end of a
	  message with a \n character. This patch adds an indication that
	  we are expecting a \n character to end the message to make it
	  more clear to users that this is necessary if they are receiving
	  this warning over and over. (issue ASTERISK-20061) Reported by:
	  Eike Kuiper ........ Merged revisions 370494 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-24 17:08 +0000 [r370432]  Tzafrir Cohen <tzafrir.cohen@xorcom.com>

	* /, channels/chan_oss.c: chan_oss: fix "sample rate" error message
	  Merged revisions 370428 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-24 16:54 +0000 [r370361-370430]  Kevin P. Fleming <kpfleming@digium.com>

	* main/frame.c, /: Rewrite a comment that didn't adequately explain
	  the code it was documenting. ........ Merged revisions 370429
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, funcs/func_shell.c: Improve documentation for the SHELL()
	  dialplan function. ........ Merged revisions 370383 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/channel.c, /: Free any datastores attached to dummy
	  channels. Revision 370205 added the use of a datastore attached
	  to a dummy channel to resolve a memory leak, but
	  ast_dummy_channel_destructor() in this branch did not free
	  datastores, resulting in a continued (but slightly smaller)
	  memory leak. This patch backports the change to free said
	  datastores from the Asterisk trunk. (related to issue AST-916)
	  ........ Merged revisions 370360 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-19 22:11 +0000 [r370277]  Richard Mudgett <rmudgett@digium.com>

	* /, main/cel.c: Fix compiler warnings. gcc (GCC) 4.2.4 has
	  problems casting away constness. ........ Merged revisions 370275
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-19 22:01 +0000 [r370271-370274]  Matthew Jordan <mjordan@digium.com>

	* /, main/cel.c: Fix compilation error when MALLOC_DEBUG is enabled
	  To fix a memory leak in CEL, a channel datastore was introduced
	  whose destruction function pointer was pointed to the ast_free
	  macro. Without MALLOC_DEBUG enabled this compiles as fine, as
	  ast_free is defined as free. With MALLOC_DEBUG enabled, however,
	  ast_free takes on a definition from a different place then
	  utils.h, and became undefined. This patch resolves this by using
	  a reference to ast_free_ptr. When MALLOC_DEBUG is enabled, this
	  calls ast_free; when MALLOC_DEBUG is not enabled, this is defined
	  to be ast_free, which is defined to be free. (issue AST-916)
	  Reported by: Thomas Arimont ........ Merged revisions 370273 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* res/res_rtp_asterisk.c, /: Handle extremely out of order RFC 2833
	  DTMF The current implementation of RFC 2833 DTMF handling in
	  res_rtp_asterisk will, if a packet arrives out of order, drop the
	  packet. This is to prevent duplicate ton generation in the
	  Asterisk core. Since the RTP layer does not buffer data itself,
	  this is the only option the RTP layer currently has for handling
	  packets that arrive out of order. For the most part, this doesn't
	  matter. For a particular digit, so long as a BEGIN packet arrives
	  before the first END packet, the digit will be produced. If
	  subsequent BEGIN packets arrive interleaved with the ENDs, they
	  will be dropped; likewise, if the BEGIN or END packets themselves
	  are out of order, those packets are dropped but sufficient
	  information is conveyed to the Asterisk core to produce the
	  appropriate digit. For certain sequences of DTMF packets - most
	  notably when, for a particular digit, an END packet arrives
	  before any BEGIN packet for that digit - this is a real problem.
	  When an END arrives before any BEGINs, the END packet is dropped
	  - but at the same time, it causes subsequent BEGIN packets for
	  that digit to be ignored. When the next in order END packet
	  arrives, it too is dropped - Asterisk believes that there was no
	  initial BEGIN. The solution this patch provides is to trust the
	  END packet to convey the information needed for the Asterisk core
	  to produce the DTMF digit. If we receive an END packet, and it: *
	  Has a timestamp greater then the last timestamp received from an
	  END packet * Does not have the same sequence number as the last
	  received sequence number (and is thus not an END packet
	  retransmission) Then we send the END frame up to the Asterisk
	  core. It contains enough DTMF information for Asterisk to produce
	  the digit. On the other hand, if we receive a BEGIN or
	  continuation packet that occurs with a timestamp equal to or less
	  then the last END timestamp, then we've received something out of
	  order - but we already have received enough information to
	  produce the digit. These packets are dropped. Much thanks goes to
	  Olle Johansson (oej) for providing the idea for this solution.
	  Review: https://reviewboard.asterisk.org/r/2033/ (issue
	  ASTERISK-18404) Reporter: Stephane Chazelas Tested by: Matt
	  Jordan ........ Merged revisions 370252 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-18 19:14 +0000 [r370184-370206]  Kevin P. Fleming <kpfleming@digium.com>

	* /, main/cel.c: Resolve severe memory leak in CEL logging modules.
	  A customer reported a significant memory leak using Asterisk 1.8.
	  They have tracked it down to
	  ast_cel_fabricate_channel_from_event() in main/cel.c, which is
	  called by both in-tree CEL logging modules (cel_custom.c and
	  cel_sqlite3_custom.c) for each and every CEL event that they log.
	  The cause was an incorrect assumption about how data attached to
	  an ast_channel would be handled when the channel is destroyed;
	  the data is now stored in a datastore attached to the channel,
	  which is destroyed along with the channel at the proper time.
	  (closes issue AST-916) Review:
	  https://reviewboard.asterisk.org/r/2053/ ........ Merged
	  revisions 370205 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/channel.c, addons/app_mysql.c, main/pbx.c,
	  funcs/func_curl.c, /, main/ccss.c, funcs/func_odbc.c,
	  funcs/func_lock.c, apps/app_macro.c, channels/chan_iax2.c,
	  apps/app_mixmonitor.c, apps/app_stack.c, funcs/func_global.c,
	  res/res_odbc.c: Ensure that all ast_datastore_info structures are
	  'const'. While addressing a bug, I came across a instance of
	  'struct ast_datastore_info' that was not declared 'const'. Since
	  the API already expects them to be 'const', this patch changes
	  the declarations of all existing instances that were not already
	  declared that way. ........ Merged revisions 370183 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-16 19:52 +0000 [r370132]  Walter Doekes <walter+asterisk@wjd.nu>

	* /, channels/chan_sip.c: Code cleanup and bugfix in chan_sip
	  outboundproxy parsing. The bug was clearing the global
	  outboundproxy when a peer-specific outboundproxy was bad. The
	  cleanup reduces duplicate code. Review:
	  https://reviewboard.asterisk.org/r/2034/ Reviewed by: Mark
	  Michelson ........ Merged revisions 370131 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-16 13:51 +0000 [r370082]  Kinsey Moore <kmoore@digium.com>

	* /, UPGRADE.txt, CHANGES, UPGRADE-1.8.txt: Add comments about the
	  BUILD_NATIVE change This is a significant change and mention of
	  it should have gone into UPGRADE.txt and CHANGES. ........ Merged
	  revisions 370081 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-12 20:20 +0000 [r370025]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c, channels/sig_analog.c, /: Add missing
	  ast_hangup() calls on some analog exception paths. Make starting
	  analog_ss_thread() or __analog_ss_thread() failure paths hangup
	  the channel. ........ Merged revisions 370017 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-12 20:05 +0000 [r369994-370015]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_sip.c: Include Expires header for SIP PUBLISH
	  requests RFC3903 requres SIP PUBLISH requests to have Expires
	  headers, so add them. Review:
	  https://reviewboard.asterisk.org/r/2003/ Patch-by: gareth
	  ........ Merged revisions 370014 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Prevent double uri_escaping in chan_sip
	  when pedantic is enabled If pedantic mode is enabled, outbound
	  invites will have double-escaped contacts. This avoids setting an
	  already-escaped string into a field where it is expected to be
	  unescaped. (closes issue ASTERISK-20023) Reported-by: Walter
	  Doekes ........ Merged revisions 369993 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-12 14:25 +0000 [r369971]  Michael L. Young <elgueromexicano@gmail.com>

	* /, funcs/func_math.c: Correct Documentation For DEC Function The
	  documentation for DEC in func_math.c was incorrect. Looks like a
	  copy and paste error. (Closes issue ASTERISK-20095) Reported by:
	  Billy Chia Tested by: Michael L. Young Patches: func_math.patch
	  uploaded by Billy Chia (license 6381) ........ Merged revisions
	  369970 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-11 17:12 +0000 [r369938]  Tilghman Lesher <tilghman@meg.abyt.es>

	* funcs/func_realtime.c, /: Allow the REALTIME() function to report
	  errors back to the caller. Also, do more error checking on the
	  arguments specified to the REALTIME() function and clarify the
	  documentation. While I was editing the file, a few coding
	  guidelines fixups, as well. Review:
	  https://reviewboard.asterisk.org/r/2031/ ........ Merged
	  revisions 369937 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-30  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.7.0 Released.

2012-07-11  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.7.0-rc1 Released.

2012-07-10 13:35 +0000 [r369871]  Kinsey Moore <kmoore@digium.com>

	* main/pbx.c, /, apps/app_stack.c: Improve Goto and GotoIf related
	  documentation Correct documentation on labeliftrue and
	  labeliffalse parameters of GotoIf() and update several other
	  locations that use the same syntax. (closes issue ASTERISK-20007)
	  Patch-by: Leif Madsen Reported-by: WIMPy ........ Merged
	  revisions 369869 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-09 17:06 +0000 [r369819]  Jason Parker <jparker@digium.com>

	* configs/sip_notify.conf.sample, /: Add Digium phones context to
	  sip_notify sample config. This makes it so that they can be
	  reconfigured remotely. (closes issue ASTERISK-19910) ........
	  Merged revisions 369818 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-09 14:43 +0000 [r369793]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c: chan_sip: Fix small behavioral change
	  accidentally introduced in r369750 When removing the warning for
	  AST_CONTROL_FLASH from sip_indicate, I also inadvertently changed
	  the return value, which would likely make the indication not be
	  sent in audio. This fixes that while still removing the warning
	  message. ........ Merged revisions 369792 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-06 21:02 +0000 [r369751]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c: chan_sip: Add case for FLASH control
	  frames so that we don't display a warning. chan_sip channels can
	  receive flash control frames when connected to analog phones and
	  possibly for other reasons. There really isn't a reason to warn
	  when these frames are received, we can safely ignore them.
	  Patches: dahdi_sip_flash.diff uploaded by Jonathan Rose (license
	  6182) ........ Merged revisions 369750 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-06 18:47 +0000 [r369709-369732]  Mark Michelson <mmichelson@digium.com>

	* main/tcptls.c, /: Remove a superfluous and dangerous freeing of
	  an SSL_CTX. The problem here is that multiple server sessions
	  share a SSL_CTX. When one session ended, the SSL_CTX would be
	  freed and set NULL, leaving the other sessions unable to
	  function. The code being removed is superfluous because the
	  SSL_CTX structures for servers will be properly freed when
	  ast_ssl_teardown is called. (closes issue ASTERISK-20074)
	  Reported by Trevor Helmsley Patches: ASTERISK-20074.diff uploaded
	  by Mark Michelson (license #5049) Testers: Trevor Helmsley
	  ........ Merged revisions 369731 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/bridging.c: Fix bridging thread leak. The bridge thread
	  was exiting but was never being reaped using pthread_join(). This
	  has been fixed now by calling pthread_join() in
	  ast_bridge_destroy(). (closes issue ASTERISK-19834) Reported by
	  Marcus Hunger Review: https://reviewboard.asterisk.org/r/2012
	  ........ Merged revisions 369708 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-05 19:12 +0000 [r369653]  Kinsey Moore <kmoore@digium.com>

	* apps/app_voicemail.c, /: AST-2012-011: Resolve heap corruption
	  issue with voicemail The heard and deleted arrays in the
	  voicemail state structure were not handled properly following the
	  memory leak fix in r354890 and a fix for an invalid free in
	  r356797. This could result in accessing and writing into freed
	  memory. The allocation for these arrays has been reworked to
	  avoid the possibility of invalid frees, access of freed memory,
	  and crashes that were occurring as a result of this. Locking
	  around accesses and modifications of the voicemail state
	  structure members dh_arraysize, heard, and deleted has been added
	  to prevent simultaneous modification and access when IMAP storage
	  is in use. If IMAP storage is not in use, this locking is not
	  compiled in. Review: https://reviewboard.asterisk.org/r/1994/
	  (closes issue ASTERISK-19923) Reported by: Dan Delaney Tested by:
	  Dan Delaney, Julian Yap Patches: vm_alloc_fix.diff uploaded by
	  kmoore (license 6273) ........ Merged revisions 369652 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-05 17:02 +0000 [r369627]  Matthew Jordan <mjordan@digium.com>

	* /, channels/chan_sip.c: Do not send a BYE when a provisional
	  response arrives during a re-INVITE Commits r369557 and r369579
	  were done to improve handling of re-INVITEs when the UA that was
	  supposed to receive the re-INVITE fails to respond. A limitation
	  of those patches occurred when a UA sent a provisional response
	  to the re-INVITE. This triggered a sending of a BYE in
	  check_pending. This patch tweaks the handling of the re-INVITE
	  such that a BYE is not sent in response to those messages. (issue
	  ASTERISK-19992) Reported by: Steve Davies Tested by: Steve Davies
	  patches: (reinvite_tweak.diff license #5012 by Steve Davies)
	  ........ Merged revisions 369626 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-03 17:02 +0000 [r369558-369580]  Terry Wilson <twilson@digium.com>

	* /, channels/chan_sip.c: More improvements to re-INVITEs timing
	  out after a provisional response There is no need to call
	  check_pendings() on a final response to an INVITE when destroying
	  the scheduler entry as it will be done later during normal
	  processing. (issue ASTERISK-19992) ........ Merged revisions
	  369579 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c, channels/sip/include/sip.h: Better handle
	  re-INVITEs with provisional but no final repsonses A previous
	  attempt at fixing this issue had negative side effects related to
	  attended transfers which this patch should resolve. Many thanks
	  to Steve Davies for all of the good suggestions and testing.
	  (closes issue ASTERISK-19992) Reported by: Steve Davies Tested
	  by: Steve Davies, Terry Wilson Review:
	  https://reviewboard.asterisk.org/r/2009/ ........ Merged
	  revisions 369557 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-29 20:28 +0000 [r369511]  Mark Michelson <mmichelson@digium.com>

	* main/rtp_engine.c: Fix apparent copy and paste error where
	  incorrect "glue" is used.

2012-06-29 16:54 +0000 [r369472-369491]  Joshua Colp <jcolp@digium.com>

	* /, channels/chan_sip.c: With some configurations a transport is
	  not actually specified so assume UDP in these cases. ........
	  Merged revisions 369490 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Make the address family filter specific
	  to the transport. (closes issue ASTERISK-16618) Reported by: Leif
	  Madsen Review: https://reviewboard.asterisk.org/r/1667/ ........
	  Merged revisions 369471 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-27 21:10 +0000 [r369437]  Terry Wilson <twilson@digium.com>

	* /, channels/chan_sip.c, channels/sip/include/sip.h: AST-2012-010:
	  Clean up after a reinvite that never gets a final response The
	  basic problem is that if a re-INVITE is sent by Asterisk and it
	  receives a provisional response, but no final response, then the
	  dialog is never torn down. In addition to leaking memory, this
	  also leaks file descriptors and will eventually lead to Asterisk
	  no longer being able to process calls. This patch just keeps
	  track of whether there is an outstanding re-INVITE, and if there
	  is goes ahead and cleans up everything as though there was no
	  outstanding reinvite. Review:
	  https://reviewboard.asterisk.org/r/2009/ (closes issue
	  ASTERISK-19992) Reported by: Steve Davies Tested by: Steve
	  Davies, Terry Wilson ........ Merged revisions 369436 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-26 13:22 +0000 [r369369-369391]  Matthew Jordan <mjordan@digium.com>

	* /, main/adsi.c: Fix crash in unloading of res_adsi module When
	  res_adsi is unloaded, it removes the ADSI functions that it
	  previously installed by passing a NULL adsi_funcs pointer to
	  ast_adsi_install_funcs. This function was not checking whether or
	  not the adsi_funcs pointer passed in was NULL before
	  dereferencing it to check whether or not the version of the
	  functions matches what the core was expecting it. This patch
	  makes it so that the version is only checked if a potentially
	  valid adsi_funcs pointer was passed in. Passing in NULL removes
	  the installed functions, bypassing the version check. ........
	  Merged revisions 369390 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/cdr.c, /: Fix incorrect duration reporting in CDRs created
	  in batch mode Certain places in core/cdr.c would, if the duration
	  value were 0, calculate the duration as being the delta between
	  the current time and the time at which the CDR record was
	  started. While this does not typically cause a problem in
	  non-batch mode, this can cause an issue in batch mode where CDR
	  records are gathered and written long after those calls have
	  ended. In particular, this affects calls that were never
	  answered, as those are expected to have a duration of 0. Often,
	  this would result in CDR logs with a significant number of calls
	  with lengthy durations, but dispositions of "BUSY". Note that
	  this does not affect cdr_csv, as that backend does not use
	  ast_cdr_getvar and instead directly reports the duration value.
	  The affected core backends include cdr_apative_odbc and
	  cdr_custom; other extended or deprecated CDR backends may
	  potentially still directly manipulate the duration values. (issue
	  ASTERISK-19860) Reported by: Thomas Arimont (issue AST-883)
	  Reported by: Thomas Arimont Tested by: Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/1996/ ........ Merged
	  revisions 369351 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-25 19:16 +0000 [r369353]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c, channels/sip/include/sip.h: Re-fix how
	  local tag is generated when sending a 481 to an INVITE. Match our
	  local tag to whatever to-tag was sent in the initial INVITE.
	  Because the size of the to-tag may not fit in the buffer in the
	  sip_pvt, it has been changed to a string field. (closes issue
	  ASTERISK-19892) reported by Walter Doekes Review:
	  https://reviewboard.asterisk.org/r/1977 ........ Merged revisions
	  369352 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-25 15:59 +0000 [r369328]  Richard Mudgett <rmudgett@digium.com>

	* /, main/features.c: Fix Bridge application occasionally returning
	  to the wrong location. * Fix do_bridge_masquerade() getting the
	  resume location from the zombie channel. The code must not touch
	  a clone channel after it has masqueraded it. The clone channel
	  has become a zombie and is starting to hangup. (closes issue
	  ASTERISK-19985) Reported by: jamicque Patches:
	  jira_asterisk_19985_v1.8.patch (license #5621) patch uploaded by
	  rmudgett Tested by: jamicque ........ Merged revisions 369327
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-25 15:52 +0000 [r369303-369325]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/adsi.h, /, main/Makefile, res/res_adsi.c,
	  main/adsi.c (added), res/res_adsi.exports.in (removed): Multiple
	  revisions 369323-369324 ........ r369323 | mmichelson |
	  2012-06-25 10:35:43 -0500 (Mon, 25 Jun 2012) | 9 lines Eliminate
	  embedding of res_adsi.so module. The way this is done is to stop
	  using the optional API. Instead, res_adsi.so, when loaded fills
	  in a table of function pointers. Review:
	  https://reviewboard.asterisk.org/r/1991 ........ r369324 |
	  mmichelson | 2012-06-25 10:50:17 -0500 (Mon, 25 Jun 2012) | 2
	  lines Forgot to svn add this file in my last commit. ........
	  Merged revisions 369323-369324 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Be more consistent with the return code
	  for requests received from invalid domain. When Asterisk receives
	  an INVITE from an external domain when allowexternaldomains=no
	  send a 403 instead of a 404. This is consistent with Asterisk's
	  behavior when receiving a REGISTER in this situation. (Closes
	  issue ASTERISK-19601) Reported by Matthew Jordan Patches:
	  ASTERISK-19601-no401.patch uploaded by Mark Michelson (License
	  #5049) ........ Merged revisions 369302 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-23 00:12 +0000 [r369236-369283]  Richard Mudgett <rmudgett@digium.com>

	* /, main/features.c: Fix Bridge application and AMI Bridge action
	  error handling. * Fix AMI Bridge action disconnecting the AMI
	  link on error. * Fix AMI Bridge action and Bridge application not
	  checking if their masquerades were successful. * Fix Bridge
	  application running the h-exten when it should not. * Made
	  do_bridge_masquerade() return if the masquerade was successful so
	  the Bridge application and AMI Bridge action could deal with it
	  correctly. * Made bridge_call_thread_launch() hangup the passed
	  in channels if the bridge_call_thread fails to start. Those
	  channels would have been orphaned. * Made builtin_atxfer() check
	  the success of the transfer masquerade setup. ........ Merged
	  revisions 369282 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_queue.c: Explicitly check caller hangup in app Queue
	  rather than a polluted res2 value. ........ Merged revisions
	  369262 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/app_dial.c, /: Check if PBX was started and fix F and F(x)
	  action logic in Dial application. ........ Merged revisions
	  369258 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/ccss.c: Check if PBX was started for generic CCSS recall.
	  ........ Merged revisions 369238 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Change incorrect chan_sip zombie hangup
	  debug message. They are all zombies now. ........ Merged
	  revisions 369235 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-22 19:34 +0000 [r369215]  Terry Wilson <twilson@digium.com>

	* /, channels/chan_sip.c: Don't crash on a guest directmedia call A
	  sip_pvt may not have relatedpeer set if a call doesn't match up
	  with a peer. If there is no relatedpeer, there is no direct media
	  ACL to apply, so just return that it is allowed. (closes issue
	  ASTERISK-20040) Reported by: Terry Wilson ........ Merged
	  revisions 369214 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-22 17:23 +0000 [r369206]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_sip.c: Don't parse media stream state for SIP
	  video streams The sendonly/recvonly/sendrecv/inactive media
	  stream attributes were parsed for video, but nothing was ever
	  done with them. With this code removed, an UNSUPPORTED message is
	  produced when these attributes are used in conjunction with a
	  video stream which is the better behavior since they were never
	  really supported in the first place. ........ Merged revisions
	  369195 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-20 17:36 +0000 [r369147]  Alexandr Anikin <may@telecom-service.ru>

	* addons/ooh323c/src/ooq931.c, addons/ooh323c/src/ooCalls.c, /: fix
	  locking issue on empty callList (issue ASTERISK-19298) Reported
	  by: Dmitry Melekhov Patches: ASTERISK-18322-2.patch ........
	  Merged revisions 369146 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-20 02:04 +0000 [r369109]  Michael L. Young <elgueromexicano@gmail.com>

	* main/netsock2.c, /, include/asterisk/netsock2.h: Fix NULL pointer
	  segfault in ast_sockaddr_parse() While working with
	  ast_parse_arg() to perform a validity check, a segfault occurred.
	  The segfault occurred due to passing a NULL pointer to
	  ast_sockaddr_parse() from ast_parse_arg(). According to the
	  documentation in config.h, "result pointer to the result. NULL is
	  valid here, and can be used to perform only the validity checks."
	  This patch fixes the segfault by checking for a NULL pointer.
	  This patch also adds documentation to netsock2.h about why it is
	  necessary to check for a NULL pointer. (Closes issue
	  ASTERISK-20006) Reported by: Michael L. Young Tested by: Michael
	  L. Young Patches: asterisk-20006-netsock-null-ptr.diff uploaded
	  by Michael L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/1990/ ........ Merged
	  revisions 369108 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-19 23:32 +0000 [r369091]  Alexandr Anikin <may@telecom-service.ru>

	* addons/chan_ooh323.c: check rtptimeouts in ooh323 channels as per
	  config file (rtp voice, video, udptl except rtcp) (closes issue
	  ASTERISK-19179) Reported by: TSAREGORODTSEV Yury Patches:
	  19179-ooh323-ast10.patch

2012-06-19 15:37 +0000 [r369067]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Fix request routing issue when
	  outboundproxy is used. Asterisk was incorrectly setting the
	  destination of CANCELs and ACKs for error responses to the URI of
	  the initial INVITE. This resulted in further requests, such as
	  INVITEs with authentication credentials, to be routed
	  incorrectly. Instead, when these CANCEL or ACKs are to be sent,
	  we should simply keep the destination the same as what it
	  previously was. There is no need to alter it any. (closes issue
	  ASTERISK-20008) Reported by Marcus Hunger Patches:
	  ASTERISK-20008.patch uploaded by Mark Michelson (license #5049)
	  ........ Merged revisions 369066 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-18 18:11 +0000 [r369044]  Richard Mudgett <rmudgett@digium.com>

	* /, main/features.c: Fix monitoring calls put in a parking lot. *
	  Fix a regression that was introduced by -r366167 which
	  effectively disabled monitoring parked calls. (closes issue
	  ASTERISK-20012) Reported by: sdolloff Tested by: rmudgett
	  ........ Merged revisions 369043 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-15 16:07 +0000 [r369005]  Kevin P. Fleming <kpfleming@digium.com>

	* channels/sip/sdp_crypto.c, main/slinfactory.c, main/translate.c,
	  main/jitterbuf.c, main/acl.c, channels/iax2-provision.c,
	  channels/sig_pri.c, utils/astdb2bdb.c, main/chanvars.c,
	  main/data.c, main/hashtab.c, channels/chan_misdn.c,
	  main/abstract_jb.c, main/fixedjitterbuf.c,
	  channels/sip/dialplan_functions.c, main/test.c, res/snmp/agent.c,
	  main/event.c, main/astmm.c, channels/sip/config_parser.c,
	  channels/vgrabbers.c, main/alaw.c, main/asterisk.c, main/dsp.c,
	  main/timing.c, main/udptl.c, main/autoservice.c,
	  main/fskmodem_float.c, main/frame.c, main/security_events.c,
	  main/ccss.c, main/threadstorage.c, main/say.c,
	  channels/console_video.c, channels/sip/reqresp_parser.c,
	  main/devicestate.c, main/astfd.c, main/ssl.c,
	  main/taskprocessor.c, main/autochan.c, channels/misdn/isdn_lib.c,
	  main/enum.c, main/format_pref.c, main/astobj2.c,
	  main/indications.c, main/fskmodem.c, channels/misdn_config.c,
	  apps/confbridge/conf_config_parser.c, main/io.c, main/cli.c,
	  main/ulaw.c, main/dial.c, main/framehook.c, main/format_cap.c,
	  main/strcompat.c, main/heap.c, channels/misdn/ie.c, main/plc.c,
	  main/logger.c, main/stdtime/localtime.c, channels/sig_ss7.c,
	  main/sched.c, main/datastore.c, main/lock.c, main/strings.c,
	  main/pbx.c, main/stun.c, channels/sip/srtp.c, main/dnsmgr.c,
	  channels/vcodecs.c, channels/sip/security_events.c,
	  utils/astdb2sqlite3.c, main/aoc.c, pbx/dundi-parser.c,
	  main/cel.c, channels/iax2-parser.c,
	  build_tools/find_missing_support_level (added), main/netsock.c,
	  main/tcptls.c, main/srv.c, main/privacy.c, main/callerid.c,
	  main/file.c, channels/misdn/portinfo.c, main/audiohook.c,
	  main/xmldoc.c, main/netsock2.c, main/format.c,
	  main/global_datastores.c, main/rtp_engine.c, /, res/ais/clm.c,
	  main/utils.c, channels/misdn/isdn_msg_parser.c, main/xml.c,
	  main/config.c, main/loader.c, main/term.c, main/channel.c,
	  main/cdr.c, res/ael/pval.c, channels/sig_analog.c, main/tdd.c,
	  channels/console_gui.c, res/ais/evt.c, main/fskmodem_int.c,
	  channels/console_board.c, main/syslog.c, main/app.c,
	  main/image.c, main/dns.c, main/message.c, main/db.c,
	  main/bridging.c: Multiple revisions 369001-369002 ........
	  r369001 | kpfleming | 2012-06-15 10:56:08 -0500 (Fri, 15 Jun
	  2012) | 11 lines Add support-level indications to many more
	  source files. Since we now have tools that scan through the
	  source tree looking for files with specific support levels, we
	  need to ensure that every file that is a component of a 'core' or
	  'extended' module (or the main Asterisk binary) is explicitly
	  marked with its support level. This patch adds support-level
	  indications to many more source files in tree, but avoids adding
	  them to third-party libraries that are included in the tree and
	  to source files that don't end up involved in Asterisk itself.
	  ........ r369002 | kpfleming | 2012-06-15 10:57:14 -0500 (Fri, 15
	  Jun 2012) | 3 lines Add a script to enable finding source files
	  without support-levels defined. ........ Merged revisions
	  369001-369002 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-14 17:31 +0000 [r368947]  Matthew Jordan <mjordan@digium.com>

	* channels/chan_skinny.c: AST-2012-009: Fix crash in chan_skinny
	  due to Key Pad Button Message handling AST-2012-008 (r367844)
	  fixed a denial of service attack exploitable in the Skinny
	  channel driver that occurred when certain messages are sent after
	  a previously registered station sends an Off Hook message.
	  Unresolved in that patch is an issue in the Asterisk 10 releases,
	  wherein, if a Station Key Pad Button Message is processed after
	  an Off Hook message, the channel driver will inappropriately
	  dereference a NULL pointer. This patch fixes those places where
	  the message handling or the channel callback functions would
	  attempt to dereference the line's pointer to the device. (issue
	  ASTERISK-19905) Reported by: Christoph Hebeisen Tested by:
	  mjordan, Christoph Hebeisen Patches: AST-2012-009-10.diff
	  uploaded by mjordan (license 6283)

2012-06-14 15:25 +0000 [r368899-368928]  Mark Michelson <mmichelson@digium.com>

	* /, main/Makefile: Revert Makefile change to remove embedding
	  res_adsi.so The change has resulted in a linking error for
	  certain versions of GCC. This is much worse than the original
	  issue, so for now, temporarily revert the change. A more thorough
	  change will be sought out. ........ Merged revisions 368927 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, funcs/func_volume.c: Fix a deadlock that occurs when
	  func_volume is used on a local channel. This was discovered by
	  trying to perform a call forward to an extension that makes use
	  of func_volume. When the local channel is optimized away, the
	  datastore on the local;2 channel would have its audiohook
	  destroyed rather than detaching the audiohook from the channel
	  and then destroying it. With this patch, func_volume's datastore
	  destructor takes the proper route of detaching the audiohook and
	  then destroying it. (closes issue ASTERISK-19611) reported by
	  Volker Sauer Patches: ASTERISK-19611.patch uploaded by Mark
	  Michelson (license #5049) ........ Merged revisions 368898 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-13 20:27 +0000 [r368895]  Matthew Jordan <mjordan@digium.com>

	* res/res_smdi.c, /, res/res_adsi.c: Mark res_smdi/res_adsi as
	  'core' supported modules Recently, various issues surrounding
	  weak symbols have caused problems with modules that rely on that
	  feature to be enabled in menuselect. This includes app_voicemail
	  and chan_dahdi, as they both rely upon res_smdi and res_adsi,
	  which, in certain circumstances, may not be enabled by default in
	  menuselect. Because res_smdi/res_adsi are dependencies for
	  chan_dahdi/app_voicemail, this patch marks both as 'core'
	  supported modules. This will allow both app_voicemail and
	  chan_dahdi to be enabled as well, regardless of whether or not
	  that system supports weak symbols. (issue AST-900) Reported by:
	  Thomas Arimont (issue AST-885) Reported by: Denis Alberto
	  Martinez ........ Merged revisions 368894 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-13 19:36 +0000 [r368885]  Mark Michelson <mmichelson@digium.com>

	* /, main/Makefile: Remove forced linking of res_adsi.o In GCC 4.5+
	  the result is that Asterisk has a phantom module loaded at
	  startup, claiming to be res_adsi. (closes issue ASTERISK-19920)
	  reported by Leif Madsen ........ Merged revisions 368873 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-13 14:30 +0000 [r368831-368853]  Matthew Jordan <mjordan@digium.com>

	* Makefile, /: Do not install empty directories; add ASTLIBDIR
	  r368830 modified the installation script to only create a
	  directory if that directory does not exist. If some directory
	  variable was empty, it would attempt to create the empty
	  location. It also failed to create the ASTLIBDIR directory. This
	  patch fixes it such that the correct directories are made and
	  only created if a value specifying them actually exists. ........
	  Merged revisions 368852 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* Makefile, /: Do not perform install on existing directories If a
	  directory already exists, performing a 'make install' will remove
	  the permissions associated with the current directory and replace
	  them with the permissions of the user executing the install. This
	  patch changes this behavior to only perform an install on the
	  directory if the directory does not exist. Thus, if a user later
	  changes the permissions on that directory, those permissions will
	  be preserved in subsequent installs. Review:
	  https://reviewboard.asterisk.org/r/1986 Review:
	  https://reviewboard.asterisk.org/r/1864 (closes issue
	  ASTERISK-19492) Reported by: Karl Fife Tested by: Paul Belanger,
	  Tilghman Lesher patches: ASTERISK-19492 by pabelanger (uploaded
	  by mjordan) ........ Merged revisions 368830 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-12 15:37 +0000 [r368808]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Set the Caller ID "tag" on peers even if
	  remote party information is present. On incoming calls, we were
	  setting the cid_tag on the dialog only if there was no remote
	  party information (Remote-Party-ID or P-Asserted-Identity)
	  present. The Caller ID tag is an invented parameter, though, and
	  should be set no matter the circumstance. (closes issue
	  ASTERISK-19859) Reported by Thomas Arimont (closes issue AST-884)
	  Reported by Trey Blancher ........ Merged revisions 368807 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-11 17:08 +0000 [r368760]  Richard Mudgett <rmudgett@digium.com>

	* main/channel.c, channels/chan_dahdi.c, channels/sig_analog.c, /,
	  channels/chan_sip.c, include/asterisk/channel.h,
	  channels/chan_iax2.c: Fix deadlock potential with
	  ast_set_hangupsource() calls. Calling ast_set_hangupsource() with
	  the channel lock held can result in a deadlock because the
	  function also locks the bridged channel. (issue ASTERISK-19537)
	  (closes issue AST-891) Reported by: Guenther Kelleter Tested by:
	  Guenther Kelleter (closes issue ASTERISK-19801) Reported by: Alec
	  Davis ........ Merged revisions 368759 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-11 15:15 +0000 [r368721-368739]  Kinsey Moore <kmoore@digium.com>

	* apps/app_voicemail.c, main/udptl.c, channels/sip/sdp_crypto.c, /,
	  channels/chan_sip.c, main/say.c, res/res_fax.c,
	  funcs/func_strings.c, channels/sip/reqresp_parser.c,
	  apps/app_queue.c, main/loader.c, channels/chan_dahdi.c,
	  res/res_config_odbc.c, channels/sip/dialplan_functions.c,
	  pbx/pbx_config.c, apps/app_directory.c, res/res_speech.c,
	  res/res_odbc.c: Fix coverity UNUSED_VALUE findings in core
	  support level files Most of these were just saving returned
	  values without using them and in some cases the variable being
	  saved to could be removed as well. (issue ASTERISK-19672)
	  ........ Merged revisions 368738 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/md5.c: Fix compilation in dev-mode Backport a compilation
	  fix in md5.c from trunk that only showed up in dev-mode under
	  certain compiler versions. ........ Merged revisions 368719 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-07-10  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.6.0 Released.

2012-07-06  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.6.0-rc2 Released.

	* AST-2012-009: Skinny Channel Driver Remote Crash Vulnerability

	* AST-2012-010: Possible Resource Leak on Uncompleted Re-INVITE
	  Transactions

	* AST-2012-011: Remote Crash Vulnerability in VoiceMail Application

	* Fix crash on a guest directmedia call

	  A sip_pvt may not have relatedpeer set if a call doesn't match up
	  with a peer.  If there is no relatedpeer, there is no direct media
	  ACL to apply, so just return that is is allowed.

	  (closes issue ASTERISK-20040)
	
	* Fix request routing issue when outboundproxy is used

	  Asterisk was incorrectly setting the destination of CANCELs and ACKs
	  for error responses to the URI of the initial INVITE.  This resulted
	  in further requests, such as INVITEs with authentication
	  credentials, to be routed incorrectly.  Instead when these CANCEL or
	  ACKs are to be esnt, we should simply keep the destination the same
	  as what it previously was.  There is no need to alter it any.

	  (closes issue ASTERISK-20008)
	
	* Fix monitoring calls put in a parking lot

	  Fix a regression that was introduced by r366167 which effectively
	  disabled monitoring parked calls.

	  (closes issue ASTERISK-20012)

2012-06-08  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.6.0-rc1 Released.

2012-06-06 21:32 +0000 [r368645]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c, channels/sig_analog.c, /: Fix POTS flash
	  hook to orignate a second call deadlock. A deadlock can occur
	  when a POTS phone tries to flash hook to originate a second call
	  for 3-way or transfer. If another process is scanning the
	  channels container when the POTS line flash hooks then a deadlock
	  will occur. * Release the channel and private locks when creating
	  a new channel as a result of a flash hook. (closes issue
	  ASTERISK-19842) Reported by: rmudgett Tested by: rmudgett
	  ........ Merged revisions 368644 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-06 19:18 +0000 [r368629]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Fix a specific scenario where ACKs are
	  not matched. If a dialog-starting INVITE contains a to-tag, then
	  Asterisk will respond with a 481. In this case, the resulting
	  incoming ACK would not be matched, so Asterisk would continue
	  retransmitting the 481 until the transaction times out. There
	  were two issues. Asterisk, upon creating a sip_pvt would generate
	  a local tag. However, when the time came to transmit the 481,
	  since there was a to-tag in the INVITE, Asterisk would place this
	  original to-tag in the 481 response. When the ACK came in,
	  Asterisk would attempt to match the to-tag in the ACK to the
	  generated local tag. Unfortunately, Asterisk never actually
	  transmitted a response with the generated local tag, so the
	  to-tag in the ACK would not match. The other problem was that
	  when the 481 was sent, nothing was set on the sip_pvt to indicate
	  what CSeq is expected in the ACK. To fix the first problem, we
	  zero out the to-tag seen in the incoming INVITE. This way,
	  Asterisk, when time to send a response, will send its generated
	  local tag instead. To fix the second problem, we set the
	  sip_pvt's pendinginvite to the CSeq of the INVITE when we send a
	  481. (closes issue ASTERISK-19892) Reported by Mark Michelson
	  ........ Merged revisions 368625 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-06 17:21 +0000 [r368605]  Matthew Jordan <mjordan@digium.com>

	* /, build_tools/make_version: Add feature modifier to versions
	  produced from branches Certain branches, such as Certified
	  Asterisk, may have a modifier added to them that specifies the
	  features available in that branch. For branches, this modifier is
	  expected to be reflected in the location of the branch in
	  subversion. For example, a subversion of URL of
	  /certified/branches/1.8.11 would have a feature modifier of
	  'certified'. This is slightly different then how features are
	  determined for tags, where the feature is part of the actual tag
	  name, e.g., "10.5.0-digiumphones". In keeping with the
	  nomenclature used for tags, the feature specifier for branches is
	  translated and placed after the revision numbers. For the example
	  given previously, this would result in a branch version of
	  "Asterisk SVN-branch-1.8.11-cert-rXXXXXX". ........ Merged
	  revisions 368604 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-06 16:09 +0000 [r368587]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_sip.c: Ensure overlapping hold flags do not
	  conflict When changing between different modes of hold, the flags
	  were not being cleared out properly causing a failure to change
	  hold states. (closes issue ASTERISK-19919) Patch-by: Morten
	  Tryfoss Reported-by: Morten Tryfoss ........ Merged revisions
	  368586 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-06 01:10 +0000 [r368568]  Richard Mudgett <rmudgett@digium.com>

	* /, main/features.c: Fix parked call performing a DTMF blind
	  transfer after being retrieved. When a parked call was retrieved
	  from the parking lot, it could not do a blind transfer because it
	  caused the involved calls to be hung up unconditionally. * Made
	  the ParkedCall application return the ast_bridge_call() return
	  value. (closes issue ABE-2862) Reported by: Vlad Povorozniuc
	  ........ Merged revisions 368567 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-05 15:27 +0000 [r368524-368536]  Kinsey Moore <kmoore@digium.com>

	* /, apps/app_minivm.c: Resolve some build warnings My newly
	  upgraded compiler caught these usages of uninitialized values.
	  They weren't actually used. ........ Merged revisions 368533 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/app_voicemail.c, /: Ensure that pages and emails are sent
	  using RFC822-compliant date format When localization was added to
	  app_voicemail, these headers were altered when they should have
	  remained in en_US format for RFC compliance. This reverts the
	  changes to those two lines. (closes issue ASTERISK-19876)
	  ........ Merged revisions 368520 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-04 22:02 +0000 [r368499]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Relay proper SIP responses on calling
	  side. Revision 351130 broke corect HANGUPCAUSE setting for the
	  404 case in chan_sip. Other cases were also potentially broken.
	  This patch fixes the relaying of causes to be what they used to
	  be. (closes issue ASTERISK-19914) Reported by Pavel Troller
	  Tested by Walter Doekes (via a reviewboard test to be committed
	  later) Patches: chan_sip.diff uploaded by Pavel Troller (license
	  #6302) ........ Merged revisions 368498 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-04 21:11 +0000 [r368407-368470]  Richard Mudgett <rmudgett@digium.com>

	* /, UPGRADE.txt: Document BLINDTRANSFER behavior change. (issue
	  ASTERISK-19322) (closes issue ASTERISK-19875) Reported by: call
	  ........ Merged revisions 368469 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/channel.c, /: Fix potential deadlock between masquerade and
	  chan_local. * Restructure ast_do_masquerade() to not hold channel
	  locks while it calls ast_indicate(). * Simplify many calls to
	  ast_do_masquerade() since it will never return a failure now. If
	  it does fail internally because a channel driver callback
	  operation failed, the only thing ast_do_masquerade() can do is
	  generate a warning message about strange things may happen and
	  press on. * Fixed the call to ast_bridged_channel() in
	  ast_do_masquerade(). This change fixes half of the deadlock
	  reported in ASTERISK-19801 between masquerades and chan_iax.
	  (closes issue ASTERISK-19537) Reported by: rmudgett Tested by:
	  rmudgett Review: https://reviewboard.asterisk.org/r/1915/
	  ........ Merged revisions 368405 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-01 23:24 +0000 [r368310]  Richard Mudgett <rmudgett@digium.com>

	* /, apps/app_stack.c: Fix deadlock when Gosub used with alternate
	  dialplan switches. Attempting to remove a channel from
	  autoservice with the channel lock held will result in deadlock. *
	  Restructured gosub_exec() to not call ast_parseable_goto() and
	  ast_exists_extension() with the channel lock held. (closes issue
	  ASTERISK-19764) Reported by: rmudgett Tested by: rmudgett
	  ........ Merged revisions 368308 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-01 20:22 +0000 [r368267]  Kevin P. Fleming <kpfleming@digium.com>

	* /, channels/chan_sip.c: Improve SDP parsing warning messages *
	  'Unsupported media type' is only reported when that is in fact
	  the case, not when a supported media type is included in an 'm'
	  line that has an invalid format. * All warning messages related
	  to parsing 'm' lines now include the 'm' line contents. * (minor
	  bugfix) newline added to port-number-zero warning messages. *
	  Warning messages improved to use RFC-specified terminology for
	  various items. * Warnings for offers that include more than one
	  port for a single media type now include the media type. Review:
	  https://reviewboard.asterisk.org/r/1811/ ........ Merged
	  revisions 368218 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-01 03:28 +0000 [r368093]  Michael L. Young <elgueromexicano@gmail.com>

	* /, funcs/func_channel.c: Add documentation to function CHANNEL
	  for options echocan_mode and buffers The ability to set
	  "echocan_mode" and "buffers" through the dialplan was added to
	  chan_dahdi some time ago. This patch adds some documentation to
	  func_channel. (Closes issue ASTERISK-19911) Reported by: Dale
	  Noll Tested by: Michael L. Young Patches:
	  asterisk-19911-branch18.diff uploaded by Michael L. Young
	  (license 5026) Review: https://reviewboard.asterisk.org/r/1949/
	  ........ Merged revisions 368092 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-31 18:20 +0000 [r368042]  Richard Mudgett <rmudgett@digium.com>

	* res/ael/pval.c, main/tcptls.c, main/manager.c,
	  res/res_config_odbc.c, /, channels/chan_sip.c,
	  channels/chan_agent.c, funcs/func_math.c, main/features.c,
	  apps/app_queue.c, channels/chan_iax2.c, pbx/pbx_config.c:
	  Coverity Report: Fix issues for error type REVERSE_INULL (core
	  modules) * Fixes findings: 0-2,5,7-15,24-26,28-31 (issue
	  ASTERISK-19648) Reported by: Matt Jordan ........ Merged
	  revisions 368039 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-30 18:07 +0000 [r367907-367981]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/sig_pri.c, channels/sig_ss7.c: Use the
	  DEADLOCK_AVOIDANCE() macro instead. (issue ASTERISK-19854)
	  ........ Merged revisions 367980 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/sig_pri.c, channels/sig_ss7.c: Fix deadlock when
	  executing CLI "pri show channels" and "ss7 show channels"
	  commands. * Fix sig_pri_lock_owner() to avoid deadlock properly.
	  * Code pri_grab() better. * Fix sig_ss7_lock_owner() to avoid
	  deadlock properly. * Code ss7_grab() better. (closes issue
	  ASTERISK-19854) Reported by: Jaxon Patches:
	  jira_asterisk_19854_v1.8.6.patch (license #5621) patch uploaded
	  by rmudgett (Modified to do the same thing to sig_ss7) Tested by:
	  Jaxon ........ Merged revisions 367976 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_meetme.c: Coverity Report: Fix issues for error type
	  REVERSE_INULL (deprecated modules) * Fix only issue pointed out
	  by deprecated_REVERSE_INULL.txt for app_meetme.c in find_user().
	  * Change use of %i to %d in sscanf() in find_user(). The use of
	  %i gives unexpected parsing because it can accept hex, octal, and
	  decimal integer formats. * Changed other uses of %i in
	  app_meetme() to use %d for consistency. (issue ASTERISK-19648)
	  Reported by: Matt Jordan ........ Merged revisions 367906 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-29 18:33 +0000 [r367844]  Matthew Jordan <mjordan@digium.com>

	* channels/chan_skinny.c: AST-2012-008: Fix remote crash
	  vulnerability in chan_skinny When a skinny session is
	  unregistered, the corresponding device pointer is set to NULL in
	  the channel private data. If the client was not in the on-hook
	  state at the time the connection was closed, the device pointer
	  can later be dereferened if a message or channel event attempts
	  to use a line's pointer to said device. The patches prevent this
	  from occurring by checking the line's pointer in message handlers
	  and channel callbacks that can fire after an unregistration
	  attempt. (closes issue ASTERISK-19905) Reported by: Christoph
	  Hebeisen Tested by: mjordan, Damien Wedhorn Patches:
	  AST-2012-008-1.8.diff uploaded by mjordan (license 6283)
	  AST-2012-008-10.diff uploaded by mjordan (licesen 6283)

2012-05-25 16:30 +0000 [r367782]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/chan_iax2.c: AST-2012-007: Fix IAX receiving HOLD
	  without suggested MOH class crash. * Made schedule_delivery() set
	  the received frame f->data.ptr to NULL if the datalen is zero. *
	  Fix queue_signalling() memcpy() size error. * Made
	  queue_signalling() not use C++ keyword variable names. (closes
	  issue ASTERISK-19597) Reported by: mgrobecker Patches:
	  jira_asterisk_19597_v1.8.patch (license #5621) patch uploaded by
	  rmudgett Tested by: rmudgett, Michael L. Young ........ Merged
	  revisions 367781 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-25 02:29 +0000 [r367731]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_sip.c: Fix pvt_sip for inbound call to use
	  peer's allowtransfer setting The pvt_sip allowtransfer was not
	  being set to that of the peer's setting. Therefore, the global
	  allowtransfer setting was being used instead which would lead to
	  calls not being transfered if the global setting was set to 'no'
	  despite the setting on the peer being 'yes' and vice versa, calls
	  would be allowed to transfer even if the peer's setting was 'no'
	  but the global setting was 'yes'. (Closes issue ASTERISK-19856)
	  Reported by: Jacek Tested by: Michael L. Young, Jacek Patches:
	  issue-asterisk-19856-branch10-v3.diff uploaded by Michael L.
	  Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/1923/ ........ Merged
	  revisions 367730 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-24 22:29 +0000 [r367679]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_dial.c, /, apps/app_queue.c: Fix Dial I option ignored
	  if dial forked and one fork redirects. The Dial and Queue I
	  option is intended to block connected line updates and
	  redirecting updates. However, it is a feature that when a call is
	  locally redirected, the I option is disabled if the redirected
	  call runs as a local channel so the administrator can have an
	  opportunity to setup new connected line information.
	  Unfortunately, the Dial and Queue I option is disabled for *all*
	  forked calls if one of those calls is redirected. * Make the Dial
	  and Queue I option apply to each outgoing call leg independently.
	  Now if one outgoing call leg is locally redirected, the other
	  outgoing calls are not affected. * Made Dial not pass any
	  redirecting updates when forking calls. Redirecting updates do
	  not make sense for this scenario. * Made Queue not pass any
	  redirecting updates when using the ringall strategy. Redirecting
	  updates do not make sense for this scenario. * Fixed deadlock
	  potential with chan_local when Dial and Queue send redirecting
	  updates for a local redirect. * Converted the Queue stillgoing
	  flag to a boolean bitfield. (closes issue ASTERISK-19511)
	  Reported by: rmudgett Tested by: rmudgett Review:
	  https://reviewboard.asterisk.org/r/1920/ ........ Merged
	  revisions 367678 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-24 13:32 +0000 [r367562]  Matthew Jordan <mjordan@digium.com>

	* apps/app_confbridge.c: Fix crash in ConfBridge when user
	  announcement is played for more than 2 users A patch introduced
	  in r354938 made it so that ConfBridge would not attempt to play
	  sound files if those files did not exist. Unfortunately,
	  ConfBridge uses the same underlying function, play_sound_helper,
	  to playback both sound files and numbers to callers. When a
	  number is being played back, the name of the sound file is
	  expected to be NULL. This NULL value was passed into a function
	  that tested for the existance of a sound file and is not tolerant
	  to NULL file names, causing a crash. This patch fixes the
	  behavior, such that if a sound file does not exist we do not
	  attempt to play it, but we only attempt that check if the a sound
	  file was specified in the first place. If a sound file was not
	  specified, we use the 'play number' logic in the helper function.
	  (closes issue ASTERISK-19899) Reported by: Florian Gilcher Tested
	  by: Florian Gilcher patches: asterisk-19899.diff uploaded by
	  mjordan (license 6283)

2012-05-23 23:16 +0000 [r367470]  Richard Mudgett <rmudgett@digium.com>

	* main/pbx.c, /: Fix WaitExten(x,m(musicclass)) string termination.
	  The AST_CONTROL_HOLD MOH class from the WaitExten application can
	  now be queued onto a channel, passed over local channels with the
	  /m option, and passed over IAX channels. ........ Merged
	  revisions 367469 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-23 20:29 +0000 [r367417]  Mark Michelson <mmichelson@digium.com>

	* main/tcptls.c, /: Only call SSL_CTX_free if DO_SSL is defined.
	  Thanks to Paul Belanger for pointing out this error. ........
	  Merged revisions 367416 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-23 13:25 +0000 [r367369]  Matthew Jordan <mjordan@digium.com>

	* /, channels/chan_sip.c, CHANGES, channels/sip/include/sip.h:
	  Re-add LastMsgsSent value for SIP peers Previously, MWI logic
	  utilized a counter called 'lastmsgssent' to know whether or not
	  MWI NOTIFY requests had been sent to a specific peer. When MWI
	  notifications were changed to use the internal event framework,
	  this value was no longer needed for its original purpose. Hence,
	  it was no longer updated with the new/old message counts for a
	  peer. The value was previously removed for Asterisk 10; however,
	  since it was still present in Asterisk 1.8 and still useful for
	  reporting purposes, it was decided to re-add the value. This
	  patch re-adds the 'LastMsgsSent' field in the response to an
	  AMI/CLI 'sip show peer [peer]' command, and makes it so that the
	  value of lastmsgssent is updated appropriately. The value should
	  now display the new/old message counts for a particular peer.
	  (closes issue ASTERISK-17866) Reported by: Steve Davies patches
	  by: ast-17866-rb1272.patch (License #5041 by irroot) Modified
	  slightly for this commit Review:
	  https://reviewboard.asterisk.org/r/1939 ........ Merged revisions
	  367362 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-22 17:21 +0000 [r367267-367299]  Terry Wilson <twilson@digium.com>

	* main/channel.c, /, include/asterisk/cel.h,
	  include/asterisk/channel.h, main/cel.c, main/asterisk.c: Fix race
	  condition for CEL LINKEDID_END event This patch fixes to
	  situations that could cause the CEL LINKEDID_END event to be
	  missed. 1) During a core stop gracefully, modules are unloaded
	  when ast_active_channels == 0. The LINKDEDID_END event fires
	  during the channel destructor. This means that occasionally, the
	  cel_* module will be unloaded before the channel is destroyed. It
	  seemed generally useful to wait until the refcount of all
	  channels == 0 before unloading, so I added a channel counter and
	  used it in the shutdown code. 2) During a masquerade,
	  ast_channel_change_linkedid is called. It calls
	  ast_cel_check_retire_linkedid which unrefs the linkedid in the
	  linkedids container in cel.c. It didn't ref the new linkedid. Now
	  it does. Review: https://reviewboard.asterisk.org/r/1900/
	  ........ Merged revisions 367292 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Resolve crash in subscribing for MWI
	  notifications ASTOBJ_UNREF sets the variable to NULL after
	  unreffing it, so the variable should definitely not be used after
	  that. To solve this in the two cases that affect subscribing for
	  MWI notifications, we instead save the ref locally, and unref
	  them in the error conditions. (closes issue ASTERISK-19827)
	  Reported by: B. R Review:
	  https://reviewboard.asterisk.org/r/1940/ ........ Merged
	  revisions 367266 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-18 17:50 +0000 [r367003-367028]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_dahdi.c, /, main/say.c: Address MISSING_BREAK
	  static analysis reports some more. This addresses core findings 4
	  and 6. Moises Silva helped me by stating that a break could be
	  safely added to the case where it is added in chan_dahdi.c In
	  say.c, I have added a comment indicating that static analysis
	  complains but that it is currently unknown if this is correct.
	  This fixes all core findings of this type. (closes issue
	  ASTERISK-19662) reported by Matthew Jordan ........ Merged
	  revisions 367027 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/tcptls.c, /, channels/chan_sip.c, include/asterisk/tcptls.h:
	  Fix memory leak of SSL_CTX structures in TLS core. SSL_CTX
	  structures were allocated but never freed. This was a bigger
	  issue for clients than servers since new SSL_CTX structures could
	  be allocated for each connection. Servers, on the other hand,
	  typically set up a single SSL_CTX for their lifetime. This is
	  solved in two ways: 1. In __ssl_setup(), if a tcptls_cfg has an
	  ssl_ctx on it, it is freed so that a new one can take its place.
	  2. A companion to ast_ssl_setup() called ast_ssl_teardown() has
	  been added so that servers can properly free their SSL_CTXs.
	  (issue ASTERISK-19278) ........ Merged revisions 367002 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-18 15:45 +0000 [r366948]  Matthew Jordan <mjordan@digium.com>

	* main/cli.c, /, channels/chan_sip.c, funcs/func_odbc.c: Fix more
	  memory leaks This patch adds to what was fixed in r366880.
	  Specifically, it addresses the following: * chan_sip: dispose of
	  an allocated frame in off nominal code paths in sip_rtp_read *
	  func_odbc: when disposing of an allocated resultset, ensure that
	  any rows that were appended to that resultset are also disposed
	  of * cli: free the created return string buffer in another off
	  nominal code path (issue ASTERISK-19665) Reported by: Matt Jordan
	  Review: https://reviewboard.asterisk.org/r/1922/ ........ Merged
	  revisions 366944 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-18 14:18 +0000 [r366884]  Kinsey Moore <kmoore@digium.com>

	* /, channels/sip/config_parser.c: Reorder and renumber tests
	  appropriately It appears that a patch did not apply properly when
	  adding tests 12 and 13 and test 11 was duplicated. These tests
	  have been reordered and renumbered such that they make sense.
	  ........ Merged revisions 366882 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-18 14:01 +0000 [r366881]  Matthew Jordan <mjordan@digium.com>

	* main/xmldoc.c, apps/app_voicemail.c, res/res_calendar.c,
	  main/netsock2.c, res/res_rtp_asterisk.c, main/pbx.c,
	  res/res_calendar_exchange.c, res/res_calendar_icalendar.c,
	  apps/app_page.c, /, funcs/func_dialgroup.c, channels/chan_sip.c,
	  apps/app_record.c, res/res_calendar_caldav.c,
	  res/res_musiconhold.c, channels/chan_iax2.c, apps/app_queue.c,
	  res/res_jabber.c, main/editline/term.c, main/enum.c,
	  main/config.c, res/res_srtp.c, main/cli.c,
	  main/editline/tokenizer.c, main/data.c, channels/chan_dahdi.c,
	  funcs/func_odbc.c, main/features.c, apps/app_minivm.c,
	  main/editline/readline.c, channels/sip/config_parser.c: Fix a
	  variety of memory leaks This patch addresses a number of memory
	  leaks in a variety of modules that were found by a static
	  analysis tool. A brief summary of the changes: * app_minivm: free
	  ast_str objects on off nominal paths * app_page: free the
	  ast_dial object if the requested channel technology cannot be
	  appended to the dialing structure * app_queue: if a penalty rule
	  failed to match any existing rule list names, the created rule
	  would not be inserted and its memory would be leaked * app_read:
	  dispose of the created silence detector in the presence of off
	  nominal circumstances * app_voicemail: dispose of an allocated
	  unique ID field for MWI event un-subscribe requests in off
	  nominal paths; dispose of configuration objects when using the
	  secret.conf option * chan_dahdi: dispose of the allocated frame
	  produced by ast_dsp_process * chan_iax2: properly unref peer in
	  CLI command "iax2 unregister" * chan_sip: dispose of the
	  allocated frame produced by sip_rtp_read's call of
	  ast_dsp_process; free memory in parse unit tests *
	  func_dialgroup: properly deref ao2 object grhead in nominal path
	  of dialgroup_read * func_odbc: free resultset in off nominal
	  paths of odbc_read * cli: free match_list in off nominal paths of
	  CLI match completion * config: free comment_buffer/list_buffer
	  when configuration file load is unchanged; free the same buffers
	  any time they were created and config files were processed *
	  data: free XML nodes in various places * enum: free context
	  buffer in off nominal paths * features: free ast_call_feature in
	  off nominal paths of applicationmap config processing * netsock2:
	  users of ast_sockaddr_resolve pass in an ast_sockaddr struct that
	  is allocated by the method. Failures in ast_sockaddr_resolve
	  could result in the users of the method not knowing whether or
	  not the buffer was allocated. The method will now not allocate
	  the ast_sockaddr struct if it will return failure. * pbx: cleanup
	  hash table traversals in off nominal paths; free ignore pattern
	  buffer if it already exists for the specified context * xmldoc:
	  cleanup various nodes when we no longer need them *
	  main/editline: various cleanup of pointers not being freed before
	  being assigned to other memory, cleanup along off nominal paths *
	  menuselect/mxml: cleanup of value buffer for an attribute when
	  that attribute did not specify a value * res_calendar*: responses
	  are allocated via the various *_request method returns and should
	  not be allocated in the various write_event methods; ensure
	  attendee buffer is freed if no data exists in the parsed node;
	  ensure that calendar objects are de-ref'd appropriately *
	  res_jabber: free buffer in off nominal path * res_musiconhold:
	  close the DIR* object in off nominal paths * res_rtp_asterisk: if
	  we run out of ports, close the rtp socket object and free the rtp
	  object * res_srtp: if we fail to create the session in libsrtp,
	  destroy the temporary ast_srtp object (issue ASTERISK-19665)
	  Reported by: Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/1922 ........ Merged revisions
	  366880 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-17 14:41 +0000 [r366792]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c: chan_sip: Fix missed locking of opposing
	  pvt for directmedia acl from r366547 It also required deadlock
	  avoidance since two sip_pvts structs needed to be locked
	  simultaneously. Trunk handles it differently, so this is a 1.8
	  and 10 patch only. ........ (issue AST-876) Merged revisions
	  366791 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-17 12:57 +0000 [r366741]  Matthew Jordan <mjordan@digium.com>

	* channels/chan_dahdi.c, /, res/res_calendar_ews.c: Fix checking
	  bounds of array index after using it; improper sizeof This patch
	  fixes two problems pointed out by a static analysis tool. * In
	  chan_dahdi, when an event is handled the index of the sub channel
	  is first obtained. In very off nominal cases, the method that
	  determines the index can return a negative value. In the event
	  handling code, whether or not the index returned is valid was
	  being checked after that value was used to index into an array.
	  This patch makes it so the value is checked before any indexing
	  is done. * In res_calendar_ews, sizeof was being passed a pointer
	  instead of the struct to determine the amount of memory to
	  allocate. (issue ASTERISK-19651) Reported by: Matt Jordan (closes
	  issue ASTERISK-19671) Reported by: Matt Jordan ........ Merged
	  revisions 366740 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-15 23:39 +0000 [r366598]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Correct misuse of ast_strip_quoted() when
	  getting a Diversion header's reason parameter. The use here was
	  assuming that the pointer would be updated, but the updated
	  string is actually returned by ast_strip_quoted() instead.
	  ........ Merged revisions 366597 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-15 20:44 +0000 [r366591]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c: chan_sip: Check the right channel's host
	  address for directmediapermit/deny Prior to this patch, when
	  checking the addresses for directmediapermit and
	  denydirectmediadeny, Asterisk would check the host address of the
	  channel permit/deny was specified, which defers from the
	  expectations of both our users and the development team. Instead,
	  directmediapermit/deny now checks against the address of the
	  channel that the peer with the ACL is connected to. (issue
	  AST-876) Review: https://reviewboard.asterisk.org/r/1899/
	  ........ Merged revisions 366547 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-14 20:06 +0000 [r366390-366412]  Mark Michelson <mmichelson@digium.com>

	* /, pbx/dundi-parser.c: Fix two more coverity constant expression
	  result findings. These correspond to findings 0 and 1 in the core
	  findings of ASTERISK-19649. After contacting Mark Spencer, he was
	  unsure of what the intent behind these lines of code were, so
	  they are being axed. For Asterisk 1.8 and 10, the output of
	  debugging DUNDi frames will not be changed, but for trunk the
	  "Retry" portion will be omitted since it does not properly
	  distinguish retransmissions from initial frames. (closes issue
	  ASTERISK-19649) Reported by Matthew Jordan ........ Merged
	  revisions 366409 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Fix broken reinvite glare scenario. To
	  make a long story short, reinvite glares were broken because
	  Asterisk would invert the To and From headers when ACKing a 491
	  response. The reason was because the initreq of the dialog was
	  being changed to the incoming glared reinvite instead of being
	  set to the outgoing glared reinvite. This change has three parts
	  * In handle_incoming, we never will reject an ACK because it has
	  a to-tag present, even if we think the request may be out of
	  dialog. * In handle_request_invite, we do not change the initreq
	  when receiving a reinvite to which we will respond with a 491. *
	  In handle_request_invite, several superflous settings up
	  pendinginvite have been removed since this is dones automatically
	  by transmit_response_reliable Review:
	  https://reviewboard.asterisk.org/r/1911 ........ Merged revisions
	  366389 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-11 23:59 +0000 [r366297]  Russell Bryant <russell@russellbryant.com>

	* /, addons/format_mp3.c: format_mp3: Fix a possible crash
	  mp3_read(). This patch fixes a potential crash in mp3_read() by
	  not assuming that dbuf has enough data to finish filling up the
	  output buffer. The patch also makes sure that the dbuf state gets
	  reset after we know we read everything out of it already. In
	  passing, this patch includes some other cleanups of this module,
	  including stripping trailing whitespace, formatting fixes based
	  on coding guidelines, and removing a number of unused members
	  from the private state struct. (closes issue ASTERISK-19761)
	  Reported by: Chris Maciejewsk Tested by: Chris Maciejewsk
	  ........ Merged revisions 366296 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-10 23:42 +0000 [r366241]  Richard Mudgett <rmudgett@digium.com>

	* main/channel.c, /: * Made ast_change_name() hold the channels
	  container lock while changing the channel name. * Eliminate
	  redundant list not empty check in clone_variables(). ........
	  Merged revisions 366240 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-10 20:54 +0000 [r366168]  Kinsey Moore <kmoore@digium.com>

	* main/xmldoc.c, apps/app_voicemail.c, funcs/func_speex.c,
	  main/pbx.c, res/res_calendar_icalendar.c, /, channels/chan_sip.c,
	  funcs/func_lock.c, channels/chan_agent.c,
	  channels/sip/reqresp_parser.c, main/devicestate.c,
	  pbx/dundi-parser.c, channels/chan_iax2.c, channels/iax2-parser.c,
	  main/config.c, res/res_monitor.c, main/cdr.c, main/channel.c,
	  res/ael/pval.c, main/data.c, channels/chan_dahdi.c,
	  main/tcptls.c, main/manager.c, main/features.c, main/app.c,
	  main/event.c, pbx/pbx_dundi.c, res/res_odbc.c: Resolve
	  FORWARD_NULL static analysis warnings This resolves core findings
	  from ASTERISK-19650 numbers 0-2, 6, 7, 9-11, 14-20, 22-24, 28,
	  30-32, 34-36, 42-56, 82-84, 87, 89-90, 93-102, 104, 105, 109-111,
	  and 115. Finding numbers 26, 33, and 29 were already resolved.
	  Those skipped were either extended/deprecated or in areas of code
	  that shouldn't be disturbed. (Closes issue ASTERISK-19650)
	  ........ Merged revisions 366167 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-10 16:55 +0000 [r366106]  Jonathan Rose <jrose@digium.com>

	* main/xmldoc.c, apps/app_voicemail.c, main/pbx.c,
	  channels/sig_analog.c, /, channels/chan_sip.c, funcs/func_lock.c,
	  main/features.c, main/acl.c, channels/iax2-provision.c,
	  apps/app_queue.c, channels/chan_iax2.c, res/ael/ael.flex,
	  funcs/func_devstate.c, main/asterisk.c: Coverity Report: Fix
	  issues for error type CHECKED_RETURN for core (issue
	  ASTERISK-19658) Reported by: Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/1905/ ........ Merged
	  revisions 366094 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-10 16:13 +0000 [r366053]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Close the proper tcptls_session when
	  session creation fails. (issue AST-998) Reported by: Thomas
	  Arimont Tested by: Thomas Arimont ........ Merged revisions
	  366052 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-10 15:43 +0000 [r365990-366049]  Jonathan Rose <jrose@digium.com>

	* /, apps/app_page.c, funcs/func_cdr.c, main/features.c,
	  apps/app_disa.c, apps/app_chanspy.c: Coverity Report: Fix issues
	  for error type UNINIT in Core supported modules (issue
	  ASTERISK-19652) Reported by: Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/1909/ ........ Merged
	  revisions 366048 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, codecs/codec_dahdi.c: Block on frameout if the hardware has
	  enough samples to complete a frame. Fixes some problems with
	  skipping audio in elaborate scenarios involving multiple codecs
	  by making codec_dahdi operate in a more synchronous fashion
	  similar to codec_g729. This change also fixes the use of file
	  conversion tools from Asterisk's CLI. This change may cause the
	  thread responsible for transcoding audio to block briefly (Shaun
	  Ruffell describes this as 'several milliseconds') while waiting
	  for the hardware transcoder. (closes issue ASTERISK-19643)
	  reported by: Shaun Ruffell Patches:
	  0001-codec_dahdi-Block-on-frameout-the-hardware-has-enoug.patch
	  uploaded by Shaun Ruffell (license 5417) ........ Merged
	  revisions 365989 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-09 16:15 +0000 [r365898]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Prevent sip_pvt refleak when an
	  ast_channel outlasts its corresponding sip_pvt. chan_sip was
	  coded under the assumption that a SIP dialog with an owner
	  channel will always be destroyed after the owner channel has been
	  hung up. However, there are situations where the SIP dialog can
	  time out and auto destruct before the corresponding channel has
	  hung up. A typical example of this would be if the 'h' extension
	  in the dialplan takes a long time to complete. In such cases,
	  __sip_autodestruct() would complain about the dialog being auto
	  destroyed with an owner channel still in place. The problem is
	  that even once the owner channel was hung up, the sip_pvt would
	  still be linked in its ao2_container because nothing would ever
	  unlink it. The fix for this is that if __sip_autodestruct() is
	  called for a sip_pvt that still has an owner channel in place,
	  the destruction is rescheduled for 10 seconds in the future. This
	  will continue until the owner channel is finally hung up. (closes
	  issue ASTERISK-19425) reported by David Cunningham Patches:
	  ASTERISK-19425.patch uploaded by Mark Michelson (License #5049)
	  (closes issue ASTERISK-19455) reported by Dean Vesvuio Tested by
	  Dean Vesvuio ........ Merged revisions 365896 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-08 20:25 +0000 [r365632-365701]  Richard Mudgett <rmudgett@digium.com>

	* /, apps/app_followme.c: * Fix FollowMe memory leak on error paths
	  in app_exec(). * Fix FollowMe leaving recorded caller name file
	  on error paths in app_exec(). * Use correct buffer dimension
	  define in struct call_followme.moh[] and struct
	  fm_args.namerecloc[]. This fixes unexpected namerecloc filename
	  length restriction. ........ Merged revisions 365692 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_followme.c: * Fix accept/decline DTMF buffer
	  overwrite in FollowMe. * Made use MAX_YN_STRING define to make
	  all accept/decline DTMF buffers the same size. Just using 20
	  isn't good enough when someone didn't get the memo. * Fix stupid
	  use of a global variable in FollowMe. (ynlongest) * Fix bit field
	  declarations in FollowMe. ........ Merged revisions 365631 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-08 15:51 +0000 [r365575]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Send more accurate identification
	  information in dialog-info SIP NOTIFYs. This uses the calling
	  channel's caller ID and connected line information to populate
	  the remote and local identities in the dialog-info NOTIFY when an
	  extension is ringing. There is a bit of an oddity here, and that
	  is that we seed the remote target with the To header of the
	  outbound call rather than the from header. This is because it was
	  reported that seeding with the from header caused hints to be
	  broken with certain SNOM devices. A comment has been added to the
	  code to explain this. (closes issue ASTERISK-16735) reported by
	  Maciej Krajewski patches: local_remote_hint2.diff uploaded by
	  Mark Michelson (license #5049) 16735_tweak1.diff uploaded by Mark
	  Michelson (license #5049) Tested by Niccolo Belli ........ Merged
	  revisions 365574 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-07 18:43 +0000 [r365478]  Richard Mudgett <rmudgett@digium.com>

	* /, tests/test_config.c: Fix type punned compiler warning in
	  test_config.c ........ Merged revisions 365476 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-07 18:39 +0000 [r365475]  Matthew Jordan <mjordan@digium.com>

	* apps/app_voicemail.c, main/pbx.c, /: Support VoiceMail d() option
	  when extension does not exist in channel's context The VoiceMail
	  d([c]) option is documented to accept digits for a new extension
	  in context <c>, if played during the greeting. This option works
	  fine if the extension being redirected to has an extension with
	  the same initial digit in the channel's current context. If that
	  digit did not happen to exist in some extension, a dialplan match
	  would fail and the user would not be redirected. This patch fixes
	  it such that if the <c> option is used, the extensions are
	  matched in that context as opposed to the caller's original
	  context. (closes issue ASTERISK-18243) Reported by: mjordan
	  Tested by: mjordan Review:
	  https://reviewboard.asterisk.org/r/1892 ........ Merged revisions
	  365474 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-04 22:15 +0000 [r365399]  Kinsey Moore <kmoore@digium.com>

	* apps/app_voicemail.c, /, channels/chan_sip.c, funcs/func_aes.c,
	  main/features.c, apps/app_followme.c, channels/chan_iax2.c,
	  channels/sip/config_parser.c, pbx/pbx_config.c,
	  apps/app_chanspy.c, apps/app_stack.c, main/config.c: Fix many
	  issues from the NULL_RETURNS Coverity report Most of the changes
	  here are trivial NULL checks. There are a couple optimizations to
	  remove the need to check for NULL and outboundproxy parsing in
	  chan_sip.c was rewritten to avoid use of strtok. Additionally, a
	  bug was found and fixed with the parsing of outboundproxy when
	  "outboundproxy=," was set. (Closes issue ASTERISK-19654) ........
	  Merged revisions 365398 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-04 16:28 +0000 [r365320]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_local.c, /: Fix local channel chains optimizing
	  themselves out of a call. * Made chan_local.c:check_bridge()
	  check the return value of ast_channel_masquerade(). In long
	  chains of local channels, the masquerade occasionally fails to
	  get setup because there is another masquerade already setup on an
	  adjacent local channel in the chain. * Made the outgoing local
	  channel (the ;2 channel) flush one voice or video frame per
	  optimization attempt. * Made sure that the outgoing local channel
	  also does not have any frames in its queue before the masquerade.
	  * Made do the masquerade immediately to minimize the chance that
	  the outgoing channel queue does not get any new frames added and
	  thus unconditionally flushed. * Made block indication -1 (Stop
	  tones) event when the local channel is going to optimize itself
	  out. When the call is answered, a chain of local channels pass
	  down a -1 indication for each bridge. This blizzard of -1 events
	  really slows down the optimization process. (closes issue
	  ASTERISK-16711) Reported by: Alec Davis Tested by: rmudgett, Alec
	  Davis Review: https://reviewboard.asterisk.org/r/1894/ ........
	  Merged revisions 365313 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-04 15:51 +0000 [r365299]  Mark Michelson <mmichelson@digium.com>

	* res/res_rtp_asterisk.c, /: Fix core FINDING 2, FINDING 3, and
	  FINDING 4 from Coverity's CONSTANT_EXPRESSION_RESULT report.
	  These three all are in RTP code that attempts to print the number
	  of sequence number cycles in an RTCP RR report. The code was
	  masking out the upper 16 bits and then shifting the number right
	  by 16 bits. This led to an all zero result in all cases. The fix
	  is to do the shift without the bit masking. (issue
	  ASTERISK-19649) ........ Merged revisions 365298 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-05-03 15:01 +0000 [r365155-365160]  Alexandr Anikin <may@telecom-service.ru>

	* addons/ooh323c/src/ooh323.c, /,
	  addons/ooh323c/src/h323/H323-MESSAGES.h,
	  addons/ooh323c/src/h323/H323-MESSAGESEnc.c: Fix warning of
	  Coverity Static analysis, change H225ProtocolIdentifier from
	  value to pointer per functions that use this. (close issue
	  ASTERISK-19670) Reported by: Matt Jordan Patches:
	  ASTERISK-19670.patch (License #5415) ........ Merged revisions
	  365159 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* addons/ooh323c/src/ooq931.c, /: Fix coverity static analysis
	  warning, allocate full ie structure instead of without data
	  buffer (close issue ASTERISK-19674) Reported by: Matt Jordan
	  Patches: ASTERISK-19674.patch (License #5415) ........ Merged
	  revisions 365143 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2012-06-04  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.5.0 Released.

2012-05-30  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.5.0-rc2 Released.

	* Resolve crash in subscribing for MWI notifications.

	  ASTOBJ_UNREF sets the variable to NULL after unreffing it, so the
	  variable shoudl definitely not be used after that. To solve this in
	  the two cases that affect subscribing for MWI notifications, we
	  instead save the ref locally, and unref them in the error
	  conditions.
	  
	  (closes issue ASTERISK-19827)
	  Reported by: B. R.
	  Review: https://reviewboard.asterisk.org/r/1940/

	* Fix crash in ConfBridge when user announcement is played for more
	  than 2 users

	  A patch introduced in r354938 made it so that ConfBridge would not
	  attempt to play sound files if those files did not exist.
	  Unfortunately, ConfBridge uses the same underlying fucntion,
	  play_sound_helper, to playback both the sound files and numbers to
	  callers. When a number is being played back, the name of the sound
	  file is expected to be NULL. This NULL value was passed into a
	  function that tested for the existance of a sound file and is not
	  tolerant to NULL file names, causing a crash.

	  This patch fixes the behavior, such that if a sound file does not
	  exist we do not attempt to play it, but we only attempt that check
	  if the sound file was specified in the first place. If a sound file
	  was not specified, we use the 'play number' logic in the helper
	  function.

	  (closes issue ASTERISK-19899)
	  Reported by: Florian Gilcher
	  Tested by: Florian Gilcher
	  patches:
	    ASTERISK-19899.diff uploaded by mjordan (license 6283)

	* AST-2012-007

	* AST-2012-008

2012-05-03  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 10.5.0-rc1 Released.

2012-05-02 17:29 +0000 [r365083]  Terry Wilson <twilson@digium.com>

	* channels/chan_local.c, /, main/cel.c: Multiple revisions
	  365006,365068 ........ r365006 | twilson | 2012-05-02 10:49:03
	  -0500 (Wed, 02 May 2012) | 12 lines Fix a CEL LINKEDID_END race
